
#include "stdafx.h"
#include <commctrl.h>
#include <commdlg.h>
#ifndef _WIN32_WCE
  #include <shlobj.h>
#endif

#include "..\uelib2\uelib.h"
#include "ntpmain.h"
#include "resource.h"

#include "azdialog.h"

using namespace uelib;
using namespace ntpedit;

typedef DWORD   (*AZGETURIFILE2)(LPCTSTR, LPCTSTR, HWND);
typedef void    (*AZSETVALUE)(int);
typedef int     (*AZGETVALUE)();

extern AzDLDialog* dl;
extern AzDialog*   dd; // HTML parse i

//----------------------------------------------------------------
FARPROC Ntp::getProcAddress(HMODULE hModule, LPCTSTR lpProcName)
{
	FARPROC f;
#ifdef _WIN32_WCE
	// for CE
	f = ::GetProcAddress(hModule, lpProcName);
#else
	// for Win
	int len = _tcslen(lpProcName);
	char* p = new char[ len+1 ];
	::WideCharToMultiByte(CP_ACP, 0, lpProcName, -1,
		p, len+1, NULL, NULL);

	f = ::GetProcAddress(hModule, p);
	delete [] p;
#endif
	return f;
}

//----------------------------------------------------------------
void Ntp::initAZDialog(size_t size, DWORD id)
{
	if( dd!=NULL ) delete dd;
	dd = new AzDialog( size, 1024, id );
	dd->doModeless( getHwnd() );
	RECT r;
	::GetWindowRect( getHwnd(), &r );
#ifdef _WIN32_WCE
	int height = CommandBar_Height( _hwndCB );
#else
	int height = 0;
#endif
	dd->moveTo( r.right-200, height+1, r.right-22, height+26 );
	dd->show(); dd->update();
}

//------------------------------------------------------------------
void Ntp::sendLinkPos(bool bStart)
{
	//  link  PaintTool ɓo^B
	size_t lsize = _mlink.size();
	PaintTool& t = _e.getPaintTool();

	if( bStart ) t.clearSearch();

	map<LPARAM, String>::iterator itr    = _mlink.begin();
	map<LPARAM, String>::iterator itrEnd = _mlink.end();

    // vfׂĕ\
    for( ; itr != itrEnd ; ++itr )
	{
		// LPARAM==-1  hidden 
		if( itr->first==-1L )
		{ getFormHidden( itr->second ); continue; }

		size_t start = LOWORD(itr->first);
		size_t   end = HIWORD(itr->first);

		POINT pt1={0}, pt2={0};
		bool rc1 = count2pos(start, &pt1);
		bool rc2 = count2pos(end,   &pt2);

		if( !rc1 || !rc2 ) break;

		t.setSearch(&pt1, &pt2, itr->second);
	}

	// f[^cŏdȂ΂肾
	// xÂˁB
	_mlink.clear();
}

//------------------------------------------------------------------
bool Ntp::count2pos(size_t c, POINT* p)
{
	// ͈͊O false ԂB
	// ̕Asڂ̉ڂ
	// ̂Zo
	Doc& d = _e.getDoc();
	size_t strsize = d.getStringSize(), charsize=0;
	size_t i=0;
	while(1)
	{
		size_t size = d.getString(i).size();
		if( charsize+size >= c )
		{ p->y=i; p->x=c-charsize; return true; }
		else
//		{ charsize+=size+2; } //\r\n 𑫂
		{ charsize+=size+1; } //\n 𑫂
		if( i==strsize-1 ) break;
		i++;
	}
	return false;
}

//------------------------------------------------------------------
void Ntp::setCurrentURI( String& s )
{
	// http:// n܂ĂȂ
	// cdir ۑB
	// łȂȂ猻݂ cdir 
	// cdir ۑȂB

	// ܂ # 폜B
	size_t spos = s.find( _T('#') );
	if( spos != String::npos )
		s = s.substr( 0, spos );

	size_t pos = s.find( _T("://") );

	if( pos!=String::npos )
	{
		String sp = s.substr(0, pos);
		if( 0!=sp.compare( _T("http") ) &&
			0!=sp.compare( _T("https") ) &&
			0!=sp.compare( _T("file") ) )
			pos = String::npos;
	}

//	if( String::npos != s.find( _T("://") ) )
	if( pos != String::npos )
	{
		String sp = s.substr(0, s.find(_T("://"))+3 );

		// http:// ꍇ
		size_t p = s.find_last_of( _T('/') );
		_cdir = s.substr( 0, p+1 );
	}
	else
	{
		// Ȃꍇ

		// ../ A_cdir Kw
		size_t pos=0;
		while( String::npos!=(pos = s.find( _T("../")) ))
		{
			// _cdir  / ŏIĂ͂
			size_t spos = _cdir.find_last_of( _T('/'), _cdir.size()-2 );
			_cdir = _cdir.substr( 0, spos+1 );
			s = s.substr( 3, s.size()-3 );
		}
		if( s.empty() )
			s = _cdir;
		else if( s[0]==_T('/') )
			s = _cdir + s.substr( 1, s.size()-1 );
		else
			s = _cdir + s;
		size_t p = s.find_last_of( _T('/') );
		_cdir = s.substr( 0, p+1 );
	}
}

//------------------------------------------------------------------
bool Ntp::downloadFile(const String& s, size_t size)
{
	// s  URIB
	AZGETURIFILE2 ff = (AZGETURIFILE2)::GetProcAddress( _hDLL,
#ifdef _WIN32_WCE
		_T("AZGetURIFile2") );
#else
		"AZGetURIFile2" );
#endif
	if( !ff ) return false;

	bool viewflag = false;
	String fname;
	DWORD dwID;

	Ini ini(0);
	ini.open( _T("n12k2.ini") );
	int n = ini.readInt( _T("Azukimochi"),
		_T("ShowImage") );

	// gq jpg, jpe, jpeg, gif, png ŁAݒ肪 ON Ȃ
	// t@CɌ߂ă_E[hA
	// O viewer Ăяo
	size_t pos1 = s.find_last_of( _T('.') );
	size_t pos2 = s.find_last_of( _T('/') );
	String ext;
	if( pos1!=String::npos )
		ext = s.substr( pos1+1, s.size()-(pos1+1) );
	if( n==1 && (pos1<pos2 || 0==ext.compare( _T("jpg") )
		|| 0==ext.compare( _T("jpeg") )
		|| 0==ext.compare( _T("gif") ) ))
	{
		// _E[h
		TCHAR tmp[MAX_PATH+1];
		uelib::GetCurrentDirectory( MAX_PATH, tmp );
		fname = tmp;
		fname += _T("\\_");
		fname += s.substr( pos2+1, s.size()-(pos2+1));
		dwID = ff( s.c_str(), fname.c_str(),
			getHwnd() );
		if( dwID==-1 ) return false;

		// {[htO ON
		viewflag = true;
	}
	else
	{
		// t@C_E[h邩q˂
		TCHAR *tmp = new TCHAR [40+_tcslen(s.c_str())];
		wsprintf(tmp, 
			_T("t@C_E[h悤ƂĂ܂F\n%s\n")
			_T("_E[h܂H"), s.c_str() );
		int rc = ::MessageBox( getHwnd(), tmp,
			_T("n12k2 Azukimochi-mode"), MB_YESNO|MB_ICONINFORMATION );
		delete [] tmp;

		if( rc!=IDYES ) return false;

		// ǂɕۑ邩߂Ă
		TCHAR temp[MAX_PATH*2+1]={0};
		static TCHAR initDir[MAX_PATH*2+1]={0};
		size_t pos = s.find_last_of( _T('/') );
		wcscpy( temp, 
			s.substr(pos+1, s.size()-(pos+1)).c_str() );
		OPENFILENAME of={sizeof(OPENFILENAME)};
		of.hwndOwner       = getHwnd();
		of.lpstrInitialDir = initDir;
		of.lpstrFile       = temp;
		of.nMaxFile        = MAX_PATH*2;
		of.Flags           = OFN_OVERWRITEPROMPT;

		// t@C߂
		if(!::GetSaveFileName( &of ))
			return false;

		fname = of.lpstrFile;

		// _E[h
		dwID = ff( s.c_str(), fname.c_str(),
			getHwnd() );
		if( dwID==-1 ) return false;

		// i󋵃_CAOo
		if( dl!=NULL ) delete dl;
		dl = new AzDLDialog( size, 1024, dwID, 
			_hDLL, viewflag, fname );
		dl->doModeless( getHwnd() );
		RECT r;
		::GetWindowRect( getHwnd(), &r );
		dl->show(); dl->update();
	}
	return true;
}

//------------------------------------------------------------------
void Ntp::deleteImage()
{
	vector<String>::iterator    itr = _vimage.begin();
	vector<String>::iterator itrEnd = _vimage.end();

	for( ; itr!=itrEnd; ++itr )
		::DeleteFile( itr->c_str() );
}

//------------------------------------------------------------------
void Ntp::setEncode( UINT id )
{
	AZSETVALUE f = (AZSETVALUE)::GetProcAddress( _hDLL,
#ifdef _WIN32_WCE
		_T("AZSetCharset") );
#else
		"AZSetCharset" );
#endif
	if ( !f ) return;

	int code;
	switch( id )
	{
	case IDM_ENCODE_AUTO: 
		code = 0; break;
	case IDM_ENCODE_EUC:
		code = (int)uelib::EucJP; break;
	case IDM_ENCODE_JIS:
		code = IsoJP; break;
	case IDM_ENCODE_SJIS:
		code = SJIS; break;
	case IDM_ENCODE_UTF8:
		code = UTF8N; break;
	}

	f(code);
}

//------------------------------------------------------------------
int Ntp::createBookmarkMenu(TCHAR* dir, HMENU hMenu, int no)
{
	HANDLE h;
	WIN32_FIND_DATA fd;

	h = FindFirstFile( dir, &fd );

	if(h == INVALID_HANDLE_VALUE)
		return no;

	do {

		if(0==_tcscmp(fd.cFileName, _T(".")) ||
			0==_tcscmp(fd.cFileName, _T("..")) )
			continue;
		if( fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
		{
			TCHAR tmp[MAX_PATH*2];
			TCHAR dirtmp[MAX_PATH*2];
			_tcsncpy(dirtmp, dir, _tcslen(dir)-3);
			dirtmp[_tcslen(dir)-3]=_T('\0');
			_tcscpy(tmp, dirtmp);
			_tcscat(tmp, fd.cFileName);
			_tcscat(tmp, _T("\\*.*"));
			HMENU hMenuSub=CreatePopupMenu(); // Tuj[
			no = createBookmarkMenu(tmp, hMenuSub, no);
			AppendMenu(hMenu, MF_POPUP, (UINT)hMenuSub,
				fd.cFileName );
			continue;
		}

		// t@C烁j[
		String s = fd.cFileName;
		s = s.substr(0, s.size()-4);
		AppendMenu(hMenu, MF_STRING, ++no,
			s.c_str() );
		// map ɓo^邽߂
		// ΃fBNg ss ɍ쐬
		String ss = dir;
		ss = ss.substr(0, ss.size()-3);
		ss += s;
		_mbookmark.insert( pair<UINT,String>(no, ss) );
 
	} while (FindNextFile(h, &fd));	// ̃t@CT

	FindClose(h);
	return no;
}

//------------------------------------------------------------------
void Ntp::readURLFile(UINT id)
{
	// bookmark  map t@CE
	// URI 
	String s = _mbookmark[id];
	s += _T(".url");

	FileR f;
	if( !f.open( s.c_str() ) ) return;

	String sf = reinterpret_cast<const char*>(f.base());
	size_t pos = sf.find( _T("URL=") );
	if( pos != String::npos )
	{
		onOpenURI( sf.substr( pos+4, sf.size()-(pos+4)-2 ).c_str() );
	}
}

//------------------------------------------------------------------
void Ntp::addBookmark()
{
	// .url t@CāA
	// [InternetShortcut]
	// URL=http://`
	// Ƃt@CB

	// ܂t@C߂邽߂
	// _CAOo
	AzTxtDialog2 d( _T("^Cg߂Ă") );
	d.doModal( getHwnd() );

	if( d.endCode() != 1 ) return;

	// t@C擾
	String s = d.getText();
	s += _T(".url");

	// ΃fBNg擾ăt@C쐬
	TCHAR *t = new TCHAR[MAX_PATH*2+s.size()];
	getBookmarkDirectory( t );
	_tcscat( t, _T("\\") );
	_tcscat( t, s.c_str() );
	FileW f;
	if( !f.open( t, true ) )
	{ delete [] t; return; }

	// R{{bNX URI 擾
	int len = SendMessage( _hCombo, WM_GETTEXTLENGTH, 0, 0L );
	TCHAR* turi = new TCHAR[len+2];
	char*  uri  = new char[len+2];
	::GetWindowText( _hCombo, turi, len+1 );
	::WideCharToMultiByte(CP_ACP, 0, turi, -1, 
		uri, len+1, NULL, NULL);

	f.write( "[InternetShortcut]\r\nURL=", 24 );
	f.write( uri, len );
	f.write( "\r\n", 2 );

	delete [] t; delete [] uri;
}

//------------------------------------------------------------------
void Ntp::openBookmarkDir()
{
	STARTUPINFO         si={0};
	PROCESS_INFORMATION pi={0};
	TCHAR dir[MAX_PATH*2]={0};
	TCHAR commandLine[MAX_PATH*2]={0};

	getBookmarkDirectory( dir );
	wsprintf( commandLine, _T("explorer %s"),
		dir );

	::CreateProcess( NULL,
		commandLine, // R}hC
		NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);

	::CloseHandle(pi.hThread);
	::CloseHandle(pi.hProcess);
}

//------------------------------------------------------------------
void Ntp::getBookmarkDirectory(TCHAR* dir)
{
#ifdef _WIN32_WCE
//	_tcscpy( dir, _T("explorer \\Windows\\Cɓ") );
	_tcscpy( dir, _T("\\Windows\\Cɓ") );
#else
	// need IE4 or later.
//	::SHGetSpecialFolderPath( getHwnd(),
//		dir, CSIDL_FAVORITES, FALSE );
	LPITEMIDLIST pidl;
    IMalloc *pMalloc;

    ::SHGetMalloc( &pMalloc );
	if( NOERROR == ::SHGetSpecialFolderLocation( getHwnd(),
		CSIDL_FAVORITES, &pidl) )
	{
		// pXɕϊ
		::SHGetPathFromIDList( pidl, dir );
		// 擾IDL (CoTaskMemFreeł)
		pMalloc->Free( pidl );
	}
	pMalloc->Release();
#endif
}

