
#ifndef _NTP2DLG_H_
#define _NTP2DLG_H_

#include "..\uelib2\uelib.h"
#include "resource.h"

using namespace uelib;

//-----------------------------------------------------

class EncodeDlg : public Dialog
{
public:
	EncodeDlg(bool b);

public:
	int getSel(int n);
	static charset     getEncodeType(int i);
	static Txt::lbcode getLBType(int i);

private:
	void onInit();
	void onDestroy();
	bool onOK();
	bool onCancel();
//	bool onCommand( UINT cmd, UINT id, HWND ctrl );
//	bool onMessage( UINT msg, WPARAM wp, LPARAM lp );

private:
	void insert(int n, const TCHAR* c);
	void setSel(int n, int s);

private:
	//@{ R{{bNX̃nh //@}
	HWND _hCombo1, _hCombo2;
	//@{ t@CJƂ
	//   ̃_CAOgȂ true //@}
	bool _bOpen;
	//
	int  _sel1, _sel2;
};

//-----------------------------------------------------

EncodeDlg::EncodeDlg(bool open)
	:Dialog(IDD_ENCODE_DIALOG), _bOpen(open)
{}

void EncodeDlg::onInit()
{
	_hCombo1 = ::GetDlgItem(getHwnd(),IDC_COMBO1);
	_hCombo2 = ::GetDlgItem(getHwnd(),IDC_COMBO2);

	insert(1, _T("UTF32-BE(BOM)"));
	insert(1, _T("UTF32-LE(BOM)"));
	insert(1, _T("UTF16-BE(BOM)"));
	insert(1, _T("UTF16-LE(BOM)"));
	insert(1, _T("UTF8(BOM)"));
	insert(1, _T("UTF8"));
	insert(1, _T("UTF7"));
	insert(1, _T("ISO-2022-JP"));
	insert(1, _T("EUC-JP"));
	insert(1, _T("Shift-JIS"));

	insert(2, _T("CR+LF"));
	insert(2, _T("LF"));
	insert(2, _T("CR"));
	if( _bOpen )
		insert(1, _T("[]")),insert(2, _T("[]"));
	else
		insert(1, _T("[ύXȂ]")),insert(2, _T("[ύXȂ]"));
	setSel(1, 0); setSel(2, 0);
}

void EncodeDlg::onDestroy()
{
	Dialog::onDestroy();
}

bool EncodeDlg::onOK()
{
	_sel1 = ::SendMessage( _hCombo1,
		CB_GETCURSEL, 0, 0L );
	_sel2 = ::SendMessage( _hCombo2,
		CB_GETCURSEL, 0, 0L );
	return true;
}

bool EncodeDlg::onCancel()
{
	return true;
}

void EncodeDlg::insert(int n, const TCHAR* c)
{
	::SendMessage( n==1 ? _hCombo1 : _hCombo2,
		CB_INSERTSTRING, 0, (LPARAM)c );
}

int EncodeDlg::getSel(int n)
{
	return n==1 ? _sel1 : _sel2;
}

void EncodeDlg::setSel(int n, int s)
{
	::SendMessage( n==1 ? _hCombo1 : _hCombo2,
		CB_SETCURSEL, s, 0L );
}

charset EncodeDlg::getEncodeType(int cs)
{
	switch(cs)
	{
	case 1:  return SJIS;
	case 2:  return EucJP;
	case 3:  return IsoJP;
	case 4:  return UTF7;
	case 5:  return UTF8N;
	case 6:  return UTF8;
	case 7:  return UTF16l;
	case 8:  return UTF16b;
	case 9:  return UTF32l;
	case 10: return UTF32b;
	default: return SJIS;
	}
}

Txt::lbcode EncodeDlg::getLBType(int lb)
{
	switch(lb)
	{
	case 1:  return Txt::CR;
	case 2:  return Txt::LF;
	case 3:  return Txt::CRLF;
	default: return Txt::CRLF;
	}
}

//-----------------------------------------------------
class JumpDlg : public Dialog
{
public:
	JumpDlg(int max);

public:
	int getPos();

private:
	void onInit();
	void onDestroy();
	bool onOK();
	bool onCancel();
//	bool onCommand( UINT cmd, UINT id, HWND ctrl );
//	bool onMessage( UINT msg, WPARAM wp, LPARAM lp );

private:
	int _max;
	int _pos;
};

//-----------------------------------------------------
JumpDlg::JumpDlg(int max)
	:Dialog(IDD_JUMP_DIALOG), _max(max), _pos(0)
{}

void JumpDlg::onInit()
{
	HWND hSpin = ::GetDlgItem( getHwnd(), IDC_SPIN1 );
	HWND hEdit = ::GetDlgItem( getHwnd(), IDC_EDIT1 );

	::SendMessage( hSpin, UDM_SETBUDDY, (WPARAM)hEdit, 0L );
	::SendMessage( hSpin, UDM_SETRANGE32, 0, (LPARAM)_max );
	::SendMessage( hSpin, UDM_SETPOS,     0, (LPARAM)MAKELONG(1,0) );
}

void JumpDlg::onDestroy()
{
	Dialog::onDestroy();
}

bool JumpDlg::onOK()
{
	HWND hSpin = ::GetDlgItem( getHwnd(), IDC_SPIN1 );
	_pos = ::SendMessage( hSpin, UDM_GETPOS, 0, 0L );
	return true;
}

bool JumpDlg::onCancel()
{
	return true;
}

int JumpDlg::getPos()
{
	return _pos;
}

#endif // _NTP2DLG_H_

