

#include "ntpedit.h"

#include "caret.h"

using namespace ntpedit;

//--------------------------------------------------
// caret.cpp
// Caret NX̃\bĥA
// Cxgnhn͂B
//--------------------------------------------------

//-----------------------------------------------------------------
void Caret::onPaint()
{
	POINT pt;
	::GetCaretPos(&pt);

	RECT r = {pt.x, pt.y, pt.x+2, pt.y+_height};

	HBRUSH hBrush = ::CreateSolidBrush( _tool.getColor(PaintTool::BG) );
	::FillRect( _tool.getDC(), &r, hBrush );
	::DeleteObject( hBrush );
}

//-----------------------------------------------------------------
int Caret::onKeyDown( int code, int hscroll )
{
	// code = VK_RIGHT:VK_LEFT:VK_DOWN:VK_UP:
	// ɃXN[Ȃ SB_LINEUP,
	// ɃXN[Ȃ SB_LINEDOWN ԂB
	int retcode = 0xFFFF; // gĂȂȒl
						  // Ƃ肠Ă

	if( code==0x10 )
	{
		// ͈͑I ON
		_shift = true;
	}

	// #84 ASB
	POINT oldp={_dX,_dY}, p;

	// V΍s擾
	switch( code )
	{
	case VK_UP:
		moveUp(&oldp,&p);    break;
	case VK_DOWN:
		moveDown(&oldp,&p);  break;
	case VK_LEFT:
		moveLeft(&oldp,&p);  break;
	case VK_RIGHT:
		moveRight(&oldp,&p); break;
	default:
		p.x=_dX, p.y=_dY;    break;
	}

	// ΍sAVȍW߂
	POINT pt = getNewXY(oldp, p, hscroll, &retcode);
	_dX = p.x, _dY = p.y;

	// ړ
	setPos(pt.x, pt.y);


	// ShiftĂ΁A͈͑IGo
	if( _shift )
	{
		bool updated=false;
		POINT p0={_dX,_dY}, p1, p2;
		_tool.getSel(&p1, &p2);

		if( p1.y==-1 || p0.y < p1.y || ( p0.y==p1.y && p0.x < p1.x ))
			_tool.setSel(&p0, NULL), updated=true;
		if( p2.y==-1 || p0.y > p1.y || ( p0.y==p1.y && p0.x > p1.x ))
			_tool.setSel(NULL, &p0), updated=true;
		if( updated )
			::InvalidateRect( _vwnd, NULL, FALSE );
	}
	else
	{
		// _shift  false ŁA͈͑IĂ clear
		POINT p1, p2;
		_tool.getSel(&p1,&p2);
		if( p1.y!=-1 ) 
			_tool.clearSel(),
			::InvalidateRect( _vwnd, NULL, FALSE );
	}

#ifdef _DEBUG
	TCHAR temp[64];
	wsprintf(temp, _T("code=%x, _dX=%d, _dY=%d (x=%d, y=%d)\n"),
		code, _dX, _dY, pt.x, pt.y);
	OutputDebugString(temp);
#endif

	return retcode;
}

//-----------------------------------------------------------------
void Caret::onKeyDown2(int code, int startpos)
{
	// onKeyDown 債̂
	// HOME  END ɏƂɁB
	// v́Ajump 邾Ȃ킯ŁB
	int x;
	if( code==VK_HOME )
		x = 0;
	else if( code==VK_END )
		x = _doc.getString( _dY ).size();

	jump( x, _dY+1, startpos );
}

//-----------------------------------------------------------------
void Caret::onKeyUp(int code)
{
	_shift = false, _drag = false;
}

//-----------------------------------------------------------------
void Caret::onSetFocus()
{
	create(_height); show();
	setPos( _pt.x, _pt.y );
}

void Caret::onKillFocus()
{
	hide(); destroy();
}

void Caret::onVScroll(int y)
{
	// y ɂ Scroll ̈ړʂĂB
	// ̒lƂɁA艺B
	if( y==0 ) return;

	// ǂ̍śA܂Ԃ̉sڂɂ邩߂B
	UINT starty = _dY;
	const LineInfo& f = _tool.getLineInfo( starty );
	const size_t size = _doc.getString(starty).size();
	UINT startx = 0;
	for( UINT i=0; i<f.wrapsize(); i++ )
	{
		size_t start = i==0              ? 0    : f[i];
		size_t   end = i==f.wrapsize()-1 ? f[i] : size;
		if( _dX >= start && _dX <= end )
		{ startx = i; break; }
	}

	// LINEDOWN, etc
	if( y>0 )
	{
		// ΍s
		if( (UINT)y <= f.wrapsize() - startx )
		{
			size_t fpos = startx==0   ? 0 : f[startx-1];
			size_t fpos2= startx+y==0 ? 0 : f[startx+y-1];
			_dX = _dX - fpos + fpos2;
//			return;
		}
		else
		{
			// Ⴄs
			for( UINT ypos=starty+1, ysize=f.wrapsize()-startx+1;
				ypos<_doc.getStringSize(); ypos++ )
			{
				const LineInfo& f2 = _tool.getLineInfo( ypos );
				size_t ws = f2.wrapsize();
				if( (UINT)y <= ysize + ws )
				{
					// ̍s
					_dY = ypos;
					size_t fpos  = startx==0  ? 0 : f[startx-1];
					size_t f2pos = y-ysize==0 ? 0 : f2[y-ysize-1];
					_dX = _dX - fpos + f2pos;
//					return;
					break;
				}
				ysize += ws+1;
			}
		}
	}
	// LINEUP, etc	
	else
	{
		if( (int)(startx + y) >= 0 )
		{
			// ΍s
			size_t fpos = startx==0   ? 0 : f[startx-1];
			size_t fpos2= startx+y==0 ? 0 : f[startx+y-1];
			_dX = _dX - fpos + fpos2;
//			return;
		}
		else
		{
			// Ⴄs
			for( UINT ypos=starty-1, ysize=0; //f.wrapsize()-startx+1;
				(int)ypos>=0; ypos-- )
			{
				const LineInfo& f2 = _tool.getLineInfo( ypos );
				size_t ws = f2.wrapsize();
				if( 0 <= (int)(ysize + ws + 1 + y) )
				{
					// ̍s
					_dY = ypos;
					size_t fpos  = startx==0  ? 0 : f[startx-1];
					size_t f2pos = ysize+ws+1+y==0 ? 0 : 
						f2[ws+ysize+y];
					_dX = _dX - fpos + f2pos;
//					return;
					break;
				}
				ysize += ws+1;
			}
		}

	}
	
	// 덇킹H
	correctPos();

/*
#ifdef _DEBUG
	TCHAR temp[64];
	wsprintf(temp, _T("_dX=%d, _dY=%d\n"),
		_dX, _dY);
	OutputDebugString(temp);
#endif
*/
}

//-----------------------------------------------------------------
void Caret::onLButtonDown( WORD dx, WORD dy, int vpos, int hpos )
{
	_drag = true;

	// tH[JXĂ
	if( !_alive ) onSetFocus();

	// ͈͑IĂA܂ł̕`
	// Kv
	POINT p1, p2;
	_tool.getSel(&p1,&p2);

	if( p1.y != -1 )
	{
		// ܂ł̑I͈͂NA
		_tool.clearSel();

		// NAĕ`悪KvȋC
		::InvalidateRect(_vwnd, NULL, FALSE);
	}

	setPosByMouse( dx, dy, vpos, hpos );
/*
#ifdef _DEBUG
	TCHAR temp[64];
	wsprintf(temp, _T("_dX=%d, _dY=%d\n"),
		_dX, _dY);
	OutputDebugString(temp);
#endif
*/
}

//-----------------------------------------------------------------
void Caret::onLButtonUp( WORD dx, WORD dy, int vpos )
{
	_drag = false;
	_shift= false;
}

//-----------------------------------------------------------------
void Caret::onMouseMove( WORD dx, WORD dy, int vpos, int hpos )
{
	if( !_drag ) return;

	RECT r;
	_tool.getTextAreaRect(&r);
	if( dx < r.left ) return;

	bool updated=false;
	POINT p0 = getVPos(dx, dy, vpos, hpos);

	POINT p1, p2;
	_tool.getSel(&p1, &p2);

	if( p1.y==-1 || p0.y < p1.y || ( p0.y==p1.y && p0.x < p1.x ))
		_tool.setSel(&p0, NULL), updated=true;
	if( p2.y==-1 || p0.y > p1.y || ( p0.y==p1.y && p0.x > p1.x ))
		_tool.setSel(NULL, &p0), updated=true;

	// p1 p2 Ȃ炱 clear?

	setPosByMouse(dx, dy, vpos, hpos);

	if( updated )
	{
		// Ïw肾ōςށH
		::InvalidateRect(_vwnd, NULL, FALSE);
	}
/*
#ifdef _DEBUG
	if( updated ){
		_tool.getSel(&p1, &p2);
		TCHAR temp[64];
		wsprintf(temp, _T("p1.x=%d, p1.y=%d p2.x=%d, p2.y=%d\n"),
			p1.x, p1.y, p2.x, p2.y);
		OutputDebugString(temp);
	}
#endif
*/
}

//-----------------------------------------------------------------
void Caret::onChar( TCHAR ch )
{
	POINT p   ={_dX,_dY};
	TCHAR t[2]={ch,0};
	String s = t;
	bool bDrawAll = false; // S`悷邩ǂ̃tO

	// ǎp當ύXłȂ
	if( _tool.getReadOnly() ) return;
	// ESC L[ɂ͔Ȃ
	if( ch==VK_ESCAPE ) return;

	POINT pt; ::GetCaretPos(&pt);
	RECT r;   _tool.getLineNumRect( &r );
	int lw  = _tool.getFontHeight() + _tool.getLineSpace();
	size_t pre_wrap;
	{
	const LineInfo& info = _tool.getLineInfo( _dY );
	pre_wrap = info.wrapsize();
	}

	// ͈͑IĂ邩
	POINT p1, p2;
	_tool.getSel(&p1, &p2);

	// VK_DELETE == '.' ?
//	if( ch==VK_BACK || ch==VK_DELETE )
	if( ch==VK_BACK )
	{
		// 擪 BS ĂȂɂȂ
		if( ch==VK_BACK && p1.y==-1 && _dX==0 && _dY==0 ) return;

		// N_߂
		POINT ps;
		if( ch==VK_BACK )
			ps.x = p.x==0 ? 0 : p.x-1, ps.y = p.y;
		else
			ps.x = p.x, ps.y = p.y;

		// ͈͑IĂ炻ɒu
		if( p1.y != -1 )
		{
			if( p1.y!=p2.y || p1.x!=p2.x )
				ps=p1, p=p2;
			else
				p1.y=-1; // Ƃł̒lĝŏ
			_tool.clearSel();
		}

		if( ps.y != 0 && p.x==0 )
			ps.y--, ps.x = _doc.getString(ps.y).size();
//			,p.x = _doc.getString(p.y).size();

		if( p.x==0 )
//			::SendMessage( _vwnd, WM_KEYDOWN, VK_LEFT, 0L );
			::SendMessage( _vwnd, WM_KEYDOWN, VK_UP, 0L );

		// Command  Doc Ŏs
		_doc.exec( new Remove(ps,p) );

		// LineInfo XV
		if( ps.y != p.y )
			_tool.updateWrapInfo(), bDrawAll=true;
		else
			bDrawAll = _tool.updateWrapInfoPartial( ps.y, 1, 
				p.x==0 ? true : false );

		// BS  wrapsize ςA
		// Caret ɓKv
		if( pre_wrap != 0 )
		{
			const LineInfo& info = _tool.getLineInfo( _dY );
			if( ps.y==p.y && pre_wrap != info.wrapsize() )
				_pt.y -= lw*(pre_wrap-info.wrapsize());
		}

		// Lbg𓮂
		// AA͈͑IĂ
		// 킹邾ł
		if( p.x==0 )
			;
		else if( _dX>=_doc.getString(ps.y).size() || p1.y!=-1 )
			correctPos();
		else
			::SendMessage( _vwnd, WM_KEYDOWN, VK_LEFT, 0L );
	}
	else
	{
		// ͈͑IĂ Replace
		// Command  Doc ŎsB
		POINT p1, p2;
		_tool.getSel(&p1, &p2);
		_tool.clearSel();
		if( p1.y==-1 || ( p1.y==p2.y && p1.x==p2.x ) )
			_doc.exec( new Insert(p,s) );
		else
			_doc.exec( new Replace(p1,p2,s) );

		// LineInfo XV
		bDrawAll = _tool.updateWrapInfoPartial( p.y, 
							ch==_T('\r') ? 2 : 1 );

		if( ch==VK_RETURN )
		{
			// ̍s̐擪
			// Aԉ̍sȂ Y ɈړȂB
			// (ԉ̍sALbg͈ړ
			//  XN[ق̂B)
			RECT tr;
			_tool.getTextAreaRect(&tr);
			
//			_dX=0; _dY++;
//			if( tr.bottom < pt.y+lw )   // XN[o[Ƃp
			if( tr.bottom < pt.y+lw*2 ) // XN[o[ȂƂp
			{
				_dX=0;
				setPos(r.right, pt.y),
				::PostMessage( _vwnd, WM_VSCROLL, SB_LINEDOWN, 0L);
				return;
			}
			else
			{
				_dX=0; _dY++;
				setPos(r.right, pt.y+lw);
				bDrawAll = true;
			}
		}
		else
		{
			const LineInfo& info = _tool.getLineInfo( _dY );
			int y=0;
			for( size_t i=0; i<info.wrapsize(); i++ )
			{
				size_t inf_n = info[i];
				if( _dX==(UINT)inf_n-1 ) y=-1, bDrawAll=true;
				else if( _dX==(UINT)inf_n+1 ) y=1;
			}

#ifdef _DEBUG
		TCHAR tmp[256], tmp2[32];
		_tcscpy( tmp, _T("info[n] -> ") );
		for( size_t j=0; j<info.wrapsize(); j++ )
		{
			wsprintf(tmp2, _T("%d "), info[j] );
			_tcscat(tmp, tmp2);
		}
		_tcscat(tmp, _T("\n"));
		OutputDebugString(tmp);
#endif
			// ͈͑IĂāALbgI[ʒuȂ
			// EɓKv͂Ȃ
			// (Aꂪ͈͑Iłꍇ)
			if( !(p1.y==p2.y && p1.x==p2.x) && 
				p2.y==p.y && p2.x==p.x )
				correctPos();
			else
				::SendMessage( _vwnd, WM_KEYDOWN, VK_RIGHT, 0L );

			// ʂ͂̕ȂALbg͉EɈړ邾
			// Awrapsize XVꂽ牺ɈړKv
			// (ႤBwrapsize XVꊎLbgsɂƂ̂)
			if( y!=0 )
			{
				_pt.y += lw*y;
				setPos( _pt.x, _pt.y );
			}

		}
	}

	// ĕ`
	if( _dY > (UINT)_tool.getTotalLines() )
	{
		// ̍s݂͑Ȃ̂ŁA
		// o邾ođS`
		correctPos();
		::InvalidateRect( _vwnd, NULL, FALSE );
	}
	else
	{
		const LineInfo& info = _tool.getLineInfo( _dY );
		if( bDrawAll || pre_wrap != info.wrapsize() )
			// ܂ԂςĂA
			// 낪ŜőS`
			::InvalidateRect( _vwnd, NULL, FALSE );
		else
			// sĕ`
			invalidateLineRect(pre_wrap);
	}
}

//-----------------------------------------------------------------
void Caret::onIMEComposition(LPARAM lp)
{
	TCHAR* buf;
	POINT p   ={_dX,_dY};
	size_t pre_wrap;
	{
	const LineInfo& info = _tool.getLineInfo( _dY );
	pre_wrap = info.wrapsize();
	}

	// IME ɂ镶́B
	// ꕶÂĂ͕`悪x̂ŁA
	// m肳ꂽƂɕƂĈxɕ`悷B
	HIMC hImc = ::ImmGetContext(_vwnd);

	int len  = ::ImmGetCompositionStringW(hImc, GCS_RESULTSTR, NULL, 0);
	int tlen = len/sizeof(TCHAR);
	buf = new TCHAR[tlen+1];
	::ImmGetCompositionStringW(hImc, GCS_RESULTSTR, buf, len);
	buf[tlen] = _T('\0');
	String s = buf;
	delete [] buf;

	// ͈͑IĂ Replace
	POINT p1, p2;
	_tool.getSel(&p1, &p2); _tool.clearSel();
	if( p1.y==-1 || ( p1.y==p2.y && p1.x==p2.x ) )
		_doc.exec( new Insert(p,s) );
	else
		_doc.exec( new Replace(p1,p2,s) );

	_tool.updateWrapInfoPartial(_dY, 1);

	for( size_t i=0; i<s.size(); i++ )
		::SendMessage( _vwnd, WM_KEYDOWN, VK_RIGHT, 0L );

	// ĕ`
	const LineInfo& info = _tool.getLineInfo( _dY );
	if( pre_wrap != info.wrapsize() )
		::InvalidateRect( _vwnd, NULL, FALSE );
	else
		invalidateLineRect(pre_wrap);
}

//-----------------------------------------------------------------
void Caret::onIMENotify(WPARAM wp)
{
#ifndef _WIN32_WCE
	// IME  on/off ŐFςM~bNB
	// CE ƎgȂ̂߂B
	if( wp!=IMN_SETOPENSTATUS ) return;

	static bool on=false;

//	COLORREF c = on==true ? RGB(255,255,255) : RGB(255,255,0);
	COLORREF c = on==true ? RGB(0,0,0) : RGB(0,255,255); // skyblue
//	COLORREF c = on==true ? RGB(255,255,255) : RGB(0,0,255); // blue

	hide(); destroy();
	create(_height, c); show();

	on = !on;
#endif
}

//-----------------------------------------------------------------
void Caret::onMouseWheel(short hi, short lo)
{
	// ĂƁ[ɁA3 sÂړB
	const int WHEEL_DELTA = 120;

	int code = hi > 0 ? SB_LINEUP : SB_LINEDOWN;

	for( int i=0; i<3; i++ )
		::SendMessage( _vwnd, WM_VSCROLL,
			MAKEWPARAM(code, 0), 0L );

	correctPos();
}

