
#ifndef _NTPEDIT_CARET_H_
#define _NTPEDIT_CARET_H_

#include "doc.h"
//#include "painter.h"
#include "painttool.h"

namespace ntpedit{

//@{
//  LbgB
//@}
class Caret
{
public:
	Caret( Doc& d, PaintTool& t, HWND h );
	~Caret();

public:
	//@{ EŁEړ //@}
	void create( int height, COLORREF rgb=0 );
	void destroy();
	void hide();
	void show();
	void reset();
	void changeHeight( int height );
	void setPos( int x, int y );
	void setPosByMouse(WORD dx, WORD dy, int vpos, int hpos);
	//@{ 날킹̂߂̈ړ //@}
	void correctPos();
	//@{ AhDEhD //@}
	void undo();
	void redo();
	//@{ Nbv{[h //@}
	void cut();
	void copy(bool bClearSel=true);
	void paste();
	//@{ ׂđI //@}
	void selectAll();
	//@{ Wv //@}
	void jump(UINT x, UINT y, int startpos);
	//@{ ` //@}
	void invalidateLineRect(int wrapsize);
	void invalidateBottomRect();
	//@{ ΍sʒu擾 //@}
	const POINT getAbsPoint();
	//@{ onKeyDown p낢 //@}
	void moveUp(const POINT* po, POINT* pn);
	void moveDown(const POINT* po, POINT* pn);
	void moveLeft(const POINT* po, POINT* pn);
	void moveRight(const POINT* po, POINT* pn);
	POINT getNewXY(const POINT po, const POINT pn,
		int hscroll, int *flag);
	int  getCurrentWrapLine(const POINT p);

public:
	//@{ Cxgnh //@}
	void onPaint();
	int  onKeyDown( int code, int hscroll );
	void onKeyDown2( int code, int startpos );
	void onKeyUp( int code );
	void onSetFocus();
	void onKillFocus();
	void onLButtonDown(WORD x, WORD y, int vpos, int hpos);
	void onLButtonUp(WORD x, WORD y, int vpos);
	void onMouseMove(WORD x, WORD y, int vpos, int hpos);
	void onVScroll(int y);
	void onChar( TCHAR ch );
	void onIMEComposition(LPARAM lp);
	void onIMENotify(WPARAM wp);
	void onMouseWheel(short hi, short lo);

private:
	//@{ WƃX^[gʒu
	//   ΍s+ʒu𓾂 //@}
	const POINT getVPos(WORD x, WORD y, int vpos, int hpos);
	UINT        getWrapPos( UINT x, UINT y );

private:
	Doc& _doc;
	PaintTool& _tool;
	HWND       _vwnd;
	//@{ hLg̍sIΈʒu //@}
	UINT       _dX, _dY;
	//@{ WBĐȂǂɕKvB //@}
	POINT      _pt;
	//@{ Lbg̍ //@}
	int _height;
	//@{ LbgĂ邩 //@}
	bool _alive;
	//@{ }EX/L[{[hɂ͈͑ION //@}
	bool _shift, _drag;
	//@{ CreateDIBSection pB //@}
	HBITMAP _hBitmap;
};

//-----------------------------------------
inline Caret::Caret(Doc& d, PaintTool& t, HWND h)
	:_doc(d), _tool(t), _vwnd(h)
	,_dX(0), _dY(0)
	,_height(0)
	, _alive(false) ,_shift(false), _drag(false)
{ _pt.x=0, _pt.y=0; }

inline Caret::~Caret()
	{ destroy(), _alive=false; }

inline void Caret::show()
	{ ::ShowCaret(_vwnd); }

inline void Caret::hide()
	{ ::HideCaret(_vwnd); }

inline const POINT Caret::getAbsPoint()
	{ const POINT p={_dX,_dY}; return p; }

//-----------------------------------------

//@{
// XN[o[B
//@}
class Scroll
{
public:
	Scroll(PaintTool& t, HWND h);

public:
	//@{ Cxgnh //@}
	int  onVScroll( short code, short pos );
	void onHScroll( short code );
	void onSize( int vlines, int vtotal, int hlines=0, int htotal=0 );
	void onKeyDown( int code );

public:
	//@{ ̑̊֐ //@}
	void setV();
	void setH();
	void update();
	int  getVStartPos();
	int  getHScrollSize();
	void reset();

private:
	PaintTool& _tool;
	//@{ View  hwnd //@}
	HWND _vwnd;
	//@{ Jnʒu //@}
	int  _x, _y;
	SCROLLINFO _siv, _sih;
};

//-------------------------------------------------
inline int Scroll::getVStartPos()
	{ return _y; }

inline int Scroll::getHScrollSize()
	{ return _x; }

inline void Scroll::setV()
	{ ::SetScrollInfo( _vwnd, SB_VERT, &_siv, TRUE ); }

inline void Scroll::setH()
	{ ::SetScrollInfo( _vwnd, SB_HORZ, &_sih, TRUE ); }

} //namespace ntpedit;
#endif

