
#include "ntpedit.h"

#include "caret.h"

using namespace ntpedit;

//--------------------------------------------------
// caret2.cpp
// Caret NX̃\bĥA
// CxgnhȊÔ̂͂B
//--------------------------------------------------
void Caret::create(int height, COLORREF rgb)
{
	// LbgB
	if( _alive ) return;
	if( height==0 ) return;

	// FtLbg̉B
	BITMAPINFO bmi={0};
	bmi.bmiHeader.biSize       = sizeof(BITMAPINFOHEADER);
	bmi.bmiHeader.biWidth      = 2;
	bmi.bmiHeader.biHeight     = height;
	bmi.bmiHeader.biPlanes     = 1;
	bmi.bmiHeader.biBitCount   = 24;
	bmi.bmiHeader.biCompression= BI_RGB;

	LPBYTE pBits;
	_hBitmap = ::CreateDIBSection( _tool.getDC(), &bmi,
		DIB_RGB_COLORS, (void**)&pBits, NULL, 0 );
	// 0x00bbggrr 
	UCHAR r =  (rgb&0xFF),
		  g =  (rgb&0xFF00)>>8, 
		  b =  (rgb&0xFF0000)>>16;

	// wiƐFςႤłǁ[
	// łΏ̎d킩Ȃłǁ[
	// Aȃrbg肵Ă邱Ǝ̂B
	UCHAR r2 = r|(~b), b2 = b|(~r);
	r = r2, b = b2, g=~g;
	// wiȂ甽]H
	COLORREF c = _tool.getColor( PaintTool::BG );
	if( c==0x0 && c!=rgb ) r=~r, g=~g, b=~b;

	for(int i=0; i<height; i++ )
	{
		pBits[8*i]  =r,pBits[8*i+1]=g,pBits[8*i+2]=b;
		pBits[8*i+3]=r,pBits[8*i+4]=g,pBits[8*i+5]=b;
		pBits[8*i+6]=0,pBits[8*i+7]=0;
	}

#ifndef _WIN32_WCE
	BOOL rc = ::CreateCaret(_vwnd, _hBitmap, 2, height);
#else
	BOOL rc = ::CreateCaret(_vwnd, NULL, 2, height);
#endif
	//

	_height = height;

	// IMEݒ
	HIMC ime = ::ImmGetContext( _vwnd );
	LOGFONT& f = _tool.getFont();
	::ImmSetCompositionFont( ime, &f );
	::ImmReleaseContext( _vwnd, ime );

	if( rc ) _alive = true;
}

//------------------------------------------------------------
void Caret::destroy()
{
	// LbgŁB
	if( !_alive ) return;
	BOOL rc = ::DestroyCaret();
	::DeleteObject( _hBitmap );
	if( rc ) _alive = false;
}

//------------------------------------------------------------
void Caret::changeHeight(int height)
{
	// Lbg̍ύXB
	hide(); destroy(); create(height);
	show();
}

//------------------------------------------------------------
void Caret::setPos(int x, int y)
{
	// LbgړB
	RECT r;
	_tool.getTextAreaRect(&r);

	if( x < r.left ) return;

	// caret 
	::SetCaretPos(x, y);
	_pt.x = x, _pt.y = y;

	// IME
	// GreenPad ̂҂؁`
	COMPOSITIONFORM cf;
	cf.dwStyle = CFS_POINT;
	cf.ptCurrentPos.x = x;
	cf.ptCurrentPos.y = y;
	HIMC ime = ::ImmGetContext( _vwnd );
	::ImmSetCompositionWindow( ime, &cf );
	::ImmReleaseContext( _vwnd, ime );
}

//------------------------------------------------------------
void Caret::reset()
{
	_dX = _dY = 0;

	RECT r;
	_tool.getTextAreaRect(&r);
	setPos(r.left, 0);
}

//------------------------------------------------------------
void Caret::correctPos()
{
	// OB덇킹B

	POINT pt=_pt; //::GetCaretPos(&pt);
	RECT r;   _tool.getLineNumRect( &r );

	// ݂ȂsɂAɓB
	if( _dY >= _doc.getStringSize() )
	{
		int lw = _tool.getFontHeight() + _tool.getLineSpace();
		pt.y -= lw*(_dY - _doc.getStringSize()+1);
		_dY = _doc.getStringSize()-1;
		_dX = 0;
		setPos(r.right, pt.y);
		return;
	}

	// sAЂƂOɐiށB
	LineInfo& inf = _tool.getLineInfo( _dY );
	String      s = _doc.getString( _dY ).c_str();
	size_t     ws = inf.wrapsize();

	if( _dX > s.size() )
	{
		_dX = s.size(); // _dY ͐u

		// _dX ܂Ԃ̉sڂɂׂ̂
		size_t begin = ws==0 ? 0 : inf[ws-1];
		size_t   end = s.size();
		String    ss = s.substr(begin, end-begin);

		int x = _tool.getStringWidth(ss, _dX-begin);
		setPos(x+r.right, pt.y);
	}
}

//------------------------------------------------------------
void Caret::setPosByMouse(WORD dx, WORD dy, int vpos, int hpos)
{
	// W(dx,dy)΍sɕϊāA
	// ɂӂ킵WւƕϊB
	RECT r;
	_tool.getTextAreaRect(&r);

	// sԍGAȂƂ肠
	if( dx < r.left ) return;

	// ΍s
	POINT p = getVPos(dx, dy, vpos, hpos);

	// ssKȂړȂ
	if( p.y==-1 ) return;

	_dX = p.x, _dY = p.y;

	// pt.y ̈ʒu킹̂
	UINT yy = dy%(_tool.getFontHeight()+_tool.getLineSpace());
	POINT pt = {0, dy-yy};

	// ړ
	// ܂W߂ɂȂ񥥥
	const String& s = _doc.getString( p.y );
	LineInfo&   inf = _tool.getLineInfo( p.y );
	size_t begin=0, end=s.w_str().size();
	for( size_t i=0; i<=inf.wrapsize(); i++ )
	{
		begin = i==0              ?                0 : inf[i-1];
		end   = i==inf.wrapsize() ? s.w_str().size() : inf[i];
		if( begin < (size_t)p.x && (size_t)p.x < end )
			break;
	}

	pt.x = _tool.getStringWidth( s.substr(begin, end-begin),
								p.x-begin );
	pt.x += r.left - hpos;
/*
#ifdef _DEBUG
	TCHAR temp[64];
	wsprintf(temp, _T("pt.x=%d, pt.y=%d, begin=%d, end=%d\n"),
		pt.x, pt.y, begin, end);
	OutputDebugString(temp);
//	OutputDebugStringW(s.substr(begin, end).w_str().c_str());
#endif
*/
	setPos(pt.x, pt.y);
}

//------------------------------------------------------------
const POINT Caret::getVPos(WORD dx, WORD dy, int vpos, int hpos)
{
	// W(dx,dy)΍sɕϊB
	POINT p;
	UINT yy = dy / 
		(_tool.getFontHeight()+_tool.getLineSpace());
	RECT r;
	_tool.getTextAreaRect(&r);
	UINT x = dx - r.left;

	// y ߂
	// vpos ͐΍sł͂Ȃ
	// X^[gʒu vpos 猈߂
	UINT startStr=0, startLine=0;
	size_t size = _doc.getStringSize();
	for( UINT k=0, j=0; k<(UINT)vpos+yy, k<size; k++)
	{
		const LineInfo& f = _tool.getLineInfo(k);
		// k + wrapsize sB
		if( (UINT)vpos+yy <= j + f.wrapsize() )
		{
			startLine = vpos+yy - j;
			break;
		}else{
			j += f.wrapsize() + 1;
			startStr++;
		}
	}
	p.y = startStr;
	if( size <= startStr )
	{ p.y = -1; return p; }

	// x ߂
	const String&     s = _doc.getString( p.y );
	LineInfo&       inf = _tool.getLineInfo( p.y );
	UINT          wsize = inf.wrapsize();

	// n[ƏI[߂
	size_t begin = startLine==0 ?
		0 : inf[startLine-1];
	size_t end   = startLine==wsize ?
		s.w_str().size() : inf[startLine];

	// ؂
	const String ss = s.substr(begin, end-begin).c_str();

	// ̒擾
	size_t ssize = ss.w_str().size();
	int *w = new int[ssize+1];
	_tool.getTabbedTextExtent( ss, ssize, w );

	// ɕvZ
	for(size_t i=0; i<ssize; i++)
	{
		if( w[i] > (int)x+hpos )
		{
			p.x = begin+i;
			// XN[΍
			if( i!=0 && w[i-1]<hpos && w[i]>hpos ) p.x++;
			// ܂ԂsO
			else if( i==ssize-1 && end!=s.w_str().size() )
				p.x = end-1;
			break;
		}
	}
	// 擪Ȃ begin ̈ʒu
	if( ssize==0 )
		p.x = begin;
	// I[̏ꍇA܂ԂsȂI[̑OA
	// s[ȂI[ʒu
	else if( w[ssize-1] <= (int)x+hpos )
		if( end==s.w_str().size() )
			p.x = begin + ssize;
		else
			p.x = begin + ssize - 1;

	delete [] w;
/*
#ifdef _DEBUG
	TCHAR temp[64];
	wsprintf(temp, _T("p.x=%d, p.y=%d, yy=%d\n"),
		p.x, p.y, yy);
	OutputDebugString(temp);
#endif
*/
	return p;
}

//------------------------------------------------------------
void Caret::undo()
{
	// AhD
	_doc.undo();

	// LineInfo XV
	_tool.updateWrapInfo();

	// Lbg𓮂
	// (łBŒA낳
	// Ă΁B)
	correctPos();

	// sĕ`
	::InvalidateRect( _vwnd, NULL, FALSE );
}

//--------------------------------------------------------

void Caret::cut()
{
	POINT p1, p2;
	_tool.getSel(&p1,&p2);

	// ͈͑IĂȂȂɂȂ
	if( p1.y==-1 ) return;
	// ǂݎpȂɂȂ
	if( _tool.getReadOnly() ) return;

	// Copy  Delete
	// clearSel Ȃ false
	copy(false);

	onChar(VK_BACK);

	// sɂ܂Ăs`悶Ⴗ܂Ȃ̂
	// S`ł
	if( p1.y != p2.y )
		::InvalidateRect( _vwnd, NULL, FALSE );
}

//--------------------------------------------------------

void Caret::copy(bool bClearSel)
{
	POINT p1, p2;
	_tool.getSel(&p1,&p2);
	// ͈͑IĂȂȂɂȂ
	if( p1.y==-1 ) return;

	// ͈͑I
	if( bClearSel ) _tool.clearSel();

	// Ă
	String s = _doc.getSelectedString(p1,p2);

	Clipboard cb(_vwnd,false);
	if( !cb.isOpened() ) return;

//	::EmptyClipboard();

	HLOCAL h = ::LocalAlloc(LMEM_MOVEABLE,
			(_tcslen(s.c_str())+1) * sizeof(TCHAR));
	LPTSTR p = (LPTSTR)LocalLock(h);	
	_tcscpy( p, s.c_str() );
	LocalUnlock(h);

	if( !cb.setData( CF_UNICODETEXT, p ) )
		::LocalFree(h);

	// ͈͑Iꂽĕ`
	if( bClearSel )
		::InvalidateRect( _vwnd, NULL, FALSE );
}

//--------------------------------------------------------

void Caret::paste()
{
	String s;
	Clipboard cb(_vwnd,true);
	if(cb.isOpened())
		s = cb.getUnicodeText();

	// }񂪋Ȃ牽Ȃ
	if( s.empty() ) return;
	// ǂݎpȂɂȂ
	if( _tool.getReadOnly() ) return;

	size_t pre_wrap, npos, rpos;
	{
		const LineInfo& info = _tool.getLineInfo( _dY );
		pre_wrap = info.wrapsize();
		npos = s.find( _T('\n') );
		rpos = s.find( _T('\r') );
	}
	POINT p={_dX,_dY};
	POINT p1, p2;
	_tool.getSel(&p1,&p2);

	if( p1.y==-1 )
		// ͈͑IĂȂ Insert
		_doc.exec( new Insert(p,s) );
	else
		_doc.exec( new Replace(p1,p2,s) );

	// ͈͑I
	_tool.clearSel();

	// LineInfo XV
	int yn= _tool.countLB( s ) + 1;
	_tool.updateWrapInfoPartial( p.y, yn );

	// LbgʒuĂƁ[ɒ덇킹
	correctPos();

	// ĕ`
	const LineInfo& info = _tool.getLineInfo( _dY );
	if( pre_wrap != info.wrapsize() ||
		String::npos != rpos || String::npos != npos )
		// ܂ԂςĂA
		// 낪ŜőS`
		::InvalidateRect( _vwnd, NULL, FALSE );
	else
		// sĕ`
		invalidateLineRect(pre_wrap);

	if( yn > 1 )
		::PostMessage( _vwnd, WM_SIZE, 0, 0L );
}

//--------------------------------------------------------
void Caret::selectAll()
{
	// ׂđIB
	// ŏI܂łׂđIԂɁB
	int py = _doc.getStringSize()-1,
		px = _doc.getString(py).size();

	POINT p1={0,0}, p2={px,py};
	_tool.setSel( &p1, &p2 );
	
	::InvalidateRect( _vwnd, NULL, FALSE );
}

//--------------------------------------------------------

void Caret::jump(UINT xpos, UINT ypos, int startpos)
{
	// ǂ킯 y  1 NZB
	if( (int)ypos <= 0 ) return;

	// ݂ȂsȂȂɂȂ
	if( ypos >= _doc.getStringSize() || ypos < 1 ) return;
	// ړKvȂȂȂɂȂ
	if( ypos == _dY + 1 && xpos==_dX ) return;


	RECT tr; _tool.getTextAreaRect( &tr );
	int y=0; // ړ
	// OɈړƂ true
	bool bPrev;
	if( ypos - 1 == _dY  )
	{
		if( _dX > xpos ) bPrev = true;
		else             bPrev = false;
	}else{
		if( ypos-1 < _dY ) bPrev = true;
		else               bPrev = false;
	}

	// y ȂXLbv
	if( ypos == _dY + 1 ) goto SKIP_Y;

	// ݂̐܂Ԃʒuǂ𒲂ׂ
	{
	size_t wrapsize = _tool.getLineInfo( _dY ).wrapsize();
	UINT         yy = getWrapPos( _dX, _dY );
	y = bPrev ? (-1)*(yy+1) : wrapsize+1-yy;
	}

SKIP_Y:

	// ,sɈړ̂vZ
	int ptY=0; // WZ̈ړ
	int lw = _tool.getFontHeight() + _tool.getLineSpace(); // s
	if( bPrev )
	{
		// ɈړƂ
		if( _dY != 0 )
		{
			for( UINT i=_dY-1; i>ypos-1; i-- )
			{
				const LineInfo& info = _tool.getLineInfo( i );
				y -= info.wrapsize()+1;
			}
		}
		const LineInfo& info = _tool.getLineInfo( ypos-1 );
		y -= info.wrapsize();
		y += getWrapPos( xpos, ypos-1 );

		// y  _pt.y ƂɍWł̈ړʂvZ
		ptY = _pt.y + lw*y;
		if( ptY < tr.top )
		{
			int yscroll = startpos;
			for( ; ptY < tr.top; yscroll-- ) ptY += lw;
			WPARAM wp = MAKEWPARAM( SB_THUMBTRACK, yscroll );
			::SendMessage( _vwnd, WM_VSCROLL, wp, 0L );
			::InvalidateRect( _vwnd, NULL, FALSE );
		}
	}
	else
	{
		// ɈړƂ
		for( UINT i=_dY+1; i<ypos-1; i++ )
		{
			const LineInfo& info = _tool.getLineInfo( i );
			y += info.wrapsize()+1;
		}
		y += getWrapPos( xpos, ypos-1 );

		// y  _pt.y ƂɍWł̈ړʂvZ
		ptY = _pt.y + lw*y;
		if( ptY >= tr.bottom )
		{
			int yscroll = startpos;
			for( ; ptY > tr.bottom; yscroll++ ) ptY -= lw;
			WPARAM wp = MAKEWPARAM( SB_THUMBTRACK, yscroll );
			::SendMessage( _vwnd, WM_VSCROLL, wp, 0L );
			::InvalidateRect( _vwnd, NULL, FALSE );
		}
	}

	// xpos ̈ʒu
	const LineInfo& info = _tool.getLineInfo( ypos-1 );
	size_t      wrapsize = info.wrapsize();
	int ptX;
	for( size_t i=0; i<=wrapsize; ++i )
	{
		size_t begin = i==0          ? 0 : info[i-1];
		size_t end   = i==wrapsize ?
			_doc.getString(ypos-1).size() : info[i];
		if( xpos>=begin && xpos<=end )
		{
			ptX = _tool.getStringWidth(
					_doc.getString(ypos-1).substr(begin, end-begin),
						xpos-begin );
		}
	}

	_dX = xpos, _dY = ypos-1;
	setPos( tr.left+ptX, ptY );

#ifdef _DEBUG
	TCHAR temp[64];
	wsprintf(temp, _T("dX=%d, dY=%d\n"),
		_dX, _dY);
	OutputDebugString(temp);
#endif

}

//--------------------------------------------------------
UINT Caret::getWrapPos( UINT x, UINT y )
{
	const LineInfo& info = _tool.getLineInfo( y );
	size_t      wrapsize = info.wrapsize();
	for( size_t i=0; i<=wrapsize; ++i )
	{
		size_t begin = i==0          ? 0 : info[i-1];
		size_t end   = i==wrapsize ?
			_doc.getString(_dY).size() : info[i];
		if( x>=begin && x<=end )
		{
			return i;
		}
	}
	return wrapsize;
}

//--------------------------------------------------------
void Caret::invalidateLineRect(int wrapsize)
{
	// ŝݍĕ`B
	int lw = _tool.getFontHeight() + _tool.getLineSpace();
	POINT pt; ::GetCaretPos(&pt);
	RECT vr;
	_tool.getTextAreaRect(&vr);
	vr.left  = 0;
    vr.right+=20;
	vr.top   = _pt.y; 
	vr.bottom = _pt.y + lw*(wrapsize+1);
	::InvalidateRect( _vwnd, &vr, FALSE );
}

//--------------------------------------------------------
void Caret::invalidateBottomRect()
{
	// ݍs艺ĕ`B
	int lw = _tool.getFontHeight() + _tool.getLineSpace();
	POINT pt; ::GetCaretPos(&pt);
	RECT vr;
	_tool.getTextAreaRect(&vr);
	vr.left  = 0;
    vr.right+=20;
	vr.top   = _pt.y; 
//	vr.bottom;
	::InvalidateRect( _vwnd, &vr, FALSE );
}

