#include "ntpedit.h"

#include "caret.h"

using namespace ntpedit;


// onKeyDown ̃Tu֐ɁB
// Ƃ킩₷ȂƁB

//--------------------------------------------------------------
void Caret::moveUp(const POINT* po, POINT* pn)
{
	int n = getCurrentWrapLine(*po);
	const LineInfo& inf = _tool.getLineInfo( po->y );

	// ԏȂړȂ
	if( po->y==0 && n==0 )
	{
		pn->x=po->x, pn->y=po->y; return;
	}
	
	if( n==0 )
	{
		// O̍sֈړ
		pn->y = po->y-1;
		const LineInfo& pinf = _tool.getLineInfo( pn->y );
		if( pinf.wrapsize()==0 )
		{
			// ܂ԂȂȂ炻̂܂
			pn->x = po->x;
			if( pn->x > (int)_doc.getString(pn->y).size() )
				pn->x = _doc.getString(pn->y).size();
		}
		else
		{
			// ܂ԂȂŌ̍s
			pn->x = pinf[pinf.wrapsize()-1] + po->x;
			if( pn->x > (int)_doc.getString(pn->y).size() )
				pn->x = _doc.getString(pn->y).size();
		}
		return;
	}

	// ̍sŏֈړ
	size_t newbegin = n==1 ? 0 : inf[n-2];
	pn->x = newbegin + (po->x - inf[n-1]);
	pn->y = po->y;
}

//--------------------------------------------------------------
void Caret::moveDown(const POINT* po, POINT* pn)
{
	size_t n = (size_t)getCurrentWrapLine(*po);
	const LineInfo& inf = _tool.getLineInfo( po->y );

	// ԉȂړȂ
	if( po->y >= (int)_doc.getStringSize()-1 
		&& n==inf.wrapsize() )
	{
		pn->x=po->x, pn->y=po->y; return;
	}

	if( n==inf.wrapsize() )
	{
		// ̍sֈړ
		pn->y = po->y + 1;
		const LineInfo& pinf = _tool.getLineInfo( pn->y );
		// O̍s̊JnʒuB
		size_t begin = n==0 ? 0 : inf[n-1];
		// ̍s̏IʒuB
		size_t end   = pinf.wrapsize()==0 ? 
			_doc.getString(pn->y).size() : pinf[0]-1;

		pn->x = po->x-begin;
		if( pn->x > (int)end )
			pn->x = (int)end;
		return;
	}

	// ̍sŉֈړ
	size_t oldbegin = n==0 ? 0 : inf[n-1];
	size_t newend;
	if( n==0 || n==inf.wrapsize()-1 )
		newend = _doc.getString(po->y).size();
	else
		newend = inf[n+1]-1;

	pn->x = inf[n] + (po->x-oldbegin);
	if( pn->x > (int)newend )
		pn->x = newend;
	pn->y = po->y;
}

//--------------------------------------------------------------
void Caret::moveLeft(const POINT* po, POINT* pn)
{
	// ԏȂȂɂȂ
	if( po->y==0 && po->x==0 )
	{
		pn->x=po->x, pn->y=po->y; return;
	}

	// sȂO̍s
	if( po->x==0 )
	{
		pn->y = po->y - 1;
		pn->x = _doc.getString( pn->y ).size();
		return;
	}

	// ȊOȂO
	pn->x = po->x-1, pn->y = po->y;
}

//--------------------------------------------------------------
void Caret::moveRight(const POINT* po, POINT* pn)
{
	// ԉȂȂɂȂ
	if( po->y==(int)_doc.getStringSize()-1 &&
		po->x==(int)_doc.getString(po->y).size() )
	{
		pn->x=po->x, pn->y=po->y; return;
	}

	// s̏IȂ玟̍s
	if( po->x== (int)_doc.getString(po->y).size() )
	{
		pn->y = po->y+1;
		pn->x = 0;
		return;
	}

	// ȊOȂ
	pn->x = po->x+1, pn->y = po->y;
}

//--------------------------------------------------------------
POINT Caret::getNewXY(const POINT po, const POINT pn,
					  int hscroll, int *flag)
{
	// s
	int lw = _tool.getFontHeight() + _tool.getLineSpace();

	// ݂̃Lbg̈ʒu
	POINT pt;
	::GetCaretPos(&pt);

	// sႦΓR㉺ֈړ
	if( po.y != pn.y )
		pt.y += (pn.y - po.y)*lw;

	// ܂Ԃ̍s`FbN
	int n1 = getCurrentWrapLine(po);
	int n2 = getCurrentWrapLine(pn);

	// ܂ԂsႦΏ㉺ֈړ
	if( po.y==pn.y && n1 != n2 )
		pt.y += (n2 - n1)*lw;

	// x Ẅʒu߂
	const LineInfo& inf = _tool.getLineInfo( pn.y );
	const String&   s   = _doc.getString( pn.y );
	size_t begin = n2==0                   ? 0 : inf[n2-1];
	size_t end   = n2==(int)inf.wrapsize() ? s.size() : inf[n2];

	const String& ss = s.substr( begin, end-begin );
	RECT r;  _tool.getLineNumRect(  &r  );
	RECT tr; _tool.getTextAreaRect( &tr );
	pt.x = _tool.getStringWidth( ss, pn.x-begin ) + r.right - hscroll;

	// ŌɃLbgʂ͂ݏoȂ
	// `FbNB͂ݏo悤ȂW߂
	// flag  ON 
	if( pt.y < 0 )
	{
		pt.y += lw, *flag = SB_LINEUP;
	}
	else if( pt.y > r.bottom-lw )
	{
		pt.y -= lw, *flag = SB_LINEDOWN;
	}

	if( pt.x > tr.right )
	{
		short times=0;
		while(pt.x>tr.right)
		{
			pt.x-=_tool.getHScrollUnitSize();
			times++;
		}
		*flag |= times<<16;
	}
	else if( pt.x < r.right )
	{
		short times=0;
		while(pt.x<r.right)
		{
			pt.x +=_tool.getHScrollUnitSize();
			times--;
		}
		*flag |= times<<16;
	}

	return pt;
}

//--------------------------------------------------------------
int Caret::getCurrentWrapLine(const POINT p)
{
	const LineInfo& inf = _tool.getLineInfo( p.y );
//	const String& s = _doc.getString( _dY ).c_str();
	size_t     ws = inf.wrapsize();

	if( ws==0 ) return 0;
	for( size_t i=0; i<ws; i++ )
	{
		if( p.x < inf[i] ) return i;
	}
	return i;
}

