
#include "ntpedit.h"
#include "command.h"
#include "doc.h"

using namespace ntpedit;

// OɁADoc NX̕ύXKvB
// Econst łȂ getString \bh̍쐬B
// Esۂƍ폜郁\bh( removeString? ) ̍쐬B
// EsVɑ}郁\bh( insertString? ) ̍쐬B

//------------------------------------------------
// R}hNX
//------------------------------------------------
Command::Command(){}
Command::Command(const String& s):_s(s){}

void Command::insertOperation(Doc& d, const POINT p, 
		const String& ss, POINT& pe)
{
	String s = ss;
	size_t pos, posn;
	int x = p.x;
	int y = p.y;

	// s  \n ĂƁ[
	// ؂o
	while(1)
	{
		pos = s.find( _T('\r') );

		// \r Ȃ \n T
		posn= s.find( _T('\n') );
		if( pos==String::npos && posn != String::npos )
			pos = posn;

		if( pos==String::npos )
		{
			// sȂ΂̂܂ܑ}
			if( !s.empty() )
			{
				String& ds = d.getString2( y );
				if( x==0 && y!=p.y ) ds = s;
				else                 ds = ds.insert( x, s );
			}
			break;
		}
		else
		{
			// \r or \n ȂO܂ł؂
			String sp = s.substr( 0, pos );
			String ds1, ds2;
			if( y==p.y )
			{
				// ŏ̍sȂO̍s̖ɂ
				String& ds = d.getString2( y );
				ds1 = ds.substr(0, p.x);
				ds2 = ds.substr(p.x, ds.size()-p.x);
				ds = ds1 + sp;
				x = 0;
			}
			else
			{
				String& ds = d.getString2( y );
				ds = sp;
			}
//			d.insertString( y, sp );
			d.insertString( y, String("") ); // ł͋󂪂H
			s = s.substr( pos+1, s.size()-(pos+1) );
			// \r\n ΍
			if( pos == posn-1 ) s = s.substr( 1, s.size()-1 );
			s += ds2;
		}
		y++;
	}

	// ΂ɂ Remove R}hԂ
	pe = p;
	// s Insert ̂Ƃ 񒷂͗vȂ͂H
	if( ss==_T("\r") )
		pe.x = 0,  pe.y = y;
	else
		pe.x += s.size(), pe.y = y;
}

void Command::removeOperation(Doc& d, const POINT ps,
		const POINT pe, String& s)
{
	if( ps.y==pe.y )
	{
		const String cs = d.getString2( ps.y );
		String&      ds = d.getString2( ps.y );
		ds = ds.erase( ps.x, pe.x-ps.x );
		s  = cs.substr(ps.x, pe.x-ps.x);
	}
	else
	{
		// sɂ܂Ă

		// ܂ŏ̍s ps.x Ō܂ō폜
		String& ds = d.getString2( ps.y );
		s = ds.substr( ps.x, ds.size()-ps.x );
		ds = ds.substr( 0, ps.x );
		// pe.y ܂ł̍sׂ͂č폜
		for( int i=ps.y+1; i<pe.y; i++ )
		{
			const String cs = d.getString2( ps.y+1 );
			s += _T("\r\n"); s += cs;
			d.removeString( ps.y+1 );
		}
		// pe.y ̍s 0  pe.x ܂ō폜
		String ds2 = d.getString2( ps.y+1 );
		s += _T("\r\n"); s += ds2.substr( 0, pe.x );
		d.removeString( ps.y+1 );
		ds += ds2.substr( pe.x, ds2.size()-pe.x );
	}
//#ifdef _DEBUG
//	OutputDebugString( s.c_str() );
//#endif
}

//------------------------------------------------
// }R}h
//------------------------------------------------
Insert::Insert(const POINT p, const String& s)
	:_p(p), Command(s)
{}

Command* Insert::operator()( Doc& d )
{
	POINT pe;
/*
#ifdef _DEBUG
	OutputDebugString(_s.c_str());
	OutputDebugString(_T("\n"));
#endif
*/
	Command::insertOperation( d, _p, _s, pe );
	return new Remove(_p,pe);
}

//------------------------------------------------
// 폜R}h
//------------------------------------------------
Remove::Remove(const POINT ps, const POINT pe)
	:_ps(ps), _pe(pe)
{}

Command* Remove::operator()( Doc& d )
{
	String s;

	Command::removeOperation(d,_ps,_pe,s);
/*
#ifdef _DEBUG
	OutputDebugString(s.c_str());
	OutputDebugString(_T("\n"));
#endif
*/
	// ΂ɓ Insert R}hԂ
	return new Insert(_ps, s);
}

//------------------------------------------------
// uR}h
//------------------------------------------------
Replace::Replace(const POINT ps, const POINT pe, 
				 const String& s)
	:_ps(ps), _pe(pe), Command(s)
{}

Command* Replace::operator()( Doc& d )
{
	String s;
	POINT pf;

#ifdef _DEBUG
	OutputDebugString(_s.c_str());
	OutputDebugString(_T("\n"));
#endif

	Command::removeOperation(d,_ps,_pe,s);
	Command::insertOperation(d,_ps,_s,pf);

#ifdef _DEBUG
	OutputDebugString(s.c_str());
	OutputDebugString(_T("\n"));
#endif

	return new Replace( _ps, pf, s );
}

//------------------------------------------------
// UnReDoManager
//------------------------------------------------
UnReDoManager::UnReDoManager()
	:_limit(-1)
{}

UnReDoManager::~UnReDoManager()
{
	vector<Command*>::iterator itr    = _vCmd.begin();
	vector<Command*>::iterator itrEnd = _vCmd.end();	
	for(; itr!=itrEnd; ++itr) delete *itr;

	itr    = _vUndo.begin();
	itrEnd = _vUndo.end();
	for(; itr!=itrEnd; ++itr) delete *itr;

	_vCmd.clear(); _vUndo.clear();
}

void UnReDoManager::setLimit(int limit)
{ _limit = limit; }

void UnReDoManager::setCommand(Command* pCmd)
{
	if( _limit != -1 )
	{
		vector<Command*>::iterator itr = _vCmd.begin();
		if( _limit < (int)_vCmd.size() )
		{
			delete *itr; _vCmd.erase( itr );
		}
		itr = _vUndo.begin();
		if( _limit < (int)_vUndo.size() )
		{	
			delete *itr; _vUndo.erase( itr ); 
		}
	}
	_vCmd.push_back(pCmd);
}

void UnReDoManager::exec(Doc& d)
{
	Command* p = _vCmd.at(_vCmd.size()-1);
	Command* u = (*p)(d);
	_vUndo.push_back( u );
}

void UnReDoManager::undo(Doc& d)
{
	if( _vUndo.empty() ) return;

	Command* p = _vUndo.at(_vUndo.size()-1);
	Command* u = (*p)(d);
	delete u; delete p;
	_vUndo.pop_back();
}

void UnReDoManager::redo(Doc& d)
{
	Command* p = _vCmd.at(_vCmd.size()-1);
	Command* u = (*p)(d);
	_vUndo.push_back( u );
}

