
#ifndef _NTPEDIT_COMMAND_H_
#define _NTPEDIT_COMMAND_H_

#include "..\..\uelib2\uelib.h"
using namespace uelib;

namespace ntpedit{

class UnReDoManager;
class Doc;

//------------------------------------------------

//@{
// R}hp^[̊NX
//@}
class Command
{
public:
	static void insertOperation(Doc& d, const POINT p,
		const String& s, POINT& pe);
	static void removeOperation(Doc& d, const POINT ps,
		const POINT pe, String& s);

protected:
	Command();
	Command(const String& s);

protected:
	friend class UnReDoManager;
	virtual Command* operator()( Doc& d ) = 0;

protected:
	const String _s;
};

//------------------------------------------------

class Insert : public Command
{
public:
	// p : Jnʒu(΍s)
	// s : }
	Insert(const POINT p, const String& s);

private:
	Command* operator()( Doc& d );
	const POINT  _p;
};

//------------------------------------------------

class Remove : public Command
{
public:
	// ps : Jnʒu(΍s) point-start
	// pe : Iʒu(΍s) point-end
	Remove(const POINT ps, const POINT pe);
	~Remove(){};

private:
	Command* operator()( Doc& d );
	const POINT  _ps, _pe;
};

//------------------------------------------------
class Replace : public Command
{
public:
	// ps : Jnʒu(΍s)
	// pe : Iʒu(΍s)
	// s  : }
	Replace(const POINT ps, const POINT pe,
			const String& s);

private:
	Command* operator()( Doc& d );
	const POINT _ps, _pe;
};

//------------------------------------------------

class UnReDoManager
{
public:
	UnReDoManager();
	~UnReDoManager();

public:
	void setCommand( Command* c );
	void exec(Doc& d);
	void undo(Doc& d);
	void redo(Doc& d);
	void setLimit(int limit);

private:
    int _limit;
	vector<Command*>   _vCmd;
	vector<Command*>   _vUndo;
};

} // namespace ntpedit
#endif //_NTPEDIT_COMMAND_H_
