
#include "ntpedit.h"

#include "doc.h"

using namespace uelib;
using namespace ntpedit;

Doc::~Doc()
{
	int d=1;
}

void Doc::newDocument()
{
	if( !_vStr.empty() ) _vStr.clear();
	_vStr.push_back( String( _T("") ) );
}

void Doc::read(TxtDecoder& d)
{
	if( !_vStr.empty() ) _vStr.clear();

	for(; d.state(); )
		_vStr.push_back( d.readLine() );
}

void Doc::read(TxtDecoder2& d, bool erase)
{
	if( erase==true )
		if( !_vStr.empty() ) _vStr.clear();

	Txt* t = TxtCreator::createTxt(d.charcode(), 
		d.base(), d.size() );

	if( erase==false )
		_vStr[_vStr.size()-1] += t->readLine();

	for(; t->state(); )
		_vStr.push_back( t->readLine() );

	delete t;
}

void Doc::write(TxtEncoder& e, const TCHAR* fname)
{
	size_t size = _vStr.size();

	if( !e.open( fname ) ) return;

	for(size_t j=0; j<size; j++)
	{
		e.writeLine( _vStr[j], j==0,
			j==size-1 );
	}
}

void Doc::removeString(size_t n)
{
	vector<String>::iterator itr    = _vStr.begin();
	vector<String>::iterator itrEnd = _vStr.end();

	for(size_t i=0; i<n; i++)
		++itr;
	_vStr.erase(itr);
}

void Doc::insertString(size_t n, const String& s)
{
	vector<String>::iterator itr    = _vStr.begin();
	vector<String>::iterator itrEnd = _vStr.end();

	for(size_t i=0; (i<=n && itr!=itrEnd); i++) ++itr;
	_vStr.insert(itr, s);
}

String Doc::getSelectedString(const POINT ps, const POINT pe)
{
	if( ps.y==pe.y )
	{
		return _vStr[ps.y].substr( ps.x, pe.x-ps.x );
	}
	else
	{
		// ܂ŏ̍s
		String s = _vStr[ps.y].substr( ps.x,
			_vStr[ps.y].size()-ps.x );
		s += _T("\r\n");
		for( int i=ps.y+1; i<pe.y; i++ )
		{
			// Ԃ̍sBׂăRs[B
			s += _vStr[i];
			s += _T("\r\n");
		}
		// Ō̍s
		s += _vStr[pe.y].substr( 0, pe.x );
		return s;
	}
	return String("");
}

void Doc::exec(Command* p)
{
	_m.setCommand(p);
	_m.exec( *this );
}

void Doc::undo()
{
	_m.undo( *this );
}

void Doc::redo()
{
	_m.redo( *this );
}
