
#ifndef _NTPEDIT_DOC_H_
#define _NTPEDIT_DOC_H_

#include <vector>
#include "command.h"

#include "..\..\uelib2\uelib.h"
using namespace uelib;

namespace ntpedit{

//@{
// hLgNXB
// GfBbgGWB
//@}
class Doc
{
public:
	Doc(){};
	virtual ~Doc();

public:
	//@{ t@Cǂ //@}
	void read(TxtDecoder& d);
	//@{ ǂ //@}
	void read(TxtDecoder2& d, bool erase=false);
	//@{  //@}
	void write(TxtEncoder& e, const TCHAR* fname);
	//@{ VK쐬 
	//   IɕʃNXɈϏ
	//   \ //@}
	void newDocument();

public:
	//@{ ֌W //@}
	const size_t getStringSize() const;
	const String& getString(size_t i) const;
	String& getString2(size_t i);
	String  getSelectedString(const POINT ps, const POINT pe);
//	void setString(size_t i, const String& s);

	void removeString(size_t i);
	void insertString(size_t i, const String& s);

	//@{ UnDo, ReDo ֌W //@}
	void exec(Command* p);
	void undo();
	void redo();
	void setUndoLimit(int n);

private:
	vector<uelib::String> _vStr;
	UnReDoManager         _m;
};

//------------------------------------------------
inline const size_t Doc::getStringSize() const
	{ return _vStr.size(); }

inline const String& Doc::getString(size_t i) const
	{ return _vStr[i]; }

inline String& Doc::getString2(size_t i)
	{ return _vStr[i]; }

//inline void Doc::setString(size_t i, const String& s)
//	{ _vStr[i] = s; }

inline void Doc::setUndoLimit(int n)
	{ _m.setLimit(n); }

} //namespace ntpedit
#endif
