
#include "ntpedit.h"

#include "editctrl.h"

using namespace uelib;
using namespace ntpedit;

NtpEdit::NtpEdit()
	:Window( _T("NTP2 EDITCTRL"), WS_CHILD|WS_VISIBLE, WS_EX_CLIENTEDGE )
{
	static bool ClassRegistered = false;
	if( !ClassRegistered )
	{
		ClassRegistered = true;

		// \ẑ݁ANXo^s
		WNDCLASS wc      = {0};
		wc.lpszClassName = _className;
		registerWnd( &wc );
	}
}

NtpEdit::~NtpEdit()
{
//	delete _doc;
	destroy();
}

void NtpEdit::onCreate()
{
	_doc = auto_ptr<Doc>( new Doc() );
	_view = auto_ptr<View>( new View(*_doc, _hwnd) );
}

void NtpEdit::onDestroy()
{
	Window::onDestroy();
}

LRESULT NtpEdit::onMessage( UINT msg, WPARAM wp, LPARAM lp )
{
	if( msg == WM_SETFOCUS )
	{
		_view->setFocus();
		return 0;
	}
	else if( msg == WM_SIZE )
	{
		RECT rc;
		getClientRect( &rc );
		_view->moveTo( 0, 0, rc.right, rc.bottom );
		_view->getPaintTool().updateWrapInfo();
		::SendMessage( _view->getHwnd(), WM_SIZE, SIZE_MINIMIZED+1,
			MAKELPARAM(rc.right, rc.bottom) );
#ifdef DEBUG
		{
		TCHAR tmp[64];
		wsprintf( tmp, _T("Edit : wp=%d : lp=0x%x\n"), wp, lp );
		OutputDebugString( tmp );
		}
#endif
		return 0;
	}

	return Window::onMessage( msg, wp, lp );
}

