
#ifndef _NTPEDIT_PAINTER_H_
#define _NTPEDIT_PAINTER_H_

#include "basepainter.h"

namespace ntpedit{

//@{
// `NXB
// PaintTool NXo`B
//@}
class Painter : public BasePainter
{
public:
	//@{ RXgN^ //@}
	Painter(Doc& d, PaintTool& t, HWND h);
	~Painter();
	//@{ ȏ //@}
	virtual void Delete();

public:
	//@{ Cxgnh //@}
	void onPaint( PAINTSTRUCT* pps, int start, int hscroll );
	void onSize( int height, int width );
	void onLButtonUp(WORD x, WORD y, int vpos){};

private:
	void drawBackground( HDC h, LPRECT r );
	void drawLinenumArea( HDC h );
	void drawText( HDC h, int start, LPRECT r, int hscroll );
	
	void textOut(HDC h, const String& s, LPRECT r,
		int length, const LineInfo& info, int hscroll);
	void textOutCPP(HDC h, String& s, RECT& r, const LineInfo& i);
	void textOutHTML(HDC h, String& s, RECT& r);
	void textOutSel(HDC hdc, String& s, LPRECT rect,
					 int y, UINT start, UINT end, int hscroll);
	void textOutSearch(HDC hdc, String& ss, LPRECT rect,
					 int y, UINT start, UINT end, int hscroll);
	void textOutSpecificArea(HDC hdc, String& ss,
				LPRECT rect, int y, UINT start, UINT end,
				int hscroll, COLORREF txtcolor, COLORREF bgcolor,
				POINT p1, POINT p2);
	void drawEOF(HDC h, const LPRECT lr);
	void drawEOL(HDC h, const LPRECT lr);

private:
	// painter2.cpp ֘AB
	String translateTab(const String& s);
	UINT isComment(const String& s, const LineInfo& info);
	UINT isKeyword(const String& s);
	UINT findKeyword(const String& s);
	bool checkWord(const TCHAR c);
	size_t cutHScrollString(int hscroll, 
			const String& s, LPRECT r, bool bZeroStart=false);

private:
	Doc&       _doc;
	PaintTool& _tool;
	HWND       _vwnd;
	static int _bstart;
	//@{ ubNRg̏I[Ɠs
	//  L[[h܂܂Ăꍇ΍B
	//@}
	static bool _endcmt;
};

//-----------------------------------------------
inline void Painter::Delete()
	{ delete this; }

} //namespace ntpedit
#endif

