
#include "ntpedit.h"

#include "painter.h"

using namespace ntpedit;

//------------------------------------------------
// translateTab ƂA
// L[[h֘A͂B
//------------------------------------------------

String Painter::translateTab(const String& s)
{
	// wchar_t ^Ńobt@ɃRs[
	static int spaceWidth = _tool.getStringWidth( String(_T(" ")), 1 );
	wchar_t*      w = new wchar_t[ s.w_str().size()+1 ];
	wcscpy( w, s.w_str().c_str() );

	// ^u̐𐔂
	int         len = wcslen( w );
	size_t tabCount = 0;
	wchar_t     *wp = w;
	for( int i=0; i<len; i++ )
	{ if( *wp++==L'\t' ) tabCount++; }

	// u
	int tabSize = _tool.getTabSize();
	wchar_t* tmp = new wchar_t[ len + tabCount*tabSize +1 ];
	for( int j=0, k=0; j<len; j++ )
	{
		if( w[j]==L'\t' )
		{
			int nn = (tabSize*spaceWidth)
				-( _tool.getStringWidth(s,j)%(tabSize*spaceWidth) );
			nn /= spaceWidth;
			for( int n=0; n<nn; n++ ) tmp[k++] = L' ';
		}
		else
		{
			tmp[k++] = w[j];
		}
	}
	tmp[k] = L'\0';

	String x = tmp;
	delete [] w; delete [] tmp;
	return x;
}

//----------------------------------------------------------------
UINT Painter::isComment(const String& s, const LineInfo& info)
{
	const KEYWORDS& k = _tool.getKeywords();

	// LineInfo  comment  true ̂Ƃ
	if( info.getComment()==true && _endcmt==false)
	{
		// endcomment T
		size_t pos = s.find( k.getEndBlockComment() );
		if( pos==String::npos ) return s.w_str().size();
		if( _tool.checkQuote( s,pos ) )
		{
			_endcmt = true;
			return pos + k.getEndBlockComment().w_str().size();
		}
	}

	// sRgƔr
	const String& lc = k.getLineComment();
	if( 0==s.compare( 0, lc.size(), lc ) ) 
		return s.w_str().size();

	// ubNRgƔr
	const String& bcbegin = k.getBeginBlockComment();
	const String& bcend = k.getEndBlockComment();
	if( 0==s.compare( 0, lc.size(), bcbegin ) )
	{
		// EndComment T
		size_t pos = s.find( bcend );
		if( _tool.checkQuote( s,pos ) )
		{
			if( pos==String::npos ) return s.w_str().size();
			else                    return pos+bcend.w_str().size();
		}
	}

	return 0;
}

//----------------------------------------------------------------
UINT Painter::isKeyword(const String& s)
{
	const KEYWORDS& k = _tool.getKeywords();
	size_t ksize = k.getKeywordSize();

	// HTML̂Ƃ͑啶""A
	bool b = _tool.getHighlightType()==2 ? true : false;

	// FXĂ݂B
	// operator[] -> iterator  : 
	// String::compare -> wcsnicmp : L
	size_t ssize = s.size();

	for(size_t i=0; i<ksize; i++)
	{
		const String& kwd=k[i];
		if( kwd.empty() ) continue;

		const size_t kwsize = kwd.w_str().size();
		if( kwsize > ssize ) continue;

		int cmp = b ? wcsnicmp( s.c_str(), kwd.c_str(), kwsize ) :
			wcsncmp( s.c_str(), kwd.c_str(), kwsize );
		if( cmp==0 )
		{
			// L[[hB
			// E`FbNKv
			if( ssize <= kwsize ||
				true == checkWord( s[kwsize] ) )
				return kwsize;
		}
	}
	return 0;
}

//----------------------------------------------------------------
UINT Painter::findKeyword(const String& s)
{
	const KEYWORDS& k = _tool.getKeywords();
	size_t pos = String::npos;
	// HTML̂Ƃ͑啶""A
	bool b = _tool.getHighlightType()==2 ? true : false;

	// RgT
	const String& lcs = k.getLineComment();
	const String& bcs = k.getBeginBlockComment();
	const String& ecs = k.getEndBlockComment();
	size_t p1 = lcs.empty() ? String::npos : s.find( lcs );
	size_t p2 = bcs.empty() ? String::npos : s.find( bcs );
	size_t p3 = ecs.empty() ? String::npos : s.find( ecs );

	if( p1!=pos || p2!=pos || p3!=pos )
	{
		// "", '' ǂ̃`FbNKv
		size_t pn = p1 < p2 ? p1 : p2;
		pn = pn < p3 ? pn : p3;
		// RgOɃL[[h邩
		// Ȃ̂ŁA return łȂ
		if( _tool.checkQuote(s,pn) )
			pos = pn;
	}

	// ܂łŁApos ɃRg̈ʒuĂ

	size_t ksize = k.getKeywordSize();
	size_t pk1=String::npos, pk2=String::npos;
	for( size_t i=0; i<ksize; i++ )
	{
		const String& keystr = k[i];
		if( keystr.empty() ) continue;
		const size_t kwsize = keystr.size();

		// pos  kwsize 菬ȂArKvȂ
		if( pos < kwsize ) continue;

		size_t pk;
		if( b ) pk = s.findi( keystr );
		else    pk = s.find( keystr );

		if( pk != String::npos )
		{
			// L[[hB
			// E`FbNKv
			bool bb = pk==0 ? true : checkWord(s[pk-1]);

			if( ( bb && s.size() <= pk+kwsize ) || 
				( bb && true==checkWord(s[pk+kwsize]) ) )
			{
				//  quote `FbN
				if( _tool.checkQuote(s,pk) )
					if( pk < pos ) pos = pk; 
			}
		}
	}
	// pos  0 , cpp ̋\ "*/" 
	// \Ȃ肷̂ŁB
	return (pos!=String::npos && pos!=0) ? pos : s.w_str().size();
}

//----------------------------------------------------------------
bool Painter::checkWord(const TCHAR c)
{
	if( c>=0x30 && c<=0x39 ) return false;
	if( c>=0x41 && c<=0x5A ) return false;
	if( c>=0x61 && c<=0x7A ) return false;
	return true;
}	

//----------------------------------------------------------------
size_t Painter::cutHScrollString(int hscroll, 
					const String& s, LPRECT r, bool bZeroStart)
{
	// XN[ʁAɉBł낤
	// ؂Ă܂֐B
	size_t ssize = s.size();
	int    w = 0;
	size_t i = bZeroStart ? 0 : 1;

	for( ; i<=ssize; i++ )
	{
		w = _tool.getStringWidth( s.substr(0, i), i );
		if( w >= hscroll )
		{
			r->left += w - hscroll;
//			return s.substr( i, ssize-i );
			return i;
		}
	}
//	r->left += w-hscroll;
//	return String("");
	return s.size();
}
