
#include "ntpedit.h"

#include "painttool.h"

using namespace ntpedit;
using namespace uelib;

//------------------------------------------------

void PaintTool::setFont(LPCTSTR name, int fsiz, int tab)
{
	_fHeight			= fsiz;
	_f.lfHeight			= -uelib::MulDiv(fsiz, ::GetDeviceCaps(_hdc,LOGPIXELSY), 72);
	_f.lfWidth			= _f.lfEscapement = _f.lfOrientation = 0;
	_f.lfWeight			= FW_DONTCARE;
	_f.lfItalic			= _f.lfUnderline = _f.lfStrikeOut = FALSE;
	_f.lfCharSet		= DEFAULT_CHARSET;
	_f.lfOutPrecision	= OUT_DEFAULT_PRECIS;
	_f.lfClipPrecision	= CLIP_DEFAULT_PRECIS;
	_f.lfQuality		= DEFAULT_QUALITY;
	_f.lfPitchAndFamily	= VARIABLE_PITCH|FF_DONTCARE;
	_tcscpy(_f.lfFaceName, name);

	registerFont();

	// sԍČvZ
//	_lineNumWidth = getStringWidth( String(_T("00000")), 5 );

	_tab = tab;

	// XN[Ō߂
	_hScrollUnitSize = -(_f.lfHeight*2);
}

void PaintTool::registerFont()
{
	if( _hf!=NULL )
	{
		::SelectObject(_hdc, _oldhf);
		::DeleteObject( _hf );
	}
	_hf = ::CreateFontIndirect(&_f);
	_oldhf = (HFONT)::SelectObject(_hdc, _hf);

	// LOGFONT?
//	::GetObject( _hf, sizeof(LOGFONT), &_f );
}

void PaintTool::setColor(COLORREF* c)
{
	COLORREF *pc = c;
	for( int i=0; i<sizeof(_color)/sizeof(COLORREF); i++ )
	{
		_color[i] = *pc++;
	}
}

void PaintTool::setCtrlMark(bool* b)
{
	bool *pc = b;
	for( int i=0; i<5; i++ )
	{
		_ctl[i] = *pc++;
	}
}

void PaintTool::getLineNumRect(LPRECT rc)
{
	getClientRect(rc);
	rc->right = _lineNumWidth;
}

void PaintTool::getTextAreaRect(LPRECT rc)
{
	getClientRect(rc);
	// ̍sԍGA̕𑫂
	rc->left  += _lineNumWidth;
	// ẼXN[o[̕
	rc->right -= ::GetSystemMetrics(SM_CXVSCROLL);
	// ̃XN[o[̕
	// (XN[ĂƂŃRgAEg)
//	rc->bottom-= ::GetSystemMetrics(SM_CYHSCROLL);
}

void PaintTool::updateWrapInfo()
{
	// LineInfo ̏XV
	_vLI.clear();

	RECT r;
	getTextAreaRect( &r );

	if( r.right <= 0 ) return;
	if( getFontHeight() == 0 ) return;

	// ʂɕ`悳Ăsɂ邩A
	// Lbgړ\"Ls"ɂ邩H
	// PocketPC  +0 łȂƂ߂݂EEE
	// HPC  +1 ŖȂ񂾂ǂȁ[B
	// ǋLFXN[o[肾 +1 ɂƂɂ
	//       ܂炵
	_lines = 
		r.bottom % ( getFontHeight()+_lineSpace ) == 0 ?
		r.bottom / ( getFontHeight()+_lineSpace ) + 0: //+ 0:
		r.bottom / ( getFontHeight()+_lineSpace ) + 0;
//		r.bottom / ( getFontHeight()+_lineSpace ) + 1: //+ 0:
//		r.bottom / ( getFontHeight()+_lineSpace ) + 1;

	_totalLines = 0;

	size_t size = _doc.getStringSize();

	if( size==0 ) return;

	if( _wrap == false )
	{
		// ܂ԂȂ̏ꍇ
		// C++ ȂAcomment tO𒲂ׂȂƂ
		if( 1==getHighlightType() )
		{
			bool cmt = false;
			size_t npos = String::npos;
			for(size_t i=0; i<size; i++)
			{
				// Ă
				const String& s = _doc.getString( i );
				size_t pos1 = s.find( _kwds.getBeginBlockComment() );
				size_t pos2 = s.find( _kwds.getEndBlockComment() );

				_vLI.push_back( LineInfo(cmt) );
				_totalLines++;
				// quote `FbN
				bool b1 = checkQuote(s,pos1), b2 = checkQuote(s,pos2);
				if( b1 && b2 )
					if( pos1!=npos && pos2==npos ) cmt = true;
				if( b2 )
					if( cmt==true && pos2!=npos )
						if( pos1==npos || pos1 < pos2 ) cmt = false;
			}
		}
		else
		{
			for(size_t i=0; i<size; i++)
				_totalLines++, _vLI.push_back( LineInfo() );
		}
	}
	else
	{
		// ܂Ԃ̏ꍇ

		// EBhẺE[
		if( _wrapwidth==0 )
			r.right -= getStringWidth(String(_T("   ")), 3);
		else
			r.right = getStringWidth(String(_T(" ")), 1) * _wrapwidth;

		int *w = (int*)::LocalAlloc( LPTR, (65536)*sizeof(int) );
		for(size_t i=0; i<size; i++)
		{
			// Ă
			const String& s = _doc.getString( i );

			size_t ssize = s.w_str().size();
			_vLI.push_back( LineInfo() );
			_totalLines++;
			// ڂ܂ԂɂȂ邩Zbg
			// new ~ delete ͒xH
			// LocalAlloc ɂǂH
//			int *w = new int[ ssize+1 ];
//			int *w = (int*)::LocalAlloc( LPTR, (ssize+1)*sizeof(int) );
			getTabbedTextExtent( s, ssize, w );
			for( int j=0, diff=0; j<(int)ssize; j++)
			{
				if( w[j] >= r.right+diff )
				{
					_vLI[i].push_back( j-1 );
					diff = w[j-2];
					_totalLines++;
				}
			}
//			delete [] w;
//			::LocalFree( w );
		}
		::LocalFree( w );
	}
}

bool PaintTool::updateWrapInfoPartial(int start, int size, bool bErase)
{
	if( _wrap == false )
	{
		// ܂ԂȂ̏ꍇ
		// C++ ȂAcomment tO𒲂ׂȂƂ
		if( 1==getHighlightType() )
		{
			bool cmt = false, bChanged=false;
			size_t npos = String::npos;
			size_t ssize= _doc.getStringSize();
			vector<LineInfo>::iterator itr = _vLI.begin();
			int i;
			for(i=0; i<start; i++) ++itr;
			for(i=start; i<start+size; i++)
			{
				// Ă
				const String& s = _doc.getString( i );
				size_t pos1 = s.find( _kwds.getBeginBlockComment() );
				size_t pos2 = s.find( _kwds.getEndBlockComment() );

				if( i!=0 ) cmt = _vLI[i].getComment();

				if( i==start )
					_vLI[i] = LineInfo( cmt );
				else
					_vLI.insert( itr, LineInfo(cmt) ), _totalLines++;

				// quote `FbN
				bool b1 = checkQuote(s,pos1), b2 = checkQuote(s,pos2);
				if( b1 && b2 )
				{
					if( pos1!=npos && pos2==npos )
					{ if(!cmt) bChanged=true; cmt = true; }
//					if( pos1==npos && pos2!=npos )
//					{ bChanged=true; }
				}
				if( b2 )
				{
					if( cmt==true && pos2!=npos )
					{ if(cmt) bChanged=true; cmt = false; }
					if( cmt==false && pos2!=npos )
					{ bChanged=true; }
				}
			}
			if( bChanged ){ updateWrapInfo(); return true; }
			else          {                   return false;}
		}
		else
		{
			vector<LineInfo>::iterator itr = _vLI.begin();
			for(int i=0; i<start; i++ ) ++itr;
			if( bErase==true )
			{
				vector<LineInfo>::iterator itr2 = itr; ++itr2;
				_vLI.erase(itr2);
			}
			for( i=start+1; i<start+size; i++ )
				_totalLines++, _vLI.insert( itr, LineInfo() );
		}
	}
	else
	{
		// ܂Ԃ̏ꍇ

		RECT r; getTextAreaRect( &r );

		if( _wrapwidth==0 )
			r.right -= getStringWidth(String(_T("   ")), 3);
		else
			r.right = getStringWidth(String(_T(" ")), 1) * _wrapwidth;

//		r.right -= getStringWidth(String(_T("   ")), 3);
		int *w = (int*)::LocalAlloc( LPTR, 65536*sizeof(int) );

		vector<LineInfo>::iterator itr = _vLI.begin();
		for(int i=0; i<start; i++ ) ++itr;
		for(i=start; i<start+size; ++i, ++itr)
		{
			// Ă
			const String& s = _doc.getString( i );

			// ܂ԂNA
			if( i==start )
			{
				_totalLines -= _vLI[i].wrapsize();
				_vLI[i].clear();
			}

			size_t ssize = s.w_str().size();
			if( i!=start )
			{
				itr = _vLI.insert( itr, LineInfo() );
				_totalLines++;
			}

			// ڂ܂ԂɂȂ邩Zbg
			// new ~ delete ͒xHLocalAlloc ɂǂH
			// ǁA[vOňx LocalAlloc 邱ƂɁB
			getTabbedTextExtent( s, ssize, w );
			for( int j=0, diff=0; j<(int)ssize; j++)
			{
				if( w[j] >= r.right+diff )
				{
					_vLI[i].push_back( j-1 );
					diff = w[j-2];
					_totalLines++;
				}
			}
//			delete [] w;
//			::LocalFree( w );
		}
		::LocalFree( w );
	}
	return false;
}

UINT PaintTool::getStringWidth(const String& s, UINT num)
{
	// getTabbedTextExtent gB
	if( num==0 ) return 0;
	if( num > s.w_str().size() ) return 0;
/*
	int *arWidth = new int[ s.w_str().size()+1 ];
	getTabbedTextExtent( s, num, arWidth );

	UINT width = (int)arWidth[num-1];
	delete [] arWidth;
*/
	getTabbedTextExtent( s, num, swtemp );
	UINT width = (UINT)swtemp[num-1];

	return width;
}

DWORD PaintTool::getTabbedTextExtent(const String& s, int num,
									int* arWidth)
{
	// ֐ƁA̕ƍԂ܂B
	// ߂l̏ʃ[hAʃ[h܂B
	// ֐sƁA0 Ԃ܂B
//	String s = _T("aa\treturn a;"); // Dummy
//	num = 5;

	// C(#56)F
	// num  8192 ȏ̒lA܂łvZȂB
	if( num==0 ){ return 0; }

	if( s.empty() ){ return 0; }

	// string::operator[] ̓N\x̂ŁA
	// ɑĂgB
//	TCHAR *tp = new TCHAR[ s.size()+1 ];
//	_tcscpy( tp, s.c_str() );

	// (#58)  new ̂͒x낤
	// ꎞ̈(tttemp)g
	_tcscpy(tttemp, s.c_str());

	SIZE size;
	::GetTextExtentExPointW( getDC(), 
		s.w_str().c_str(), s.w_str().size(),
//		tttemp, num,
		8192, NULL, arWidth, &size);

	// pXy[X̕
	SIZE space;
	::GetTextExtentPoint32( getDC(), _T(" "), 1, &space );
	int spaceWidth = space.cx; // pXy[X̕

	int    ntab = 0;
	int    tabWidth = spaceWidth * _tab;
	// num  size ̂ق傫 num H
	size_t n = (size_t)num > s.w_str().size() ? 
		s.w_str().size() : (size_t)num;
	// n  8192 ȏゾA8192 ܂łvZȂ
	n = n>8192 ? 8192 : n;

//	TCHAR *tpp = tp;
	TCHAR *tpp = tttemp;
	// ȉA^ulvZ
	for( size_t i=0; i<n; i++ )
	{
		if( *(tpp++) == _T('\t') ) 
		{
			int prevWidth = i==0 ? 0 : arWidth[i-1];
			ntab -= arWidth[i] + ntab - prevWidth;
			ntab += tabWidth - ( prevWidth % tabWidth );
		}
		arWidth[i] += ntab;
	}

	// ꎞGAj
//	delete [] tp;

	// num  s.size() 𒴂Ƃ̃G[`FbNȂ
	// CAł̊֐ŕKĂ̂͂ǂ˂
	if( (size_t)num-1 > s.w_str().size() )
		return 0;
	else
		return arWidth[num-1] + ( _f.lfHeight << 8 );
}

bool PaintTool::checkQuote(const String& s, size_t n)
{
	size_t pos = 0;
//	bool   retcode = true;
	// quote Ȃ false, ȊOȂ true
	while(1)
	{
		pos = s.find( _T('\"'), pos==0 ? 0:pos+1 );
		if( pos!=String::npos && n < pos ) break;
		if( pos==String::npos ) break;

		pos = s.find( _T('\"'), pos+1 );
		if( n < pos ) return false;
		if( pos==String::npos ) break;
	}
	pos = 0;
	while(1)
	{
		pos = s.find( _T('\''), pos==0 ? 0:pos+1 );
		if( pos!=String::npos && n < pos ) break;
		if( pos==String::npos ) return true;

		pos = s.find( _T('\''), pos+1 );
		if( n < pos ) return false;
		if( pos==String::npos ) return false;
	}
	return true;
}

int PaintTool::countLB( const String& ss )
{
	int nb = 0;
	String s = ss.c_str();
	size_t npos = 0, rpos = 0;

	while(1)
	{
		npos = s.find( _T('\n'), npos==0 ? 0 : npos+1 );
		rpos = s.find( _T('\r'), rpos==0 ? 0 : rpos+1 );
	
		if( npos == String::npos && rpos == String::npos )
			break;

		if( npos != String::npos ) nb++;
		if( npos != String::npos )
			if( rpos != npos-1 ) nb++;
	}
	return nb;
}

void PaintTool::setSel(const POINT* begin, const POINT* end)
{
	if( begin != NULL )
		_selected.begin.x = begin->x,
		_selected.begin.y = begin->y;
	if( end   != NULL )
		_selected.end.x   = end->x,
		_selected.end.y   = end->y;

	// ͈͑IȂ̂ begin  end 肵
	// Zbg
//	if( _selected.begin.y == _selected.end.y &&
//		_selected.begin.x == _selected.end.x )
//		clearSel();
}

void PaintTool::getSel(POINT* begin, POINT* end)
{
	if( begin != NULL )
		begin->x = _selected.begin.x, 
		begin->y = _selected.begin.y;
	if( end   != NULL )
		end->x   = _selected.end.x,
		end->y   = _selected.end.y;
}

void PaintTool::clearSel()
{
	_selected.begin.x = -1; _selected.begin.y = -1;
	_selected.end.x   = -1; _selected.end.y   = -1;
}

void PaintTool::setSearch(POINT* begin, POINT* end,
							const String& str)
{

	String ss = str;
	SELECTED s={begin->x, begin->y, end->x, end->y};

	_vSch.push_back(s);
	_vSchStr.push_back(str);
//	_mSch.insert( pair<SELECTED, String>(s, ss) );

}

void PaintTool::getSearch(size_t i,
	POINT* b, POINT* e, String& str)
{
	SELECTED s =_vSch.at(i);
	b->x = s.begin.x, b->y = s.begin.y,
	e->x = s.end.x,   e->y = s.end.y;

	str = _vSchStr.at(i);
}

void PaintTool::correctSearch(UINT y, int n)
{
	// _vSch ̂Ay Ԗڂ̂̂̕
	// n 炷B
	vector<SELECTED>::iterator i = _vSch.begin(),
						  itrEnd = _vSch.end();
	for( ; i!=itrEnd; ++i )
	{
		if( (*i).begin.y==(int)y )
			(*i).begin.x += n,
			(*i).end.x   += n;
	}
}

void PaintTool::eraseSearch(size_t y)
{
	vector<SELECTED>::iterator i = _vSch.begin();
	for( size_t n=0; n<y; n++ ) ++i;
	_vSch.erase( i );
}

const SELECTED 
PaintTool::getNearestSearchPoint(const POINT& p, bool bPrev, int* n)
{
	size_t ssize = getSearchSize();
	SELECTED sel;

	if( bPrev==false )
	{
		// ɌĒT
		for( size_t i=0; i<ssize; i++ )
		{
			POINT p1,p2;
			getSearch(i,&p1,&p2);
			if( p1.y <  p.y ) continue;
			if( p1.y == p.y )
				if( p1.x < p.x ) continue;
//			return p1;
			sel.begin = p1; sel.end = p2;
			if( n!=NULL ) *n = i;
			return sel;
		}
	}
	else
	{
		// OɌĒT
		for( size_t i=ssize-1; (int)i>=0; i-- )
		{
			POINT p1,p2;
			getSearch(i,&p1,&p2);
			if( p1.y >  p.y ) continue;
			if( p1.y == p.y )
				if( p1.x >= p.x ) continue;
//			return p1;
			sel.begin = p1; sel.end = p2;
			if( n!=NULL ) *n=i;
			return sel;
		}
	}

	// Ȃ -1 Ԃ
	POINT pe={-1,-1};
	sel.begin=pe, sel.end=pe;
	if( n!=NULL ) *n = -1;
	return sel;
}

