
#ifndef _NTPEDIT_PAINTTOOL_H_
#define _NTPEDIT_PAINTTOOL_H_

#include "doc.h"
#include <map>

namespace ntpedit{

//@{
// ǂŐ܂ԂĂ邩A̍s
// ubNRgǂ
// sPʂŕێB
//@}
class LineInfo
{
public:
	LineInfo(bool comment);

public:
	bool getComment() const;
	void setComment(bool c);

	const size_t wrapsize() const;
	int& operator [](size_t i);
	int operator [](size_t i) const;
//	int operator[](size_t i);

	void push_back(int v);
	void clear();

private:
	//@{ ڂŐ܂ԂĂ邩ێB //@}
	//@{ ܂ԂȂƂA0 ͕KvȂB //@}
	vector<int> _vWrap;
	//@{ Rgǂ̃tOB
	//  /* Ƃ - 
	//     s */  false, łȂ true
	//  O̍s true ̂Ƃ - 
	//     */ Ȃ true, łȂ false
	//  */ Ƃ - true
	//  ȊO - false
	//
	//  ܂ԂT|[gƂA
	//  vector<bool> ͔邱ƁB
	//@}
	bool _comment;
};

//----------------------------------------------------
inline LineInfo::LineInfo(bool comment=false)
	:_comment(comment)
{}

inline bool LineInfo::getComment() const
	{ return _comment; }

inline void LineInfo::setComment(bool c)
	{ _comment = c; }

inline const size_t LineInfo::wrapsize() const
	{ return _vWrap.size(); }

inline int& LineInfo::operator [](size_t i)
	{ return _vWrap.at( i ); }
//	{ return _vWrap[i]; }

inline int LineInfo::operator [](size_t i) const
	{ return _vWrap.at( i ); }
//	{ return _vWrap[i]; }

inline void LineInfo::push_back(int v)
	{ _vWrap.push_back(v); }

inline void LineInfo::clear()
	{ _vWrap.clear(); }

//----------------------------------------------

struct SELECTED
{
	POINT begin;
	POINT end;
//	size_t operator[](size_t i){};
};

struct KEYWORDS
{
	void setLineComment(const TCHAR* s)
		{ _lCmt = s; }

	const String& getLineComment() const
		{ return _lCmt; }

	void setBlockComment(const TCHAR* begin,
						const TCHAR* end)
		{ _bCmt[0] = begin, _bCmt[1] = end; }

	const String& getBeginBlockComment() const
		{ return _bCmt[0]; }

	const String& getEndBlockComment() const
		{ return _bCmt[1]; }

	void setKeyword(const TCHAR* s)
		{ _vKwd.push_back( String(s) ); }

	size_t getKeywordSize(void) const
		{ return _vKwd.size(); }

	const String& operator[](size_t i) const
		{ return _vKwd.at(i); }
//		{ return _vKwd[i]; }
/*
	vector<String>::iterator begin()
		{ return _vKwd.begin(); }

	vector<String>::const_iterator begin() const
		{ return _vKwd.begin(); }

	vector<String>::iterator end()
		{ return _vKwd.end(); }

	vector<String>::const_iterator end() const
		{ return _vKwd.end(); }
*/
	void clear()
	{ 
		_lCmt=_T(""), _bCmt[0]=_T(""), _bCmt[1]=_T("");
		_vKwd.clear();
	}

private:
	String _lCmt;
	String _bCmt[2];
	vector<String> _vKwd;
};

// PaintTool
// f[^ێB
// HDC, FONT, s, view rect, area rect,
// ʂɉs`ł邩A
// Í͈B
class PaintTool
{
public:
	PaintTool(Doc& d, HWND h);
	~PaintTool();

public:
	//@{ FONT //@}
	void setFont(LOGFONT& lf);
	void setFont(LPCTSTR name, int fsiz, int tab);
	void registerFont();
	LOGFONT& getFont();
	//@{ `ɂtHg //@}
	int getFontHeight();
	//@{ ݒɂtHg //@}
	// Ieł̒lĂ΂
	// editctrl ł͕ێȂ
//	int getFontHeightSetting();

	//@{ F //@}
	COLORREF getColor( int code ) const;
	void     setColor(COLORREF* c);

	//@{ 䕶 //@}
	void     setCtrlMark(bool* b);
	bool     getCtrlMark( int code ) const;

	//@{ s //@}
	int  getLineSpace();
	void setLineSpace(int s);

	//@{ sԍGA //@}
	void setLineNumArea(bool b);

	//@{ EBhEɉs`\ //@}
	int getLines();
	//@{ SŉsɂȂ̂ //@}
	int getTotalLines();

	//@{ ܂Ԃ //@}
	void setWrap( bool b, int width=0 );
	bool getWrap();

	//@{ HDC, RECT //@}
	HDC  getDC();
	void getClientRect(LPRECT rc);
	void getLineNumRect(LPRECT rc);
	void getTextAreaRect(LPRECT rc);

	//@{ LineInfo //@}
	void updateWrapInfo();
	bool updateWrapInfoPartial(int start, int size, bool bErase=false);
	LineInfo& getLineInfo(UINT i);

	//@{ tab //@}
//	void setTabSize(int n);
	int  getTabSize();

	//@{ XN[ //@}
	int getHScrollUnitSize();

	//@{  //@}
	DWORD getTabbedTextExtent(const String& s, int num,
							int* arWidth);
	UINT getStringWidth(const String& s, UINT num);

	//@{ keywords //@}
	KEYWORDS& getKeywords();

	//@{ HTML-mode //@}
	void setHighlightType(int n);
	int  getHighlightType(void);

	//@{ ̑ //@}
	bool checkQuote(const String& s, size_t n);
	int  countLB( const String& s );

	//@{ ͈͑I //@}
	void setSel(const POINT* begin, const POINT* end);
	void getSel(POINT* begin, POINT* end);
	void clearSel();

	//@{  //@}
	void setSearch(POINT* b, POINT* e, 
		const String& s=String(""));
	void getSearch(size_t i, POINT* b, POINT* e,
		String& s=String(""));
	void clearSearch();
	size_t getSearchSize();
	void correctSearch(UINT y, int n);
	void eraseSearch(size_t y);
	const SELECTED 
	getNearestSearchPoint(const POINT& p, 
		bool bPrev=false, int* n=NULL);

	//@{ ǂݎp //@}
	void setReadOnly(bool flag);
	bool getReadOnly();

public:
	//@{ F敪 //@}
	enum ColorType{ TXT=0, CMT, KWD, //,
		CTL=4, BG };
	//@{ 䕶敪 //@}
	enum{ ctlZSP, ctlHSP, ctlTAB, ctlEOL, ctlEOF };

private:
	Doc&     _doc;
	HWND     _vwnd;
	HDC      _hdc;
	LOGFONT  _f;
	HFONT    _hf, _oldhf;
	int      _fHeight; //ݒłpt
	int      _lines;
	int      _totalLines;
	int      _lineSpace;
	int      _lineNumWidth;
	int      _hScrollUnitSize;
	int      _tab;
	bool     _wrap;
	int      _wrapwidth;
	SELECTED _selected;
	COLORREF _color[6];
	vector<LineInfo> _vLI;
	KEYWORDS _kwds;
	//@{ 0:highlightȂ, 1:C++, 2:html //@}
	int      _htype;
	bool     _ctl[5];
	vector<SELECTED> _vSch;
	vector<String>   _vSchStr;
//	map<SELECTED, String> _mSch;
	//@{ getStringWidthpꎞ̈ //@}
	int* swtemp;
	//@{ getTabbedTextExtentpꎞ̈ //@}
	TCHAR* tttemp;
	//@{ ǎptOBꂪ true ̂Ƃ
	//   ͂󂯕tȂ //@}
	bool _readonly;
};

//-----------------------------------------------
inline PaintTool::PaintTool(Doc& d, HWND h)
:_doc(d), _vwnd(h), _hdc( ::GetDC(_vwnd) )
,_lineNumWidth(52), _wrap(true), _wrapwidth(0)
,_lineSpace(0), _lines(0), _totalLines(0)
,_hf(NULL), _oldhf(NULL), _htype(0), _fHeight(0)
,_readonly(false), _hScrollUnitSize(0)
{
	_selected.begin.x=-1,_selected.begin.y=-1;
	_selected.end.x=-1,_selected.end.y=-1;
	swtemp = new   int[16385];
	tttemp = new TCHAR[16385];
	memset( swtemp, 0, 16385*sizeof(int));
	memset( swtemp, 0, 16385*sizeof(TCHAR));
}

inline PaintTool::~PaintTool()
{
	if( _oldhf!=NULL )
	{
		::SelectObject(_hdc, _oldhf);
		::DeleteObject(_hf);
	}
	::ReleaseDC(_vwnd, _hdc);
	delete [] swtemp;
	delete [] tttemp;
}

inline LOGFONT& PaintTool::getFont()
	{ return _f; }

inline void PaintTool::setFont(LOGFONT& lf)
	{ _f = lf; registerFont(); }

inline int PaintTool::getFontHeight()
	{ return abs(_f.lfHeight); }

//inline int PaintTool::getFontHeightSetting()
//	{ return _fHeight; }

inline COLORREF PaintTool::getColor( int code ) const
	{ return _color[code]; }

inline bool PaintTool::getCtrlMark( int code ) const
	{ return _ctl[code]; }

inline int PaintTool::getLineSpace()
	{ return _lineSpace; }

inline void PaintTool::setLineSpace(int s)
	{ _lineSpace = s; }

inline void PaintTool::setLineNumArea(bool b)
{
	// sԍČvZ
	_lineNumWidth = b==true ? 
		getStringWidth( String(_T("00000")), 5 ) : 0;
}

inline int PaintTool::getLines()
	{ return _lines; }

inline int PaintTool::getTotalLines()
	{ return _totalLines; }

inline int PaintTool::getHScrollUnitSize()
	{ return _hScrollUnitSize; }

//inline void PaintTool::setTabSize(int n)
//	{ _tab = n; }

inline int PaintTool::getTabSize()
	{ return _tab; }

inline void PaintTool::setWrap( bool w, int width )
{
	_wrap = w;
	if( width!=-1 ) _wrapwidth=width;
}

inline bool PaintTool::getWrap()
	{ return _wrap; }

inline HDC PaintTool::getDC()
	{ return _hdc; }

inline void PaintTool::getClientRect(LPRECT rc)
	{ ::GetClientRect( _vwnd, rc ); }

inline LineInfo& PaintTool::getLineInfo(UINT i)
{ 
#ifdef _DEBUG
	if( i >= _vLI.size() )
	{
		TCHAR tmp[64]={0};
		wsprintf( tmp, _T("PaintTool::getLineInfo Overflow. : i=%d, size()=%d\n"),
			i, _vLI.size() );
		OutputDebugString( tmp );
	}
#endif
	return _vLI.at( i );
}
//	{ return _vLI[i]; }

inline KEYWORDS& PaintTool::getKeywords()
	{ return _kwds; }

inline void PaintTool::setHighlightType(int n)
	{ _htype = n; }

inline int PaintTool::getHighlightType(void)
	{ return _htype; }

inline void PaintTool::clearSearch()
	{ _vSch.clear(), _vSchStr.clear(); }

inline size_t PaintTool::getSearchSize()
	{ return _vSch.size(); }

inline void PaintTool::setReadOnly(bool flag)
	{ _readonly = flag; }
	
inline bool PaintTool::getReadOnly()
	{ return _readonly; }

} //namespace ntpedit
#endif //_NTPEDIT_PAINTTOOL_H_

