
#ifndef _NTPEDIT_VIEW_H_
#define _NTPEDIT_VIEW_H_

#include "doc.h"
#include "caret.h"
#include "basepainter.h"

//using namespace uelib;

namespace ntpedit{

//@{
// view ́A܂łbZ[W̕zA
// Ƃ낾Aǂ܂ŉ䖝ł邱ƂB
//@}
class View : public uelib::Window
{
public:
	View( Doc& d, HWND wnd );
	~View();

public:
	PaintTool& getPaintTool();
	Caret&     getCaret();
	Scroll&    getScroll();
	void       setHandler(HWND w);

public:
	//@{ for Azukimochi //@}
	void replacePainter(BasePainter* p);
	void deletePainter();

private:
	void onCreate();
	void onDestroy();
	LRESULT onMessage( UINT msg, WPARAM wp, LPARAM lp );
	bool onCommand(UINT id, HWND ctrl);

private:
	Doc&                _doc;
	auto_ptr<PaintTool> _tool;
	auto_ptr<Scroll>    _scroll;
	auto_ptr<Caret>     _caret;
//	auto_ptr<BasePainter>   _p;
	BasePainter *_p;
	HWND _parent;
	HWND _wndHandler;
};

//------------------------------------------------
inline PaintTool& View::getPaintTool()
	{ return *_tool; }

inline Caret& View::getCaret()
	{ return *_caret; }

inline Scroll& View::getScroll()
	{ return *_scroll; }

inline void View::setHandler(HWND w)
	{ _wndHandler = w; }

} //namespace ntpedit
#endif
