
#include "stdafx.h"

#include <commctrl.h>
#include <commdlg.h>
#ifndef _WIN32_WCE
  #include <crtdbg.h>
#endif

#include "..\uelib2\uelib.h"
#include "ntpmain.h"
#include "ntpdlg.h"
#include "ntpsearch.h"
#include "resource.h"

using namespace uelib;
using namespace ntpedit;

#define WM_HTMLUPDATED  WM_USER+300
#define WM_HTMLPARSEEND WM_USER+301
#define WM_HTMLLINK     WM_USER+302
#define WM_HTMLLINKURI  WM_USER+303
#define WM_HTMLGETURI   WM_USER+304
#define WM_HTMLREDIRECT WM_USER+305

#define WM_TEXTUPDATED  WM_USER+310
#define WM_SHOWPOPUP    WM_USER+311

//------------------------------------------------
// class Ntp ̃\bĥA
// Cxgnh͂B
// ȊO ntpmain2.cpp ɁB
//------------------------------------------------

Ntp::Ntp()
	:Window( _T("NTP2 MAINWND"), WS_OVERLAPPEDWINDOW/*WS_VISIBLE*/, 0 )
	,_e()
	,_modified( false ), _hDLL(NULL)
	,_hwndCB(NULL) ,_hCombo(NULL), _hCEdit(NULL)
	,_buf(NULL), _cpos(-1)
	,_csEncode(charset(0)), _csLB(Txt::lbcode(0))
{
	static WNDCLASS wc={0};
	wc.hIcon         = ::LoadIcon( _hInst, MAKEINTRESOURCE(IDI_ICON1) );
	wc.hCursor       = ::LoadCursor( BaseWindow::_hInst, IDC_ARROW );
	wc.lpszClassName = _className;

#ifndef _WIN32_WCE
	wc.lpszMenuName  = MAKEINTRESOURCE( IDR_MENU1 );
#endif

	registerWnd( &wc );
}

//-----------------------------------------------------------------
Ntp::~Ntp()
{
	_e.getView().deletePainter();
	if( _hDLL!=NULL )
	{ deleteImage(); onHTMLParseEnd(-1); releaseDLL(); }
	if( _buf!=NULL ) delete [] _buf;
}

//-----------------------------------------------------------------
bool Ntp::preTranslateMessage(MSG* m)
{
	if( 0 != ::TranslateAccelerator( getHwnd(), _accel, m ) )
		return true;
	if( _hCombo==NULL ) return false;
	if( m->message==WM_KEYDOWN && 
		m->wParam == VK_RETURN &&
		m->hwnd == _hCEdit )
	{
		onOpenURI();
		return true;
	}
	return false;
}

//-----------------------------------------------------------------
void Ntp::onCreate()
{
	// ANZ[^̃[h
	_accel = ::LoadAccelerators(_hInst, MAKEINTRESOURCE(IDR_ACCELERATOR1));
	// NeBJZNV̏
	::InitializeCriticalSection(&_cs);

	// comctl 
	INITCOMMONCONTROLSEX icc={sizeof(INITCOMMONCONTROLSEX)};
	icc.dwICC = ICC_BAR_CLASSES|ICC_COOL_CLASSES|ICC_UPDOWN_CLASS;
	::InitCommonControlsEx( &icc );

	// GfBbgRg[쐬
	_e.create( _T("ntp2edit"), getHwnd() );
	_e.show();

	PaintTool& t = _e.getPaintTool();

	// [hʃR}ho[̐
	Argv a;
	if( a.size()>=1 && 0==_tcscmp(a[0], _T("-az")) )
	{
		// azukimochi mode
		// DLL [hɐA
		// View::replacePainter 
		// URI \pR{p
		loadDLL();
		startAZMode();
		setWrapType( IDM_WRAP1 );
		t.setReadOnly( true );
	}
	else
	{
		onCreatePD();
	}

	// [^Cv]j[̐
	createDocTypeMenu();

	TCHAR temp[MAX_PATH+1];
	uelib::GetCurrentDirectory( MAX_PATH, temp );
	String s = temp;
	// L[[h̃^Cvǂ̂Ƃ
	// editctrlł͕ێȂB
	// Ie 6 ̐FƂЂ
	// 邱ƁB
	String cdir = s+_T("\\type\\default.lay");
	if( !readLay( cdir ) )
	{
		COLORREF cl[6]={ RGB(  0,  0,  0), RGB(  0,  0,  0),
						 RGB(  0,  0,  0), RGB(  0,  0,  0),
						 RGB(  0,  0,  0), RGB(255,255,255) };
		t.setColor( cl );
		t.setWrap( true );
//		t.setFont( _T("FixedSys"), 14, 4 );
		t.setFont( _T("lr SVbN"), 14, 4 );
		bool b[5] = { false, false, true, true, true };
		t.setCtrlMark( b );
	}

	// DocType [W]
	setDocType( 20000 );
	t.setHighlightType( 0 );

	// ini ǂ
	Ini ini( _T("n12k2.ini") );
	_cf.filter = ini.readString(_T("USER"), _T("TxtFilter"));
	_cf.undo   = ini.readInt(_T("USER"), _T("UndoLimit"));

	RECT r;
	t.getLineNumRect( &r );
	Caret& c = _e.getView().getCaret();
	c.create( t.getFontHeight() ); c.setPos( r.right, 0 );
	c.show();

	// Ńt@CJǂ߂
	if( a.size()>=1 )
	{
		String sa0 = a[0];
		if( sa0.empty() || sa0==_T("-az") ||
			!openFile( sa0 ) )
			onNew();
	}
	else
	{
		onNew();
	}

	_e.getView().setHandler( getHwnd() );
	// Undo l 0 Ȃ狭I 20 ܂ňグ
	_e.getDoc().setUndoLimit( _cf.undo==0 ? 20 : _cf.undo );
	setWindowTitle();
}

//-----------------------------------------------------------------
void Ntp::onDestroy()
{
#ifndef _DEBUG
	if( _modified )
	{
		int rc = ::MessageBox( getHwnd(), 
			_T("݂̕ۑ܂H"), 
			_T("n12k2"),
			MB_YESNO|MB_ICONINFORMATION );
//		if( rc==IDCANCEL ) return;
		if( rc==IDYES ) onSave();
	}
#endif
	::DeleteCriticalSection(&_cs);
	onDestroyPD();
	Window::onDestroy();
}

//-----------------------------------------------------------------
bool Ntp::onCommand(UINT id, HWND ctrl)
{
	switch( id )
	{
	// [t@C] j[
	case IDA_NEW:
	case IDM_NEW:
		onNew();
		break;
	case IDA_OPEN:
	case IDM_OPEN:
		onOpen();
		break;
	case IDA_REOPEN:
	case IDM_REOPEN:
		onReOpen();
		break;
	case IDA_SAVE:
	case IDM_SAVE:
		onSave();
		break;
	case IDM_SAVEAS:
		onSaveAs();
		break;
	case IDM_EXIT:
		::SendMessage( _hwnd, WM_CLOSE, 0, 0L );
		break;

	// [ҏW] j[
	case IDA_UNDO:
	case IDM_UNDO:
	case IDMP_UNDO:
		_e.getView().getCaret().undo();
		break;
	case IDA_CUT:
	case IDM_CUT:
	case IDMP_CUT:
		_e.getView().getCaret().cut();
		if( !_modified ) 
			::PostMessage( getHwnd(), WM_TEXTUPDATED, 0, 0L );
		break;
	case IDA_COPY:
	case IDM_COPY:
	case IDMP_COPY:
		_e.getView().getCaret().copy();
		if( !_modified ) 
			::PostMessage( getHwnd(), WM_TEXTUPDATED, 0, 0L );
		break;
	case IDA_PASTE:
	case IDM_PASTE:
	case IDMP_PASTE:
		_e.getView().getCaret().paste();
		if( !_modified ) 
			::PostMessage( getHwnd(), WM_TEXTUPDATED, 0, 0L );
		break;
	case IDA_SELECTALL:
	case IDM_SELECTALL:
	case IDMP_SELECTALL:
		_e.getView().getCaret().selectAll();
		break;

	// []j[
	case IDA_SEARCH:
	case IDM_SEARCH:
		onSearch();
		break;
	case IDA_SEARCHNEXT:
	case IDM_SEARCHNEXT:
		onSearchNext(true);
		break;
	case IDA_SEARCHPREV:
	case IDM_SEARCHPREV:
		onSearchNext(false);
		break;
	case IDM_SEARCHCLEAR:
		_e.getPaintTool().clearSearch();
		::InvalidateRect( _e.getView().getHwnd(),
			NULL, FALSE );
		break;
	case IDM_JUMP:
		onJump();
		break; 

	// ܂Ԃ
	case IDA_WRAP1:
	case IDA_WRAP2:
	case IDA_WRAP3:
	case IDM_WRAP1:
	case IDM_WRAP2:
	case IDM_WRAP3:
		setWrapType( id );
		break;

	// ȉAAzukimochi p
	case IDB_BACK:
		onBackURI(); break;
	case IDB_NEXT:
		onNextURI(); break;
	case IDB_STOP:
		onStopURI(); break;
	case IDB_RELOAD:
		onReloadURI(); break;
	case IDB_BOOKMARK:
		onBookmarkURI(ctrl); break;
	case IDB_ENCODE:
		onEncodeURI(ctrl); break;
	case IDM_ENCODE_AUTO:
	case IDM_ENCODE_EUC:
	case IDM_ENCODE_JIS:
	case IDM_ENCODE_SJIS:
	case IDM_ENCODE_UTF8:
		setEncode( id );
		break;
	default:
		// bookmark ǉ
		if( id == 39998 )
			addBookmark();
		// bookmark 
		else if( id == 39999 )
			openBookmarkDir();
		// Azukimochi Bookmark p
		else if( id >= 30001 && id <= 39999 )
			readURLFile(id);
		// DocType p
		else if( id >= 20000 && id <= 29999 )
			setDocType(id);
		break;
	}
	return false;
}

//-----------------------------------------------------------------
LRESULT Ntp::onMessage( UINT msg, WPARAM wp, LPARAM lp )
{
	switch( msg ){
	case WM_ACTIVATE:
		if( LOWORD(wp) != WA_INACTIVE )
			_e.setFocus();
		break;

	case WM_SIZE:
		if( wp != SIZE_MINIMIZED )
		{
#ifdef _WIN32_WCE
			int height = CommandBar_Height( _hwndCB );
#else
			int height = _hwndCB==NULL ? 0 : 25;
//			int height = 0;
			::SendMessage( _hwndCB, WM_SIZE, wp, lp );
#endif
			_e.moveTo( 0, height, LOWORD(lp), HIWORD(lp) );
		}
		break;

	case WM_NOTIFY:
		onNotify(wp, lp);
		break;

	// View ł郁bZ[W
	case WM_TEXTUPDATED:
		onTextUpdated();
		break;
	case WM_SHOWPOPUP:
		onShowPopup( LOWORD(lp),HIWORD(lp) );
		break;

	// Azukimochi p
	case WM_HTMLUPDATED:
		onHTMLUpdated( wp, (TCHAR*)lp );
		break;
	case WM_HTMLPARSEEND:
		onHTMLParseEnd(wp);
		break;
	case WM_HTMLLINK:
		onHTMLLink(lp);
		break;
	case WM_HTMLLINKURI:
		onHTMLLinkURI(lp);
		break;
	case WM_HTMLGETURI:
		onHTMLGetURI(lp);
		break;
	case WM_HTMLREDIRECT:
		onHTMLRedirect(lp);
		break;

	default:
		return Window::onMessage( msg, wp, lp );
	}

	return 0;
}

//-----------------------------------------------------------------
void Ntp::onNew()
{
	_e.getDoc().newDocument();
	_e.getView().getCaret().reset();
	_e.getPaintTool().clearSearch();
	_e.getPaintTool().clearSel();
	_e.getPaintTool().updateWrapInfo();
	_e.getView().getScroll().reset();
//	::InvalidateRect( getHwnd(), NULL, FALSE );
	::SendMessage( _e.getHwnd(), WM_SIZE, 0, 0 );

	_filename = _T("");
	_modified = false;
	setWindowTitle();
}

//-----------------------------------------------------------------
void Ntp::onOpen()
{
	TCHAR temp[MAX_PATH+1]={0};
	static String initDir=_T("");
/*
	uelib::GetCurrentDirectory( MAX_PATH, temp );
	String s = temp;
	_tcscpy(temp, _T(""));
*/
	OPENFILENAME of={sizeof(OPENFILENAME)};
	of.hwndOwner       = getHwnd();
	of.lpstrInitialDir = initDir.c_str();
	of.lpstrFile       = temp;
	of.nMaxFile        = MAX_PATH;
	of.Flags           = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
//	of.lpstrFilter     = _T("txt (*.txt)\0*.txt\0") \
//						 _T("ׂẴt@C (*.*)\0*.*\0\0");

	if(!::GetOpenFileName( &of ))
		return;

	initDir = of.lpstrFile;
	size_t pos = initDir.find_last_of( _T('\\') );
	initDir = initDir.substr(0, pos);

	openFile( String(of.lpstrFile) );
}

//-----------------------------------------------------------------
void Ntp::onReOpen()
{
	// GR[h`Ĩ_CAOo
	EncodeDlg d(true);
	d.doModal(getHwnd());

	// IR[h OK==1
	UINT n = d.endCode();
	if( n!=1 ) return;

	// IꂽGR[h`擾
	int cs = d.getSel(1);
	_csLB  = (Txt::lbcode)d.getSel(2);
	// ꂼɒu
	_csEncode = EncodeDlg::getEncodeType(cs);

	openFile( _filename, _csEncode );
}

//-----------------------------------------------------------------
void Ntp::onSave()
{
	// untitled Ȃ疼Otĕۑ
	if( _filename.empty() )
	{
		onSaveAs();
		return;
	}
	TxtEncoder e( _csEncode, _csLB );
	_e.getDoc().write( e, _filename.c_str() );

	_modified = false;
	setWindowTitle();
}

//-----------------------------------------------------------------
void Ntp::onSearch()
{
	SearchManager m(_e);
	m.doModeless( getHwnd() );
	m.show();
	m.msgLoop();
}

//-----------------------------------------------------------------
void Ntp::onSearchNext(bool bNext)
{
	Caret&     c = _e.getView().getCaret();
	PaintTool& t = _e.getPaintTool();

	// ݈ʒu
	POINT pt = c.getAbsPoint();
	POINT p1,p2; t.getSel(&p1,&p2);

	if( p1.y != -1 )
		pt = bNext ? p2 : p1;

	// ݈ʒuł߂
	const SELECTED sel = t.getNearestSearchPoint(
							pt, !bNext, NULL );

	// ȂI
	if( sel.begin.y == -1 ) return;

	// ͈͑IāAjump āAĕ`
	t.setSel( &sel.begin, &sel.end );	
	c.jump(
		sel.begin.x, sel.begin.y+1,
		_e.getView().getScroll().getVStartPos() );
	::InvalidateRect( _e.getView().getHwnd(),
		NULL, FALSE );
}

//-----------------------------------------------------------------
void Ntp::onJump()
{
	JumpDlg d( _e.getDoc().getStringSize() );
	d.doModal( getHwnd() );

	if( 1 != d.endCode() ) return;

	_e.getView().getCaret().jump(0, d.getPos(),
		_e.getView().getScroll().getVStartPos() );
}

//-----------------------------------------------------------------
void Ntp::onSaveAs()
{
	// GR[h`Ĩ_CAOo
	EncodeDlg d(false);
	d.doModal(getHwnd());

	// IR[h OK==1
	UINT n = d.endCode();
	if( n!=1 ) return;

	// IꂽGR[h`擾
	int cs = d.getSel(1);
	int lb = d.getSel(2);
	// ꂼɒu
	_csLB = EncodeDlg::getLBType(lb);
	_csEncode = EncodeDlg::getEncodeType(cs);

	// t@CĨ_CAOo
	TCHAR fname[MAX_PATH*2] = {0};
	_tcscpy( fname, _filename.c_str() );
	OPENFILENAME of={sizeof(OPENFILENAME)};
	of.hwndOwner = getHwnd();
	of.lpstrFile = fname;
	of.nMaxFile  = MAX_PATH*2;
	of.Flags     = OFN_HIDEREADONLY    |
				   OFN_PATHMUSTEXIST   |
				   OFN_EXPLORER        |
				   OFN_OVERWRITEPROMPT;
	if( !GetSaveFileName(&of) ) return;

	_filename = fname;
	onSave();
}

//-----------------------------------------------------------------
void Ntp::onTextUpdated()
{
	if( !_modified )
	{
		// ǎpȂȂɂȂ
		if( _e.getPaintTool().getReadOnly() )
			return;

		// tO ON ɂ
		_modified = true;
		// ^Cgo[
		setWindowTitle();
	}
}

//-----------------------------------------------------------------
void Ntp::onShowPopup(int x, int y)
{
	HMENU hMenu    = ::LoadMenu( _hInst, MAKEINTRESOURCE( IDR_MENU_POPUP ) );
	HMENU hSubMenu = ::GetSubMenu(hMenu, 0);
	POINT pt={x,y}; ::ClientToScreen( getHwnd(), &pt );

	// ͈͑IĂȂA[؂][Rs[] ͖
	POINT p1,p2;
	_e.getPaintTool().getSel(&p1,&p2);
	if( p1.x==-1 || (p1.y==p2.y && p1.x==p2.x) )
		::EnableMenuItem( hSubMenu, IDMP_CUT,  MF_GRAYED ),
		::EnableMenuItem( hSubMenu, IDMP_COPY, MF_GRAYED );

	// Nbv{[hɃf[^Ȃ[\t]͖
	Clipboard cb( getHwnd() );
	if( !cb.isAvail(CF_UNICODETEXT) )
		::EnableMenuItem( hSubMenu, IDMP_PASTE, MF_GRAYED );

	::TrackPopupMenu(hSubMenu, TPM_LEFTALIGN,
		pt.x, pt.y, 0, getHwnd(), NULL);
	::DestroyMenu(hSubMenu);
}

//-----------------------------------------------

int ueMain()
{
	{
//	Argv a;
	Ntp n;
#ifdef _WIN32_WCE
	if( !n.create( _T("n12k2") ) ) return 1;
#else

  #ifdef _DEBUG
	if( !n.create( _T("n12k2"), NULL, 
		CW_USEDEFAULT, CW_USEDEFAULT, 
//		256, 173) ) return 1;
		256, 186) ) return 1;
  #else
	if( !n.create( _T("n12k2")) ) return 1;
  #endif

#endif
	n.show();
	n.msgLoop();
	}

#ifndef _WIN32_WCE
  #ifdef _DEBUG
//	_CrtDumpMemoryLeaks();
	_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF|_CRTDBG_LEAK_CHECK_DF);
  #endif
#endif

	return 0;
}

