
#ifndef _NTP2MAIN_H_
#define _NTP2MAIN_H_

#include <map>

//#include "NtpEdit\NtpEdit.h"
#include "ntpedit\editctrl.h"
using namespace ntpedit;

#ifdef _WIN32_WCE
  // ̂߂ǂŁA
  // Ă܂ցB
  #define WS_OVERLAPPEDWINDOW WS_VISIBLE
#endif

//----------------------------------------------
struct NtpConfig
{
	// .lay ̓e
	COLORREF cl[6];
	bool     ctl[5];
	int      ftsize;
	String   ftname;
	int      tab;
	int      wrap;
	int      wrapwidth;
	bool     linenum;

	// .ini ̓e
	int      undo;
	String   filter;
};

//----------------------------------------------

//@{
// ʃNXB
// ꂪ NtpEdit ƌĂ΂
// GfBbgRg[NXێA
// e탁\bhĂŃRg[B
//@}

class Ntp : public Window
{
public:
	Ntp();
	~Ntp();

private:
	bool preTranslateMessage(MSG* m);

	//@{ Cxgnh //@}
	void onCreate();
	void onDestroy();
	bool onCommand(UINT id, HWND ctrl);
	LRESULT onMessage( UINT msg, WPARAM wp, LPARAM lp );
	void onNew();
	void onOpen();
	void onReOpen();
	void onSave();
	void onSaveAs();
	void onSearch();
	void onSearchNext(bool bNext=true);
	void onJump();
	void onTextUpdated();
	void onShowPopup(int x, int y);

	//@{ for Azukimochi-mode //@}
	void onNotify(WPARAM wp, LPARAM lp);
	void onOpenURI(const TCHAR* uri=_T(""));
	void onOpenURI_POST(const TCHAR* uri=_T(""));
	void onHTMLUpdated(WPARAM wp, TCHAR* buf);
	void onHTMLParseEnd(WPARAM wp);
	void onHTMLLink(LPARAM lp);
	void onHTMLLinkURI(LPARAM lp);
	void onHTMLGetURI(LPARAM lp);
	void onHTMLRedirect(LPARAM lp);
	void onBackURI();    //@{ ߂ //@}
	void onNextURI();    //@{ i //@}
	void onStopURI();    //@{ ~ //@}
	void onReloadURI();  //@{ XV //@}
	void onBookmarkURI(HWND h);//@{ Cɓ //@}
	void onEncodeURI(HWND h);  //@{ GR[h //@}
	void setEncode(UINT);
	void sendLinkPos(bool bStart=false);
	bool count2pos(size_t c, POINT* p);
	void setCurrentURI( String& s );
	bool downloadFile( const String& s, size_t size );
	void deleteImage();
	int  createBookmarkMenu(TCHAR* dir, HMENU hm, int no);
	void readURLFile(UINT id);
	void addBookmark();
	void openBookmarkDir();
	void getBookmarkDirectory(TCHAR* dir);
	char*  getPostString( const TCHAR* uri );
	String encodeURI(const String& in);
	String getGetString( const TCHAR* uri );
	void getFormHidden( const String& s );
	void initAZDialog(size_t size, DWORD id);
	FARPROC getProcAddress(HMODULE hModule, LPCTSTR lpProcName);

private:
	//@{ @ˑ̏(Platform Dependent) //@}
	void  onCreatePD();
	void  onDestroyPD();
	void  startAZMode();
	HMENU getMenu();

private:
	//@{ ̑̏ //@}
	bool openFile(const String& fname, charset cs=charset(0));
	bool readKwd(const String& fname);
	bool readLay(const String& fname);
	ULONG strToHex(const String& s);
	ULONG strToRGB(const String& s);
	void createDocTypeMenu();
	void setDocType(int id);
	void setWrapType(int id);
	int  getDocTypeFromExt(const String& ext);
	bool compareExt(const String& ext, const String& pat);
	void setWindowTitle();

private:
	//@{ DLL֘A //@}
	bool loadDLL();
	void releaseDLL();

private:
	NtpEdit  _e;
	String   _filename;
	charset  _csEncode;
	Txt::lbcode _csLB;
	bool     _modified;
	NtpConfig _cf;
	HMODULE  _hDLL;
	HWND     _hCombo, _hCEdit;
	CRITICAL_SECTION _cs;
	HACCEL   _accel;
	HWND     _hwndCB;
	// for azukumochi-mode
	TCHAR    *_buf;
	map<LPARAM, String> _mlink; // Nۑp mapB
								// ꎞIȂ̂łȂB
	String   _cdir;
	vector<String> _vhistory;   // B
	int            _cpos;       // ɂ錻݂ URI ʒuB
	vector<String> _vimage;     // {摜B
	map<UINT, String> _mbookmark;// Cɓ̃t@C
								 // ID ̑gݍ킹B
	map<String, String> _mform;  // form pB
};

//-----------------------------------------------

inline bool Ntp::loadDLL()
{ 
#ifdef _WIN32_WCE
	_hDLL = ::LoadLibrary( _T("azukimochi.dll") );
#else
	_hDLL = ::LoadLibrary( _T("azuki\\debug\\azukimochi.dll") );
#endif
	return _hDLL==NULL ? false : true;
}

inline void Ntp::releaseDLL()
	{ ::FreeLibrary( _hDLL ); }

#endif
