
#include "stdafx.h"

#include <commctrl.h>
#include <commdlg.h>
#ifndef _WIN32_WCE
  #include <crtdbg.h>
#endif

#include "..\uelib2\uelib.h"
#include "ntpmain.h"
#include "resource.h"

using namespace uelib;
using namespace ntpedit;

//----------------------------------------------------
// ntpmain2.cpp
// class Ntp ̃\bĥACxgnhȊO
// B
//----------------------------------------------------

//---------------------------------------------------------------
bool Ntp::openFile(const String& fname, charset cs)
{
	TCHAR temp[MAX_PATH+1];
	uelib::GetCurrentDirectory( MAX_PATH, temp );
	String s = temp;

	// ㏑ۑ̂ƂɎĝŁA
	// t@CƃGR[hۑ
	_filename = fname;
	if( cs==charset(0) )
		_csEncode = Txt::autoDetect( fname.c_str(), &_csLB );

	// Jēǂ
	TxtDecoder d( _csEncode );
	if(!d.open( fname.c_str() ) ){
		::MessageBox(_hwnd, fname.c_str(),
			_T("t@CJ܂ł"), MB_ICONSTOP);
		return false;
	}
	_e.getDoc().read(d);

	// gq DocType  Pattern r
	size_t pos = _filename.find_last_of( _T('.') );
	String ext = _filename.substr( pos+1, _filename.size()-(pos+1) );
	
	// t@C̊gq DocType 
	int doctype = getDocTypeFromExt( ext );

	PaintTool& t = _e.getPaintTool();
	t.clearSearch();
	t.clearSel();

	_modified = false;
	setWindowTitle();

	return true;
}

//---------------------------------------------------------------
bool Ntp::readKwd(const String& fname)
{
	TxtDecoder d(UTF16LE);
	PaintTool& t = _e.getPaintTool();
	KEYWORDS& k = t.getKeywords();
	k.clear();
/*
#ifdef _DEBUG
	OutputDebugString( fname.c_str() );
#endif
*/
	// kwd t@Cǂ݁B
	if(!d.open( fname.c_str() )) return false;

	String flag  = d.readLine();
	String begin = d.readLine();
	String end   =  d.readLine();
	k.setBlockComment( begin.c_str(),
		end.c_str() );
	k.setLineComment( d.readLine().c_str() );
	for(; d.state(); )
	{
		k.setKeyword( d.readLine().c_str() );
	}
	return true;
}

//---------------------------------------------------------------
bool Ntp::readLay(const String& fname)
{
//	TxtDecoder d(UTF16LE);
	TxtDecoder d(UTF16l);
	if(!d.open( fname.c_str() ))
	{
		// Ƃ肠܂Ԃ off ɂ falseB
		_e.getPaintTool().setWrap( false );
		return false;
	}

	// strToHex ł BGR ɂȂ邩A
	// RGB ɕϊȂ`
	COLORREF cl[6]={0}; //0:txt,1:cmt,2:kwd,4:ctl,5:bg
	String s, ftname;
	int fsize=0, tsize=0;
	int iwrap=0;
	for( int i=0; i<12; i++ )
	{
		s = d.readLine();
		switch( (s[0]<<16)|s[1] )
		{
		case 0x00630074: // ct: COLOR-TEXT
			_cf.cl[0] = strToRGB(s.substr(3, s.size())); break;
		case 0x0063006B: // ck: COLOR-KEYWORD
			_cf.cl[2] = strToRGB(s.substr(3, s.size())); break;
		case 0x00630062: // cb: COLOR-BACKGROUND
			_cf.cl[5] = strToRGB(s.substr(3, s.size())); break;
		case 0x00630063: // cc: COLOR-COMMENT
			_cf.cl[1] = strToRGB(s.substr(3, s.size())); break;
		case 0x0063006E: // cn: COLOR-CONTROL
			_cf.cl[4] = strToRGB(s.substr(3, s.size())); break;
		case 0x00660074: // ft: FONT
			_cf.ftname = s.substr(3, s.size()); break;
		case 0x0073007A: // sz: SIZE
			_cf.ftsize = _ttoi( s.substr(3, s.size()).c_str() ); break;
		case 0x00740062: // tb: TAB
			_cf.tab    = _ttoi( s.substr(3, s.size()).c_str() ); break;
		case 0x00730063: // sc: SPECIAL-CHAR
			{
			int x = strToHex(s.substr(3, s.size()));
			_cf.ctl[PaintTool::ctlZSP] = (x & 0x00001)!=0 ? true : false;
			_cf.ctl[PaintTool::ctlHSP] = (x & 0x00010)!=0 ? true : false;
			_cf.ctl[PaintTool::ctlTAB] = (x & 0x00100)!=0 ? true : false;
			_cf.ctl[PaintTool::ctlEOL] = (x & 0x01000)!=0 ? true : false;
			_cf.ctl[PaintTool::ctlEOF] = (x & 0x10000)!=0 ? true : false;
			}
			break;
		case 0x00770070: // wp: WRAP-TYPE
			_cf.wrap = _ttoi( s.substr(3, s.size()-3).c_str() ); break;
		case 0x00770077: // ww: WRAP-WIDTH
			_cf.wrapwidth = _ttoi( s.substr(3, s.size()-3).c_str() );
			break;
		case 0x006C006E: // ln: LINE-NO
			_cf.linenum = true; break;
		}
	}

	// ǂݍ񂾏Ƃɐݒ
	PaintTool& t = _e.getPaintTool();
	t.setFont( _cf.ftname.c_str(), _cf.ftsize, _cf.tab );
	_e.getView().getCaret().changeHeight( t.getFontHeight() );
	t.setColor( _cf.cl );
	t.setWrap( _cf.wrap>=0 ? true : false, 
		_cf.wrap==1 ? _cf.wrapwidth : 0 );
	t.setCtrlMark( _cf.ctl );
	if( !_cf.linenum ) t.setLineNumArea( false );
	else               t.setLineNumArea( true );

	// ܂Ԃ
	int wid;
	switch( _cf.wrap )
	{
	case 1:  wid=IDM_WRAP3; break;
	case 0:  wid=IDM_WRAP2; break;
	default: wid=IDM_WRAP1; break;
	}
	setWrapType( wid );

	return true;
}

//---------------------------------------------------------------
void Ntp::createDocTypeMenu()
{
	HMENU m  = ::GetSubMenu( ::GetSubMenu( getMenu() , 3 ) , 4 );
//	TCHAR tmp[2][10] = {_T("C/C++"),_T("HTML")};

	// NɁAini ǂ DocType  menu 𐶐B
	Ini ini;
	ini.open( _T("n12k2.ini") );

	int i=0;
	UINT flag = MF_STRING;
	TCHAR num[10];
	while(1)
	{
		_itot( i+1, num, 10 );
		String s = ini.readString( _T("DocType"), num );
		if( s.empty() ) break;
		::AppendMenu( m, flag, 20001+i, s.c_str() );
		i++;
	}
}

//---------------------------------------------------------------
void Ntp::setDocType(int id)
{
	// ini ݒ薼Ă
	Ini ini;
	ini.open( _T("n12k2.ini") );

	TCHAR num[12]={0};
	_itot( id-20000, num, 10 );
	String ds  = ini.readString( _T("DocType"), num );

	// kwd  lay ǂ
	String ks = ini.readString( ds.c_str(), _T("Keyword") );
	String ls = ini.readString( ds.c_str(), _T("Layout") );
	
	// JgfBNg擾
	TCHAR temp[MAX_PATH+1];
	uelib::GetCurrentDirectory( MAX_PATH, temp );
	String s = temp;
	s += _T("\\type\\");

	PaintTool& t = _e.getPaintTool();

	if( ks.empty() )
	{
		// L[[hȂ
		t.getKeywords().clear();
		t.setHighlightType( 0 );
		if( ls.empty() )
			readLay( String(s+_T("default.lay")) );
		else
			readLay( String(s+ls) );
	}
	else
	{
		if( ds == _T("HTML") )
			// HTML L[[h
			t.setHighlightType( 2 );
		else
			// C L[[h
			t.setHighlightType( 1 );
		readKwd( String(s+ks) );
		readLay( String(s+ls) );
	}

	// Ōɕ\؂芷
	HMENU m  = ::GetSubMenu( ::GetSubMenu( getMenu() , 3 ) , 4 );
	::CheckMenuRadioItem( m, 20000, 29999, id, 
		MF_BYCOMMAND );

	::InvalidateRect( _e.getView().getHwnd(),
		NULL, FALSE );
}

//---------------------------------------------------------------
void Ntp::setWrapType(int id)
{
	HMENU m  = ::GetSubMenu( getMenu() , 3 );

	bool b; int w;
	switch( id )
	{
	case IDM_WRAP1: b=false, w=0;             break;
	case IDM_WRAP2: b=true,  w=_cf.wrapwidth; break;
	case IDM_WRAP3: b=true,  w=0;             break;
	case IDA_WRAP1: b=false, w=0, id=IDM_WRAP1; break;
	case IDA_WRAP2:
		b=true,  w=_cf.wrapwidth, id=IDM_WRAP2; break;
	case IDA_WRAP3: b=true,  w=0, id=IDM_WRAP3; break;
	}
	_e.getPaintTool().setWrap( b, w );

	::CheckMenuRadioItem( m, IDM_WRAP1, IDM_WRAP3,
		id, MF_BYCOMMAND );

	// ܂ԂύX Caret ɖ
	// ̂ŁA\ZbgB
	_e.getPaintTool().updateWrapInfo();
	_e.getView().getCaret().reset();
	_e.getView().getScroll().reset();
	::SendMessage( _e.getHwnd(), WM_SIZE, 0, 0L );
}

//---------------------------------------------------------------
int Ntp::getDocTypeFromExt(const String& ext)
{
	// gq ini ̓eA
	// HighlightType B
	Ini ini;
	ini.open( _T("n12k2.ini") );

	int i=0;
	bool bMatch = false;
	String ds;
	TCHAR num[10]={0};
	while(1)
	{
		// DocType 擾
		_itot( i+1, num, 10 );
		ds  = ini.readString( _T("DocType"), num );
		if( ds.empty() ) break;

		// gqp^[擾
		String ps = ini.readString( ds.c_str(), _T("Pattern") );
		// v
		if( compareExt( ext, ps ) ){ bMatch=true; break; }
		i++;
	}

	//  DocType ݒ
	if( bMatch )
		setDocType(20001+i);
	else
		setDocType(20000);

	return i+1;
}

//---------------------------------------------------------------
bool Ntp::compareExt( const String& ext, const String& pat)
{
	// pat ̊gq | ݁B
	// *.cpp ƂB
	String s = pat, ss;
	size_t pos;
	while(1)
	{
		pos = s.find( _T('|') );
		if( pos==String::npos )
		{
			if( ext == s.substr(2,s.size()-2) ) return true;
			else                                return false;
		}
		ss = s.substr( 0, pos );
		s  = s.substr( pos+1, s.size()-(pos+1) );
		if( ext == ss.substr(2, ss.size()-2) ) return true;
	}
	return false;
}

//---------------------------------------------------------------
void Ntp::setWindowTitle()
{
	// [aaa.txt(untitled) *] - noviceTextPark2 
	TCHAR* fname = new TCHAR[_filename.size()+10];
	TCHAR* title = new TCHAR[_filename.size()+40];

	// Ȃ "untitled"
	if( _filename.empty() )
		_tcscpy( fname, _T("untitled") );
	else
		_tcscpy( fname, _filename.c_str() );

	// ^Cg̕
	if( _modified )
		wsprintf( title, _T("[%s *] - noviceTextPark2"), fname );
	else
		wsprintf( title, _T("[%s] - noviceTextPark2"), fname );

	// \
	::SetWindowText( getHwnd(), title );

	// obt@j
	delete [] fname; delete [] title;
}

//---------------------------------------------------------------
ULONG Ntp::strToHex(const String& s)
{
	// A=0x41~F=0x46 a=0x61~f=0x66
	// 0=0x30~9=0x39
	ULONG n=0, strNum=0;
	size_t length = s.w_str().size();
	for(size_t i=0; i<length; i++){
		// ̌
		strNum = (s.w_str())[length-i-1];
		if(strNum>=0x41 && strNum<=0x46) strNum -= 0x40 - 0x9;
		else if(strNum>=0x61 && strNum<=0x66) strNum -= 0x60 - 0x9;
		else if(strNum>=0x30 && strNum<=0x39) strNum -= 0x30;
		else continue;
		n += strNum << (4*i);
	}
	return n;
}

//---------------------------------------------------------------
ULONG Ntp::strToRGB(const String& s)
{
	ULONG n = strToHex(s);
	UCHAR cl = n & 0xFF;
	UCHAR ch = (n & 0xFF0000)>>16;
	return ((ULONG)cl<<16) + (n&0xFF00) + ch;
}
