
#include "stdafx.h"

#include "..\uelib2\uelib.h"
#include "ntpedit\editctrl.h"
#include "resource.h"

#include "ntpsearch.h"

using namespace uelib;
using namespace ntpedit;


//-----------------------------------------------------------
SearchManager::SearchManager(NtpEdit& e)
	:Dialog(IDD_SEARCH_DIALOG)
	,_edit(e), _bPrev(false)
{}

//-----------------------------------------------------------
SearchManager::~SearchManager()
{
	::PostMessage( getHwnd(), WM_QUIT, 0, 0L );
}

//-----------------------------------------------------------
void SearchManager::onInit()
{
	HWND hCombo = ::GetDlgItem( getHwnd(), IDC_COMBO1 );

	// ͈͑IĂ炻̕
	POINT p1,p2;
	_edit.getPaintTool().getSel(&p1,&p2);
	if( p1.y != -1 )
	{
		String s = _edit.getDoc().getSelectedString( p1,p2 );
		::SetWindowText( hCombo, s.c_str() );
	}

	::SetFocus( hCombo );
}

//-----------------------------------------------------------
bool SearchManager::onCommand( UINT cmd, UINT id, HWND ctrl )
{
	switch(id)
	{
	case IDB_SEARCHNEXT:
		onSearchNext();
		break;
	case IDB_SEARCHPREV:
		onSearchPrev();
		break;
	case IDB_REPLACE:
		onReplace();
		break;
	case IDB_REPLACEALL:
		onReplaceAll();
		break;
	}
	return false;
}

//-----------------------------------------------------------
void SearchManager::onSearchNext()
{
	// ֌Č̂ false
	_bPrev = false;

	search();
}

//-----------------------------------------------------------
void SearchManager::onSearchPrev()
{
	// O֌Č̂ true
	_bPrev = true;

	search();
}
//-----------------------------------------------------------
void SearchManager::onReplace()
{
	if( 0==_edit.getPaintTool().getSearchSize() )
	{
		// ĂȂ猟
		search();
	}
	else
	{
		// łɌĂus
		replace();
	}
}

//-----------------------------------------------------------
void SearchManager::onReplaceAll()
{
	int ssize = _edit.getPaintTool().getSearchSize();
	if( ssize==0 )
	{
		// ĂȂ猟
		search(true);
	}
	else
	{
		// łɌĂus
		replaceAll();

		TCHAR tmp[128]={0};
		wsprintf( tmp, _T("%d  u܂"), ssize );
		::MessageBox( getHwnd(), tmp, _T("n12k2"),
			MB_ICONINFORMATION );
	}

}

//-----------------------------------------------------------
void SearchManager::search(bool bAll)
{
	HWND hCombo1 = ::GetDlgItem( getHwnd(), IDC_COMBO1 );

	// R{{bNX猟Ă
	TCHAR tmp[MAX_PATH*2+1]={0};
	::GetWindowText( hCombo1, tmp, MAX_PATH*2 );

	const String searchStr = tmp;

	// 󂾂ȂɂȂ
	if( searchStr.empty() ) return;

	// ݂̃Lbg̐΍sʒu擾
	Caret&     c = _edit.getView().getCaret();
	PaintTool& t = _edit.getPaintTool();

	POINT pt;
	if( bAll ) pt.x = 0, pt.y = 0;
	else       pt = c.getAbsPoint();

	if( _searchStr == searchStr )
	{
		// ɕύXȂȂԂ

		// ݂̃Lbg̐΍sʒu擾
		POINT p1,p2;
		t.getSel(&p1,&p2);

		if( p1.y==-1 )    p2 = _bPrev ? p1 : pt;
		else if( _bPrev ) p2 = p1;

		// ł߂ʒu܂Ŕ
		int n;
		SELECTED sel = _edit.getPaintTool().getNearestSearchPoint(
			p2, _bPrev, &n);

		// ȂȂɂȂ
		if( sel.begin.y == -1 ) return;

		_edit.getPaintTool().setSel(&sel.begin,&sel.end);
		_edit.getView().getCaret().jump( 
			sel.begin.x, sel.begin.y+1,
			_edit.getView().getScroll().getVStartPos() );
		::InvalidateRect( _edit.getView().getHwnd(),
			NULL, FALSE );
	}
	else
	{
		// s

		_searchStr = searchStr;

		// R{{bNX̗ɉ
		::SendMessage( hCombo1, CB_INSERTSTRING, 0, (LPARAM)tmp );

		// sÂ
		searchStrings(searchStr, pt);

		// ĕ`
		::InvalidateRect( _edit.getView().getHwnd(),
			NULL, FALSE );
	}

}

//-----------------------------------------------------------
void SearchManager::searchStrings(const String& ss, const POINT& ps)
{
	int  state      = 1;    // state  0 ɂȂ猟I
	ntpedit::Doc& d = _edit.getDoc();
	size_t ssize    = d.getStringSize();
	POINT         pf= {-1, -1};  // ŏɃ}b`ꏊ
	int starty = _bPrev ? 0 : ps.y;

	for( int i=starty; state!=0; i++ )
	{
		String s;
		size_t pos;

		// Lbĝ镶͕
		if( i==ps.y )
		{
			if( _bPrev )
				s = d.getString(i).substr( 0, ps.x ).c_str();
			else
				s = d.getString(i).substr( ps.x,
						d.getString(i).size()-ps.x ).c_str();
		}
		else
			s = d.getString(i).c_str();

		// TāA setSearch
		size_t xpos=0;
		while(1)
		{
			if( s.empty() ) break;
			pos = s.find( ss );
			if( String::npos == pos ) break;

			POINT p1={ xpos+pos,           i },
				  p2={ xpos+pos+ss.size(), i };
			if( i== ps.y ) p1.x += ps.x, p2.x += ps.x;

			if( pf.y==-1 || _bPrev ) pf = p1;

			_edit.getPaintTool().setSearch(&p1,&p2,ss);

			s = s.substr( pos+1, s.size()-(pos+1) );
			xpos += p2.x;
		}

		// I[܂ŗ state  0 
		if( _bPrev )
		{
			if( i>=ps.y-1 ) state=0;
		}
		else
		{
			if( i>=(int)ssize-1 ) state=0;
		}
	}

	// ł炻 jump
	if( pf.y!=-1 )
	{
		POINT pf2={pf.x+ss.size(),pf.y};
		_edit.getPaintTool().setSel(&pf,&pf2);
		_edit.getView().getCaret().jump( pf.x, pf.y+1,
			_edit.getView().getScroll().getVStartPos() );
	}
	else
	{
		::MessageBox( getHwnd(),
			_T("܂ł"),
			_T("n12k2"), MB_ICONINFORMATION );
	}
}

//-----------------------------------------------------------
void SearchManager::replace()
{
	HWND hCombo2 = ::GetDlgItem( getHwnd(), IDC_COMBO2 );
	Caret&     c = _edit.getView().getCaret();
	PaintTool& t = _edit.getPaintTool();

	// R{{bNX猟Ă
	TCHAR tmp[MAX_PATH*2+1]={0};
	::GetWindowText( hCombo2, tmp, MAX_PATH*2 );

	const String replaceStr = tmp;

	// R{{bNX̗ɉ
	::SendMessage( hCombo2, CB_INSERTSTRING, 0, (LPARAM)tmp );

	// ݂̃Lbg̐΍sʒu擾
	const POINT pt = c.getAbsPoint();

	// ł߂ʒu܂Ŕ
	int n;
	SELECTED sel = t.getNearestSearchPoint(pt, false, &n);

	// ȂȂɂȂ
	if( sel.begin.y == -1 ) return;

	// Replace
	_edit.getDoc().exec( 
		new Replace(sel.begin, sel.end, replaceStr) );

	//  vector 폜
	t.eraseSearch(n);

	// u瓯š̈ʒu邤[
	t.correctSearch(sel.begin.y,
		sel.end.x-sel.begin.x-1);

	// ̌ʒu܂Ŕ
	SELECTED nextsel = t.getNearestSearchPoint(
		sel.end, false, NULL);
	t.setSel(&nextsel.begin, &nextsel.end);
	c.jump( nextsel.begin.x, nextsel.begin.y+1,
		_edit.getView().getScroll().getVStartPos() );
	::InvalidateRect( _edit.getView().getHwnd(),
		NULL, FALSE );
}

//-----------------------------------------------------------

void SearchManager::replaceAll()
{
	HWND hCombo2 = ::GetDlgItem( getHwnd(), IDC_COMBO2 );
	Caret&     c = _edit.getView().getCaret();
	PaintTool& t = _edit.getPaintTool();

	// R{{bNX猟Ă
	TCHAR tmp[MAX_PATH*2+1]={0};
	::GetWindowText( hCombo2, tmp, MAX_PATH*2 );

	const String replaceStr = tmp;

	// R{{bNX̗ɉ
	::SendMessage( hCombo2, CB_INSERTSTRING, 0, (LPARAM)tmp );

	// ݂̃Lbg̐΍sʒu擾
	const POINT pt={0,0};

	// ł߂ʒu܂Ŕ
	while(1)
	{
		int n;
		SELECTED sel = t.getNearestSearchPoint(pt, false, &n);

		// ȂȂɂȂ
		if( sel.begin.y == -1 ) break;

		// Replace
		_edit.getDoc().exec( 
			new Replace(sel.begin, sel.end, replaceStr) );

		//  vector 폜
		t.eraseSearch(n);

		// u瓯š̈ʒu邤[
		t.correctSearch(sel.begin.y,
			sel.end.x-sel.begin.x-1);
	}

	::InvalidateRect( _edit.getView().getHwnd(),
		NULL, FALSE );
}


