
#ifndef _UELIB_CLIPBOARD_H_
#define _UELIB_CLIPBOARD_H_

#include "string.h"

namespace uelib{

class Clipboard
{
public:

	//@{ J //@}
	Clipboard( HWND owner, bool read=true );

	//@{  //@}
	~Clipboard();

	//@{ f[^ǂݍ //@}
	HANDLE getData( UINT uFormat ) const;

	//@{ wtH[}bg̃f[^Nbv{[hɂ邩H //@}
	bool isAvail( UINT uFormat ) const;

	//@{ wtH[}bg̃f[^Nbv{[hɂ邩H() //@}
	bool isAvail( UINT uFormats[], int num ) const;

	//@{ eLXgǂݍ //@}
	String getUnicodeText() const;

	//@{ f[^ //@}
	bool setData( UINT uFormat, HANDLE hData );

	//@{ ƎtH[}bg̓o^ //@}
	static UINT registerFormat( const TCHAR* name );

public:

	//@{ ɊJĂ邩`FbN //@}
	bool isOpened() const;

private:

	bool _opened;

};

//-------------------------------------------------------------------------

inline bool Clipboard::isOpened() const
	{ return _opened; }

inline HANDLE Clipboard::getData( UINT uFormat ) const
	{ return ::GetClipboardData( uFormat ); }

inline bool Clipboard::setData( UINT uFormat, HANDLE hData )
	{ return NULL != ::SetClipboardData( uFormat, hData ); }

inline bool Clipboard::isAvail( UINT uFormat ) const
	{ return false!=::IsClipboardFormatAvailable(uFormat); }

inline bool Clipboard::isAvail( UINT uFormats[], int num ) const
	{ return -1!=::GetPriorityClipboardFormat(uFormats,num); }

inline UINT Clipboard::registerFormat( const TCHAR* name )
	{ return ::RegisterClipboardFormat(name); }


} //namespace uelib
#endif // _UELIB_CLIPBOARD_H_
