
#include "stdafx.h"
#include "file.h"
#include "ini.h"

using namespace uelib;

const int Ini::SJIS=0;
const int Ini::UTF16=1;


void Ini::open(const TCHAR* ininame)
{
	// st@CfBNg ini B
	TCHAR temp[MAX_PATH*2]={0};
	GetModuleFileName(NULL, temp, MAX_PATH*2-1);
	String s = temp;

	size_t pos = s.find_last_of(_T('\\'));
	_filename = s.substr(0, pos+1) + ininame;

	// Init@C݂ΊJĒǵB
	// ȂΐVK쐬B
	FileR f;

	if( false == f.open( _filename.c_str() )) return;

	if( _fileType==SJIS )
		initSJIS( f.base(), f.size() );
	else
		initUTF16( f.base(), f.size() );
}

void Ini::close()
{
/*	FileW f;

	// dummy
	_filename += String( _T(".out") );
	if( false == f.open( _filename.c_str(), true ) ) return;

	if( _fileType==SJIS )
	{
		for( UINT i=0; i<=_vSection.size(); i++ )
		{
			for( UINT j=0; j<_vKey[i].size(); j++)
			{
				f.write( _vKey[i][j].c_str(),
						 _vKey[i][j].size()*sizeof(TCHAR) );
				f.write( _T("\r\n"), 2*sizeof(TCHAR) );
			}
			if( i==_vSection.size() ) break;
			f.write( _vSection[i].c_str(), 
					 _vSection[i].size()*sizeof(TCHAR) );
			f.write( _T("\r\n"), 2*sizeof(TCHAR) );
		}
	}
	else
	{}
*/
}

void Ini::initSJIS(const UCHAR* buf, UINT size)
{
	// sÂǂ String Ɋi[B
	const UCHAR *pStart = buf, *pEnd = buf;
	String s;
	int  i=0;
	UINT n=0;

	while( n<size )
	{
		if(*pStart == '[')
			_vSection.push_back( readLine( &pStart, &pEnd ) ), i++;
		else
			_vKey[i].push_back( readLine( &pStart, &pEnd ));
		n += pEnd - pStart;
		// |C^̍s̐擪
		pStart = pEnd;
	}
}

String Ini::readLine( const UCHAR **start, const UCHAR **end )
{
//	String s;
	UINT n = 0;

	if( _fileType == SJIS )
	{
		const UCHAR   *p = *start;
		char        *buf = NULL;
		// SJIS t@Csǂ
		while(1)
		{
			// \n {
			if( *p=='\0' ) break;
			if( *p=='\n' ){ p++; break; }
			p++; n++;
		}

		// Ԃ̃obt@ăRs[
		buf = new char[n+1];
		strncpy(buf, (const char*)*start, n);

		// ĂƁ[ NULL 𖄂߂
		buf[n]='\0';
		if( buf[n-1]=='\r' || buf[n-1]=='\n' ) buf[n-1]='\0';
		if( n >= 2 && buf[n-2]=='\r' )         buf[n-2]='\0';

		// String ɃRs[
		String s(buf);
		// obt@NA
		delete [] buf;

		// ̍s̐擪n
		*end = p;
		return s;
	}
	else
	{
		// UTF16 t@Csǂ
		wchar_t *tbuf = NULL;
		const USHORT *tp = (const USHORT*)*start;
		return String("");
    }

//	return s;
}

void Ini::initUTF16(const UCHAR* buf, UINT size)
{

}

String Ini::readString(const TCHAR* lpSection, const TCHAR* lpKey) const
{
	int n=-1, nn=-1;

	size_t vsize = _vSection.size();
	for(size_t i=0; i<vsize; i++)
	{
		// ZNVǂT
		String ss = _vSection[i].substr(1, _vSection[i].size()-2);
		if( !ss.compare( String(lpSection) )){
			n = (int)i+1;
			break;
		}
	}
	// Ȃ΋
	if( n==-1 ) return _T("");

	// L[T
	for(UINT j=0; j<_vKey[n].size(); j++)
	{
		size_t pos = _vKey[n][j].find_first_of(_T('='));

		if( pos == String::npos || pos==_vKey[n][j].size()-1 )
			continue;
		if( _vKey[n][j][0] == _T(';') ) continue;
		if( 0==_vKey[n][j].compare(0, pos, String(lpKey)) ){
			nn = (int)j;
			break;
		}
	}
	if( nn==-1 ) return _T("");

	size_t pos  = _vKey[n][nn].find_first_of(_T('='));
	size_t size = _vKey[n][nn].size();
	String s = _vKey[n][nn].substr( pos+1, size-2 );
	return s;
}

int Ini::readInt(const TCHAR* lpSection, const TCHAR* lpKey) const
{
	String s = readString(lpSection, lpKey);

	if(s.empty()==TRUE) return 0;
	else                return _ttoi( s.c_str() );
}


bool Ini::writeString(TCHAR* lpSection, TCHAR* lpKey, TCHAR* lpValue)
{
	UINT n, nn;

	// ZNVԍǂT
	for( n=0; n<_vSection.size(); n++)
	{
		if( _vSection[n].substr( 1, _vSection[n].size()-2 )
			== lpSection )
			break;
	}

	// ~߂ȂႢ
	if( n>10 ) return false;

	if( n==_vSection.size() ){
		// ȂꍇAZNV쐬
		String s1 = String(_T("[")) + lpSection + String(_T("]"));
		_vSection.push_back( s1 );
		
		String s2 = lpKey + String(_T("=")) + lpValue;
		_vKey[_vSection.size()-1].push_back( s2 );

//		OutputDebugstring( s1.c_str() );
//		OutputDebugstring( s2.c_str() );

		return true;
	}

	// ZNV݂ꍇAL[T
	for( nn=0; nn<_vKey[n].size(); nn++ )
	{
		int pos = _vKey[n][nn].find_first_of( _T('=') );
		if( _vKey[n][nn].substr( 0, pos ) ==
			lpKey )
			break;
	}

	// L[݂ȂꍇA쐬
	if( nn==_vKey[n].size() ){
		String s = lpKey + String(_T("=")) + lpValue;
		_vKey[n].push_back( s );

//		OutputDebugstring( s.c_str() );

		return true;
	}

	// ZNVAL[݂ꍇ
	String s = lpKey + String(_T("=")) + lpValue;
	_vKey[n][nn] = s;
	return true;
}

bool Ini::writeInt(TCHAR* lpSection, TCHAR* lpKey, int value)
{
	TCHAR temp[32] = {0};

	_itot(value, temp, 30);

	return writeString(lpSection, lpKey, temp);
}

