
#ifndef _UELIB_INI_H_
#define _UELIB_INI_H_

#include <vector>
#include "string.h"
#pragma warning(disable:4786)
#ifdef _WIN32
 #pragma warning(disable:4244)
#endif

using namespace std;

namespace uelib{

//@{
//  ini t@CNXB
//  C^[tF[XIɂ uelib1 ƕςȂB
//  Astring  vector ̂Ԃɂ
//  ȂĂ邾B
//@}

class Ini
{
public:
	Ini(int type=0);
	Ini(TCHAR* ininame, int type=0);
	~Ini();

	//@{ J //@}
	void open(const TCHAR* ininame);
	//@{  //@}
	void close();

	//@{ r //@}
	String readString(const TCHAR* lpSection, const TCHAR* lpKey) const;
	int readInt(const TCHAR* lpSection, const TCHAR* lpKey) const;
	//@{  //@}
	bool writeString(TCHAR* lpSection, TCHAR* lpKey, TCHAR* lpValue);
	bool writeInt(TCHAR* lpSection, TCHAR* lpKey, int value);

private:
	//@{  //@}
	void initSJIS(const UCHAR* buf, UINT size);
	void initUTF16(const UCHAR* buf, UINT size);
	//@{ sǂ //@}
	String readLine( const UCHAR **start, const UCHAR **end );
	//@{ S-JIS  UTF-16 ֕ϊ //@}
	String AToW(const unsigned char* buf, int size);

public:
	static const int SJIS, UTF16;

private:
	String _filename;
	vector <String> _vSection;
	vector <String> _vKey[10];
	int _fileType;
};

//--------------------------------------------------------

inline Ini::Ini(int type)
	:_fileType(type)
	{}

inline Ini::Ini(TCHAR* ininame, int type)
	:_fileType(type)
	{ open(ininame); }

// o̓t@C̓_~[ɂȂĂ܂
inline Ini::~Ini()
	{ close(); }

} //namespace uelib
#endif // _UELIB_INI_H_

