
#include "stdafx.h"
#include "reg.h"

//using namespace std;
using namespace uelib;
//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

RegKey::RegKey()
{
	_hKey = NULL;
}

RegKey::~RegKey()
{
	close();
}

LONG RegKey::open(HKEY hKeyRoot, LPCTSTR pszPath)
{
    DWORD dw;
    _sPath = pszPath;
	
	return RegCreateKeyEx (hKeyRoot, pszPath, 0L, _T(""),
		0, 0, NULL, &_hKey, &dw);
}

void RegKey::close()
{
	if (_hKey)
	{
		RegCloseKey (_hKey);
		_hKey = NULL;
	}
}

//LONG RegKey::write (LPCTSTR pszKey, DWORD dwVal)
LONG RegKey::write (const TCHAR* pszKey, DWORD dwVal)
{//l̏
	return RegSetValueEx (_hKey, pszKey, 0L, REG_DWORD,
		(CONST BYTE*) &dwVal, sizeof(DWORD));
}

//LONG RegKey::write (LPCTSTR pszKey, LPCTSTR pszData)
LONG RegKey::write (const TCHAR* pszKey, LPCTSTR pszData)
{//̏
	return RegSetValueEx (_hKey, pszKey, 0L, REG_SZ,
		(const BYTE*) pszData, 
		(DWORD)( (_tcslen(pszData) + 1) * sizeof (*pszData)));

}

//LONG RegKey::write (LPCTSTR pszKey, const BYTE* pData,
LONG RegKey::write (const TCHAR* pszKey, const BYTE* pData,
                     DWORD dwLength)
{//oCȉ
	return RegSetValueEx (_hKey, pszKey, 0L, REG_BINARY,
		pData, dwLength);
}

//LONG RegKey::read (LPCTSTR pszKey, DWORD& dwVal)
LONG RegKey::read (const TCHAR* pszKey, DWORD& dwVal)
{//l̓ǂݍ
	DWORD dwType;
	DWORD dwSize = sizeof (DWORD);
	DWORD dwDest;
	
	LONG lRet = RegQueryValueEx (_hKey, (LPTSTR) pszKey, NULL,
		&dwType, (BYTE *) &dwDest, &dwSize);
	
	if (lRet == ERROR_SUCCESS)
		dwVal = dwDest;
	
	return lRet;
}

//LONG RegKey::read (LPCTSTR pszKey, String& sVal)
LONG RegKey::read (const TCHAR* pszKey, String& sVal)
{//̓ǂݍ
	DWORD dwType;
	DWORD dwSize = 200;
	TCHAR  string[200];
	
	LONG lReturn = RegQueryValueEx (_hKey, (LPTSTR) pszKey, NULL,
		&dwType, (BYTE *) string, &dwSize);
	
	if (lReturn == ERROR_SUCCESS)
		sVal = string;
	else
		sVal = _T("");
	
	return lReturn;
}

LONG RegKey::read (const TCHAR* pszKey, BYTE* pData, DWORD& dwLen)
{//oCi̓ǂݍ
	DWORD dwType;
	
	return RegQueryValueEx (_hKey, (LPTSTR) pszKey, NULL,
		&dwType, pData, &dwLen);
}

LONG RegKey::del(HKEY hKeyRoot, LPCTSTR pszPath)
{
	return RegDeleteKey(hKeyRoot, pszPath);
}

//
// ȉAReg NX̎
//

BOOL Reg::getBinary(const TCHAR* csSettingName)
{
	RegKey regKey;
	DWORD   dwRead;
	
//	LPCTSTR pazPath = L"SOFTWARE\\uema2\\CedarFTP\\Settings";
	long lResult = regKey.open(_root, /*HKEY_CURRENT_USER,*/
		_path.c_str() );

	if (lResult == ERROR_SUCCESS)
	{
		regKey.read(csSettingName, dwRead);

		regKey.close();
	}
	if(dwRead==1) return TRUE;
	else          return FALSE;
}

//BOOL Reg::setBinary(const String& csSettingName, BOOL bCode)
BOOL Reg::setBinary(const TCHAR* csSettingName, BOOL bCode)
{
	RegKey regKey;
	DWORD   dwWrite;
	
//	LPCTSTR pazPath = L"SOFTWARE\\uema2\\CedarFTP\\Settings";
	long lResult = regKey.open(/*HKEY_CURRENT_USER*/
		_root, _path.c_str() );

	if (lResult == ERROR_SUCCESS)
	{
		bCode ? dwWrite=1 : dwWrite=0;

		regKey.write(csSettingName, dwWrite);

		regKey.close();

		return TRUE;
	}
	return FALSE;
}

//void Reg::setString(const String& csSettingName, const String& csSetting)
void Reg::setString(const TCHAR* csSettingName, const TCHAR* csSetting)
{
	RegKey regKey;
	String string, csTemp;

//	LPCTSTR pazPath = L"Software\\uema2\\CedarFTP\\Settings";
	long lResult = regKey.open(/*HKEY_CURRENT_USER*/
		_root, _path.c_str() );

	if (lResult == ERROR_SUCCESS)
	{
		regKey.write(csSettingName, csSetting);

		regKey.close();
	}

}

//const String& Reg::getString(const String& csSettingName)
const String& Reg::getString(const TCHAR* csSettingName)
{
//	String* outstr = new String;
	RegKey regKey;
	String csTemp;

//	LPCTSTR pazPath = L"Software\\uema2\\CedarFTP\\Settings";

	long lResult = regKey.open(
		/*HKEY_LOCAL_MACHINE,*/
		_root, _path.c_str() );

	if (lResult == ERROR_SUCCESS)
	{
		long lret = regKey.read(csSettingName, csTemp);

		if(lret == ERROR_SUCCESS) _out = csTemp;
		else					  _out = _T("");

		regKey.close();
//		String s(_out);
		return _out;
	}
	_out = _T("");
	return _out;
}

DWORD Reg::getDword(const TCHAR* csSettingName)
{
	RegKey regKey;
	DWORD   dwRead;
	LONG ret = ERROR_SUCCESS+1;
	
	long lResult = regKey.open(_root,
		_path.c_str() );

	if (lResult == ERROR_SUCCESS)
	{
		ret = regKey.read(csSettingName, dwRead);

		regKey.close();
	}
	if(ret==ERROR_SUCCESS) return dwRead;
	else                   return 0;
}

