#ifndef _UELIB_STRING_H_
#define _UELIB_STRING_H_

#include <string>
#include <memory>
//#include "object.h"
using namespace std;

namespace uelib{

//@{
//  String NXB
//  string 𒼂ɎgƎvĂ񂾂ǁA
//  string  wstring U΂邱ƂɂȂă}YĈŁA
//  wstring  wrapper Ƃ String pӁB
//  EEƎvǁARXgN^Ăяo
//  ΂ˁ[BBAAz(ȉ)
//  Ȃłȃ^RȃR[fBOô낤B
//@}

class String : public wstring// , public Object
{
public:
	String();
	String( const char *a );
	String( const string& s );
	String( const wstring& s );
	virtual ~String();
	void Delete();

	String& operator = ( const char *a );
	String& operator = ( const string& s );
	String& operator = ( const wstring& s );
	String& operator = ( const String& s );

	String& operator += ( const TCHAR *a );
	String& operator += ( const String& s );

	bool operator==( LPCTSTR s ) const;
	bool operator==( const wstring& s ) const;
	bool operator==( const String& s ) const;

	size_t findi( const String& cs ) const;
//public:
//	const size_t size(void) const;

public:
	const String  substr(UINT begin, UINT end) const;
	const TCHAR*  c_str(void) const;
	const string  a_str(void) const;
	const wstring w_str(void) const;

private:
	wstring wstr(const char *a) const;
	string  astr(const wchar_t* w) const;

private:
	char* _p;
};

// ------------------------------------------------------

// \z
inline String::String()
	:wstring(),_p(NULL){}

inline String::String(const char *a)
	:wstring( wstr( a ) ),_p(NULL){}

inline String::String(const string& s)
	:wstring( wstr( s.c_str() ) ),_p(NULL){}

inline String::String(const wstring& s)
	:wstring(s),_p(NULL){}

inline void String::Delete()
	{ this->~String(); }

// g~O
inline const String String::substr(UINT begin, UINT end) const
	{ return String( wstring::substr(begin, end) ); }

// r
inline bool String::operator==( LPCTSTR s ) const
	{ return 0==::_tcscmp( c_str(), s ); }

inline bool String::operator==( const wstring& s ) const
	{ return ( wstring::c_str()==s.c_str()
		? true : operator==( s.c_str() )); }

inline bool String::operator==( const String& s ) const
	{ return ( c_str()==s.c_str() 
		? true : operator==( s.c_str() )); }

//@{ String + String //@}
inline const String operator+( const String& a, const String& b )
	{ return String(a) += b; }
//@{ String + TCHAR* //@}
inline const String operator+( const String& a, const TCHAR* b )
	{ return String(a) += b; }
//@{ TCHAR* + String //@}
inline const String operator+( const TCHAR* a, const String& b )
	{ return String(a) += b; }

} // namespace uelib
#endif //_UELIB_STRING_H_

