
#ifndef _UELIB_TXTDECODER2_H_
#define _UELIB_TXTDECODER2_H_

#include <memory>
#include "string.h"
#include "file.h"
#include "txt.h"

using namespace std;

namespace uelib{

//@{
//	ϊ\ȕR[hB
//  IɑΉłȂ̂܂ŁA
//  ꗗƂĒ`B
//@}
/*
enum charset
{
	AutoDetect=0,// 

	SJIS,      // {P (Shift_JIS)
	EucJP,     // {Q ({EUC)
	IsoJP,     // {R (ISO-2022-JP)

	UTF5,      // Unicode  (UTF-5)   : BOM
	UTF7,      // Unicode  (UTF-7)   : BOM
	UTF8,      // Unicode  (UTF-8)   : BOML
	UTF8N,     // Unicode  (UTF-8N)  : BOM
	UTF16b,    // Unicode  (UTF-16)  : BOML BE
	UTF16l,    // Unicode  (UTF-16)  : BOML LE
	UTF16BE,   // Unicode  (UTF-16BE): BOM
	UTF16LE,   // Unicode  (UTF-16LE): BOM
	UTF32b,    // Unicode  (UTF-32)  : BOML BE
	UTF32l,    // Unicode  (UTF-32)  : BOML LE
	UTF32BE,   // Unicode  (UTF-32BE): BOM
	UTF32LE,   // Unicode  (UTF-32LE): BOM
};
*/
//@{
//	R[hϊ̊{NXB
//@}
class Txt2
{
public:
	Txt2(const UCHAR* b, const ULONG s)
		:_base(b), _size(s)
		,_state(1), _pos(0), _lb(0)
		,_lbCheckLimit(10000)
	{ checkLB(); }

public:
	int state(){ return _state; }
	const unsigned char* base()
	{ return _base; }
	size_t size()
	{ return _size; }
	size_t currentpos()
	{ return _pos; }
	enum lbcode{ CR = 0, LF = 1, CRLF = 2 };

public:
	virtual int charNext() = 0;
	virtual int  decodeChar(wchar_t* t)=0;
//	virtual int  decodeLine(const char* a, TCHAR* t)=0;

public:
//	static charset autoDetect(const TCHAR *fname);

protected:
	//@{ sR[h //@}
	virtual void checkLB();

protected:
	//@{ t@C}bṽx[XAhX //@}
	const UCHAR *_base;
	//@{ t@CTCY //@}
	const size_t _size;
	//@{ ݈ʒu //@}
	size_t       _pos;
	//@{ 0=EOF, 2=EOL //@}
	int          _state;
	//@{ sR[hBlbcode ̒l //@}
	int          _lb;
	//@{ sR[h̃TCY //@}
	const size_t _lbCheckLimit;

private:
	static charset checkBOM(FileR& r);
};

//-----------------------------------------------------------

inline void Txt2::checkLB()
{
	UINT i=0;
	const UCHAR *p=_base;
	while( i < _size )
	{
		if( i >= _lbCheckLimit ) break;
		if(p[i]=='\r')
		{
			if( p[i+1]=='\n' ) _lb = CRLF;
				else           _lb = CR;
			break;
		}
		if(p[i]=='\n'){ _lb = LF; break; }
		i++;
	}
}

//-----------------------------------------------------------

//@{
//	t@CǂݍݗpNXB
//  ꂪOC^[tF[XƂȂB
//@}
class TxtDecoder2
{
public:
	TxtDecoder2(int charset);
	~TxtDecoder2();

public:
	bool open(const TCHAR* fname);
	bool open(const UCHAR* b, const ULONG s);
	void close();

public:
	int state()
    { return _t->state(); }
	int charcode()
	{ return _charset; }
	const unsigned char* base()
	{ return _t->base(); }
	size_t size()
	{ return _t->size(); }
	size_t currentpos()
	{ return _t->currentpos(); }
	static charset autoDetect(const TCHAR *fname);
	static charset autoDetect(const UCHAR* b,
							  const ULONG s);
//	TxtDecoder* getDecoder1();

public:
    void charNext()
	{ _t->charNext(); }
	int decodeChar(wchar_t* t)
	{ return _t->decodeChar(t); }

private:
	static charset checkBOM(const UCHAR* b);
	static int checkCharCode(const unsigned char* str);

private:
	auto_ptr<Txt2> _t;
	FileR         _fp;
	int           _charset;
};


} //namespace uelib
#endif

