
#include "stdafx.h"
#include "t2.h"
#include "t2_2.h"

using namespace uelib;

//---------------------------------------------------------

int SjisTxt2::charNext()
{
	const char *p=reinterpret_cast<const char*>(&_base[_pos]);
//	if( *p=='\0' ) return NULL;
	if( *p=='\0' ) return 0;

	int retcode = 0;

	if( IsDBCSLeadByteEx(CP_ACP, (BYTE)*p) )
		if( *(p+1)=='\0' ) return 0;
		else               retcode = 2, _pos+=2;
	else
		retcode = 1, _pos+=1;

	return retcode;
}

int SjisTxt2::decodeChar(wchar_t* t)
{
	int alen = 0;

	if( _pos >= _size ){ _state=0; return 0; }
	if( _base[_pos] == '\0' )
		{ _state=0; return 0; }

	if( IsDBCSLeadByteEx(CP_ACP, (BYTE)_base[_pos]) )
		if( _base[_pos+1]=='\0' ){ _state=0; return 0; }
		else alen=2;
	else
		alen=1;

	::MultiByteToWideChar( CP_ACP, 0, 
		(const char*)&_base[_pos], alen, t, 1 );

	charNext();

	return 1;
}

//---------------------------------------------------------

int EucTxt2::charNext()
{
	const UCHAR *p=reinterpret_cast<const UCHAR*>(&_base[_pos]);
//	if( *p=='\0' ) return NULL;
	if( *p=='\0' ) return 0;
	int retcode = 0;

	if( (*p>=0xA1 && *p<=0xF4) || *p==0x8E )
		if( *(p+1)=='\0' ) return 0;
		else               retcode = 2, _pos+=2;
	else
		retcode = 1, _pos++;

	return retcode;
}

int EucTxt2::decodeChar(wchar_t* t)
{
	const UCHAR *a = reinterpret_cast<const UCHAR*>(&_base[_pos]);
	int  alen = 0;
	unsigned short p=0;
	char    aa0[3]="";
	wchar_t aa1[3]=L"";

	if( _pos >= _size ){ _state=0; return 0; }
//	if( _base[_pos] == '\0' )
	if( *a == '\0' ){ _state=0; return 0; }

	if( *a>=0xA1 && *a<=0xF4 )
	{
		// 2 oCg
		if( *(a+1)=='\0' ){ _state=0; return 0; }
		else
		{
			alen = 2;
			p = euc2sjis( (unsigned short)( *(a+1)+(*a<<8) ));
		}
	}
	else if( *a==0x8E )
	{
		// pJi
		alen = 1, p=*(a+1);
	}
	else
	{
		// fʂ
		alen = 1, p=*a;
	}

	char pc[3]={
		alen==2 ? (p&0xFF00)>>8 : p&0x00FF,
		alen==2 ?  p&0x00FF     :        0,
		0};

	::MultiByteToWideChar( CP_ACP, 0, 
		pc, alen, t, 1 );

	charNext();

	return 1;
}

unsigned short EucTxt2::euc2sjis(unsigned short euc)
{
    unsigned short jis;
    unsigned short hib, lob;

	if ((euc & 0xff00) == 0x8e00)
		return (euc & 0x00ff);
	else jis = euc & ~0x8080;

	hib = (jis >> 8) & 0xff;
	lob = jis & 0xff;
	lob += (hib & 1) ? 0x1f : 0x7d;
	if (lob >= 0x7f) lob++;
	hib = ((hib - 0x21) >> 1) + 0x81;
	if (hib > 0x9f) hib += 0x40;

	return (hib << 8) | lob;
}

//---------------------------------------------------------
