
#ifndef _UELIB_TXT2_H_
#define _UELIB_TXT2_H_

#include "stdafx.h"
#include "t2.h"
#include "util.h"

namespace uelib{

//---------------------------------------------------------
class SjisTxt2 : public Txt2
{
public:
	SjisTxt2(const UCHAR* b, const ULONG s)
		:Txt2(b, s){}

public:
	int charNext();
	int  decodeChar(wchar_t* t);

};

//---------------------------------------------------------
class EucTxt2 : public Txt2
{
public:
	EucTxt2(const UCHAR* b, const ULONG s)
		:Txt2(b, s){}

public:
	int charNext();
	int  decodeChar(wchar_t* t);

private:
	unsigned short euc2sjis(unsigned short euc);
};

//---------------------------------------------------------
class Utf8Txt2 : public Txt2
{
public:
	Utf8Txt2(const UCHAR* b, const ULONG s, bool bom)
		:Txt2(b, s), _bom(bom){};

public:
	int charNext();
	int  decodeChar(wchar_t* t);

private:
	int getCharLength(const UCHAR* a);

private:
	bool _bom;
};

//---------------------------------------------------------
class Utf16Txt2 : public Txt2
{
public:
	Utf16Txt2(const UCHAR* b, const ULONG s, bool bom, bool endian)
		:Txt2(b, s), _bom(bom), _endian(endian){};

public:
	int charNext();
	int  decodeChar(wchar_t* t);

private:
	int getCharLength(const UCHAR* a);

private:
	bool _bom;
	bool _endian; // 0:BE, 1:LE
};

} //namespace uelib
#endif

