
#include "stdafx.h"
#include "t2.h"
#include "t2_2.h"

using namespace uelib;

//---------------------------------------------------------

int Utf8Txt2::charNext()
{
	// ̕܂ł̃oCgԂB
	// I[Ȃ 0B
	// invalid Ȃ -1B

	// charNext  _state ׂȂH
	// decodeChar ݂̂łȂƂׂH
	
	// BOM
	if( _bom && _pos==0 ){ _pos=3; return 0; }

	// UTF8N łABOM 邩ǂA
	// mFĂB
	else if( _pos==0 && _base[0] == 0xEF 
		&& _base[1] == 0xBB && _base[2] == 0xBF )
	{	_pos=3; return 0; }

	const UCHAR *p=reinterpret_cast<const UCHAR*>(&_base[_pos]);
	if( *p=='\0' || p==NULL ){
		return 0;
	}

	int size = getCharLength(p);

	if( size==-1 )
		return -1;
	else if( size==0 )
		return 0;
	else
		p+=size, _pos+=size;

	return size;
}

int Utf8Txt2::decodeChar(wchar_t* t)
{
	// KvƂ wchar_t ԂB
	// SJIS  EUC ̏ꍇ͕K 1B
	// UTF8 ̏ꍇ̓TQ[g̏ꍇ̂ 2 ԂB

	const UCHAR *p=reinterpret_cast<const UCHAR*>(&_base[_pos]);
	
	if( _pos >= _size ){ _state=0; return 0; }

	int size = getCharLength(p);

	// BOM or '\0'
	if( *p=='\0' || p==NULL || size==-1 )
	{
		_state = 0;
		*t = _T('\0');
		return 0;
	}

	if( p[0] == 0xEF && p[1] == 0xBB 
			&& p[2] == 0xBF)
	{
		*t = _T('\0');
		charNext();
		return 0;
	}

	wchar_t d[2]=L"";
	wchar_t e[2]=L"";
	switch(size)
	{
	case 1:
		// UTF8                  UTF16
		// 0xxxxxxx          -> 00000000-0xxxxxxx
		*t = *p;
		break;
	case 2:
		// 110xxxxx 10yyyyyy -> 00000xxx-xxyyyyyy
		*t  = (p[1] & 0x3F);
		*t += (*p   & 0x1F) << 6;
		break;
	case 3:
		// 1110xxxx 10yyyyyy 10zzzzzz 
		//                   -> xxxxyyyy-yyzzzzzz
		*t =  (p[2] & 0x3F);          //z?
		*t += (p[1] & 0x3F) << 6;  // * 0x40;  //y?
		*t += (*p   & 0x0F) << 12;  // * 0x1000; //x?
		break;
	case 4:
		// 11110www 10xxxxxx 10yyyyyy 10zzzzzz 
		//                   -> wwwxx xxxxyyyy-yyzzzzzz
		*t    = (p[3] & 0x3F);
		*t   += (p[2] & 0x3F) * 0x40;
		*t   += (p[1] & 0x0F) * 0x1000;
		t[1] =  (p[1] & 0x30) >> 4;
		t[1] += (*p   & 0x07) << 2;
		break;
	}
	
	//  decode łĂȂA
	// charNext ĂȂ͂B
	charNext();

	return size==4 ? 2 : 1;
}

int Utf8Txt2::getCharLength(const UCHAR* a)
{
	// NULL 肵A0 ԂB
	// invalid ȕA-1 ԂB
	const UCHAR *p=reinterpret_cast<const UCHAR*>(a);

//	if( *p=='\0' || p==NULL ) return 0;

	// UTF8                  UTF16
	// 0xxxxxxx          -> 00000000-0xxxxxxx
	if( (*p&0x80)==0 ) 
	{
		return 1;
	}
	// 110xxxxx 10yyyyyy -> 00000xxx-xxyyyyyy
	else if( (*p&0xE0)==0xC0 && (p[1]&0xC0)==0x80 )
	{
		return 2;
	}
	else if( p[1]=='\0' ) return -1;
	// 1110xxxx 10yyyyyy 10zzzzzz 
	//                   -> xxxxyyyy-yyzzzzzz
	else if( (*p&0xF0)==0xE0 && (p[1]&0xC0)==0x80
			&& (p[2]&0xC0)==0x80 )
	{
		return 3;
	}
	else if( p[2]=='\0' ) return -1;
	// 11110www 10xxxxxx 10yyyyyy 10zzzzzz 
	//                  -> wwwxx xxxxyyyy-yyzzzzzz
	else if( (*p&0xF8)==0xF0 && (p[1]&0xC0)==0x80
			&& (p[2]&0xC0)==0x80 && (p[3]&0xC0)==0x80 )
	{
		return 4;
	}
	else
	{
		return -1;
	}

}

//---------------------------------------------------------

int Utf16Txt2::charNext()
{
	if( _bom && _pos==0 ){ _pos=2; return 0; }

	return 2;
}

int Utf16Txt2::decodeChar(wchar_t* t)
{
	// KvƂ wchar_t ԂB
	// SJIS  EUC ̏ꍇ͕K 1B
	// UTF8 ̏ꍇ̓TQ[g̏ꍇ̂ 2 ԂB
	const UCHAR *p=reinterpret_cast<const UCHAR*>(&_base[_pos]);
	
	if( _pos >= _size ){ _state=0; return 0; }
	
	if( _endian==0 )
	{
		// Big Endian
		*t = p[0]*0x10000 + p[1];
	}
	else
	{
		// Little Endian
		*t = p[1]*0x10000 + p[0];
	}

	return 1;
}

