
#ifndef _UELIB_TXTDECODER_H_
#define _UELIB_TXTDECODER_H_

// txt.h
//  eLXg Encode/Decode ɂĂ
//  {IȃNXB
//  ̓Iɂ txt2.h ȍ~B

#include <memory>
#include "string.h"
#include "file.h"

using namespace std;

namespace uelib{

//@{
//	ϊ\ȕR[hB
//  IɑΉłȂ̂܂ŁA
//  ꗗƂĒ`B
//@}
enum charset
{
	AutoDetect=0,// 

	SJIS,      // {P (Shift_JIS)
	EucJP,     // {Q ({EUC)
	IsoJP,     // {R (ISO-2022-JP)

	UTF5,      // Unicode  (UTF-5)   : BOM
	UTF7,      // Unicode  (UTF-7)   : BOM
	UTF8,      // Unicode  (UTF-8)   : BOML
	UTF8N,     // Unicode  (UTF-8N)  : BOM
	UTF16b,    // Unicode  (UTF-16)  : BOML BE
	UTF16l,    // Unicode  (UTF-16)  : BOML LE
	UTF16BE,   // Unicode  (UTF-16BE): BOM
	UTF16LE,   // Unicode  (UTF-16LE): BOM
	UTF32b,    // Unicode  (UTF-32)  : BOML BE
	UTF32l,    // Unicode  (UTF-32)  : BOML LE
	UTF32BE,   // Unicode  (UTF-32BE): BOM
	UTF32LE,   // Unicode  (UTF-32LE): BOM
};

//@{
//	R[hϊ̊{NXB
//@}
class Txt
{
public:
	Txt(const UCHAR* b, const ULONG s)
		:_base(b), _size(s)
		,_state(1), _pos(0), _lb(0)
		,_lbCheckLimit(10000)
	{ checkLB(); }

public:
	virtual String readLine()=0;
 	virtual void writeLine(FileW& fp, const String& s)=0;
	int state(){ return _state; }
	enum lbcode{ CR = 1, LF = 2, CRLF = 3 };

	//@{ sR[hóB
	//   UTF-16, 32Bł͌Xɒ`ȂB
	//@}
	virtual void writeLB(FileW& fp, int lb)
	{
		// CR, LF, CRLF
		const USHORT lbstr[] = { 0x0d, 0x0a, 0x0a0d };
		const    int lblen[] = {    1,    1,      2 };

		fp.write( (const void *)&lbstr[lb-1], lblen[lb-1] );
	}
	//@{ BOM óB //@}
	virtual void writeBOM(FileW& fp){};

public:
	static charset autoDetect(const TCHAR *fname, lbcode* lb=NULL);
	static lbcode  checkMultiLB(const UCHAR *p, const ULONG size);
	static int     checkCharCode(const unsigned char* str);

protected:
	//@{ sR[h //@}
	virtual void checkLB()
	{
		UINT i=0;
		const UCHAR *p=_base;
		while( i < _size )
		{
			if( i >= _lbCheckLimit ) break;
			if(p[i]=='\r'){
				if( p[i+1]=='\n' ) _lb = CRLF;
				else               _lb = CR;
				break;
			}
			if(p[i]=='\n'){        _lb = LF; break; }
			i++;
		}
	}

protected:
	//@{ t@C}bṽx[XAhX //@}
	const UCHAR *_base;
	//@{ t@CTCY //@}
	const size_t _size;
	//@{ ݈ʒu //@}
	size_t       _pos;
	//@{ 0=EOF, 2=EOL //@}
	int          _state;
	//@{ sR[hBlbcode ̒l //@}
	int          _lb;
	//@{ sR[h̃TCY //@}
	const size_t _lbCheckLimit;

private:
	static charset checkBOM(FileR& r);
};

//@{
//	t@CǂݍݗpNXB
//  ꂪOC^[tF[XƂȂB
//@}
class TxtDecoder
{
public:
	TxtDecoder(int charset);
	~TxtDecoder();

public:
	bool open(const TCHAR* fname);
	void close();

public:
	String readLine()
	{ return _t->readLine(); }
	int state()
    { return _t->state(); }
	int charcode()
	{ return _charset; }

private:
	auto_ptr<Txt> _t;
	FileR         _fp;
	int           _charset;
};

//@{
//	t@CݗpNXB
//  ꂪOC^[tF[XƂȂB
//@}
class TxtEncoder
{
public:
	TxtEncoder(int charset, int linebreak);
	~TxtEncoder();

public:
	bool open(const TCHAR* fname);
	void close();

public:
	void writeLine(const String& s, bool firstline=false,
		bool lastline=false);

private:
	auto_ptr<Txt> _t;
	FileW         _fp;
	int           _charset;
	int           _lb;
};

class TxtCreator
{
public:
	static Txt* createTxt(int charset, 
		const UCHAR* base, const ULONG size);
};


} //namespace uelib
#endif

