
#ifndef _UELIB_TXT3_H_
#define _UELIB_TXT3_H_

#include "stdafx.h"
#include "txt.h"
#include "util.h"

// txt3.h
//  UTF8, UTF7 ɂĂ̋̓I
//  ǂݏB

namespace uelib{

//---------------------------------------------------------------

//@{
//  UTF7, UTF8 ́AǂݏĂ̂
//  ܂Ƃ߂ĈBŁÅNXB
//@}
class UtfBaseTxt : public Txt
{
public:
	UtfBaseTxt(const UCHAR* b, const ULONG s, bool bom)
		:Txt(b,s), _bom(bom){};

	String readLine()
	{
		if( _pos==0 && _bom ) _pos = 3;

		const UCHAR *p = &_base[_pos], *pp=NULL;
		size_t start = _pos, length=0;

		// sR[h܂ł̒v
		pp = p;
		while( 1 )
		{
			if( *pp=='\n' || *pp=='\r' ) break;
			if( _pos + length == _size ){
				_state = 0;
				break;
			}
			length++; pp++;
		}

		// nĕϊ
		wchar_t *tp = new wchar_t[length+1];
		UtfToWideChar( p, tp, (int)length );

		// ݈ʒu炵
		if( _lb==CRLF ) _pos += length+2;
		else            _pos += length+1;

		String s(tp);
		delete [] tp;
		return s;
	}

	void writeLine(FileW& fp, const String& s)
	{
		UCHAR *p  = new UCHAR[ s.size()*3+1 ];
		ULONG len = WideCharToUtf( s.w_str().c_str(), p );
		fp.write( (const void*)p, len);
		delete [] p;
	}

	void writeBOM(FileW& fp)
	{
		// BOM tOĂȂΏo͂Ȃ
		if( !_bom ) return;

		const UCHAR p[3] = {0xef, 0xbb, 0xbf};
		fp.write( (const void*)p, 3);
	}

private:
	virtual void UtfToWideChar( const UCHAR *up, 
		wchar_t *tp, int length ) = 0;
	virtual ULONG WideCharToUtf(const USHORT *in,
		UCHAR *out) = 0;

private:
	bool _bom;
};

//---------------------------------------------------------------

// UTF7BGreenPad ̂܂܁A[B͂(܂ȁB)

static const UCHAR u7c[128]={
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0x3e,0xff,0xff,0xff,0x3f,
	0x34,0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0xff,0xff,0xff,0xff,0xff,0xff,
	0xff,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,
	0x0f,0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0xff,0xff,0xff,0xff,0xff,
	0xff,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,
	0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,0x30,0x31,0x32,0x33,0xff,0xff,0xff,0xff,0xff };

class Utf7Txt : public UtfBaseTxt
{
public:
	Utf7Txt(const UCHAR* b, const ULONG s)
		:UtfBaseTxt(b,s,false){};

private:
	virtual void UtfToWideChar( const UCHAR *up, 
		wchar_t *tp, int length )
	{
		const UCHAR* p = up;
		// +~- ̊Ԃ̒Ȃ true
		bool flag = false;
		int  rest = length;
		TCHAR buf[3];

		if( length==0 ){ *tp++ = L'\0'; return; }

		while(1)
		{
			if( flag )
			{
				// 擾
				int len = getDecodeLength(p, rest);

				// fR[h
				buf[0]=buf[1]=buf[2]=0;

				switch( len )
				{
				case 8: buf[2]|= u7c[p[7]];
				case 7: buf[2]|=(u7c[p[6]]<< 6);
				case 6: buf[2]|=(u7c[p[5]]<<12), buf[1]|=(u7c[p[5]]>>4);
				case 5: buf[1]|=(u7c[p[4]]<< 2);
				case 4: buf[1]|=(u7c[p[3]]<< 8);
				case 3: buf[1]|=(u7c[p[2]]<<14), buf[0]|=(u7c[p[2]]>>2);
				case 2: buf[0]|=(u7c[p[1]]<< 4);
				case 1: buf[0]|=(u7c[p[0]]<<10);

					if( len<=3 )       *tp++ = buf[0];
					else if( len<=6 ){ *tp++ = buf[0]; *tp++ = buf[1]; }
					else{ *tp++ = buf[0]; *tp++ = buf[1]; *tp++ = buf[2]; }

				}
				p+=len, rest-=len;
				if( *p=='-' ) flag = false, rest--, p++;
			}
			else
			{
				if( *p=='+' )
					if( p[1]=='-' ) *tp++ = L'+', p++, rest--;
					else            flag = true;
				else                *tp++ = *p;
				p++, rest--;
			}
			if(rest==0) break;
		}
		*tp=L'\0';
	}

	virtual ULONG WideCharToUtf(const USHORT *in,
		UCHAR *out)
	{
		const USHORT* p = in;
		bool    flag = false;
		ULONG length = 0;
		static const UCHAR mime[64] = {
		'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P',
		'Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f',
		'g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v',
		'w','x','y','z','0','1','2','3','4','5','6','7','8','9','+','/'};

		while(1)
		{
			if( *p==L'\0' ) break;

			if( *p <= 0x7f )
			{
				if( flag ) out[length++]='-', flag=false;
				out[length++]=(UCHAR)*p;
				if( *p==L'+' ) out[length++]='-';
				p++;
			}
			else
			{
				if( !flag ) out[length++]='+', flag=true;
				int len = getEncodeLength(p);

				out[length++]=mime[ p[0]>>10 ];
				out[length++]=mime[(p[0]>>4)&0x3f ];
				out[length++]=mime[(p[0]<<2|p[1]>>14)&0x3f ];

				if( len>=2 )
				{
					out[length++]=mime[(p[1]>>8)&0x3f ];
					out[length++]=mime[(p[1]>>2)&0x3f ];
					out[length++]=mime[(p[1]<<4|p[2]>>12)&0x3f ];

					if( len>=3 )
					{
						out[length++]=mime[(p[2]>>6)&0x3f ];
						out[length++]=mime[ p[2]&0x3f ];
					}
				}
				p+=len;
			}
		}

		if( flag ) out[length++]='-', flag=false;
		return length;
	}

	int getDecodeLength(const UCHAR* p, int rest)
	{
		// '-' ̈ʒuTB
		// A 8 ȓB rest ȓB
		for( int i=0; i<8; i++, p++ )
		{
			if( *p=='-' ) return i;
			if( i>=rest ) return i;
		}
		return 8;
	}

	int getEncodeLength(const USHORT* p)
	{
		// 0x7f ȏ̒l̃f[^ȂĂ邩AԂB
		// A 3 ȓBNULL 炻܂ŁB
		for( int i=0; i<3; i++, p++ )
		{
			if( *p<=0x7f ) return i;
			if( *p==NULL ) return i;
		}
		return 3;
	}
};

//---------------------------------------------------------------

// UTF8B
// fR[hƂɃTQ[g肷P[X
// uB
class Utf8Txt : public UtfBaseTxt
{
public:
	Utf8Txt(const UCHAR* b, const ULONG s, bool bom)
		:UtfBaseTxt(b,s,bom){};

public:
	bool readtest()
	{
		// ߂ɓǂł݂eXgB
		// UTF8 ƂĐȂ trueB
		// Â܂܂ƁApp݂̂̃t@C
		// UTF8N ƂĔFĂ܂ -> łH
		const UCHAR *p = _base;
		for( size_t i=0; i<_size-4; )
		{
			if( (*p&0x80)==0x00 ){ p++; i++; continue; }
			else if( (*p&0xE0)==0xC0 && ((*(p+1))&0xC0)==0x80 )
			{ p+=2; i+=2; continue; }
            else if( (*p&0xF0)==0xE0 && ((*(p+1))&0xC0)==0x80 
                     && ((*(p+2))&0xC0)==0x80 )
			{ p+=3; i+=3; continue; }
			else if( (*p&0xF8)==0xF0 && ((*(p+1))&0xC0)==0x80 
				&& ((*(p+2))&0xC0)==0x80 && ((*(p+3))&0xC0)==0x80 )
			{ p+=4; i+=4; continue; }
			else return false;
		}
		return true;
	}

private:
	virtual void UtfToWideChar( const UCHAR *up, 
		wchar_t *tp, int length )
	{
		const UCHAR *p = up;
		int pos=0, tpos=0;
		wchar_t a=_T('');

		if( length==0 ){
			tp[0]=_T('\0');
			return;
		}

		while(1)
		{
			if((p[pos] & 0x80) == 0x00){
				// UTF-16               UTF-8
				// 00000000-0xxxxxxx -> 0xxxxxxx 
				tp[tpos] = p[pos];
				pos++; tpos++;
			}else if((p[pos] >> 5)==0x06 && (p[pos+1] >> 6)==0x02){
				// UTF-16               UTF-8
				// 00000xxx-xxyyyyyy -> 110xxxxx 10yyyyyy
				tp[tpos] =  (p[pos]   & 0x1F) << 6;
				tp[tpos] += (p[pos+1] & 0x3F);
				pos += 2; tpos++;
			}else{
				// UTF-16               UTF-8
				// xxxxyyyy-yyzzzzzz -> 1110xxxx 10yyyyyy 10zzzzzz 
				tp[tpos] =  (p[pos+2] & 0x3F);  //z?
				tp[tpos] += (p[pos+1] & 0x3F) * 0x40; //y?
				tp[tpos] += (p[pos] & 0x0F) * 0x1000; //x?
				pos += 3; tpos++;
			}
				// 11110www 10xxxxxx 10yyyyyy 10zzzzzz 
				//                   -> wwwxx xxxxyyyy-yyzzzzzz

			if( pos >= length) break;
		}
		tp[tpos]=_T('\0');
	}

	virtual ULONG WideCharToUtf(const USHORT *in,
		UCHAR *out)
	{
		ULONG pos=0, tpos=0;
		while(in[tpos]!=0x00){
			if(in[tpos] >= 0x00 && in[tpos] <= 0x7F){
				// UTF-16               UTF-8
				// 00000000-0xxxxxxx -> 0xxxxxxx
				out[pos] = (UCHAR)in[tpos];
				pos++; tpos++;

			}else if(in[tpos] >= 0x80 && in[tpos] <= 0x7FF){
				// UTF-16               UTF-8
				// 00000xxx-xxyyyyyy -> 110xxxxx 10yyyyyy
				out[pos+1] = (UCHAR)( in[tpos] &  0x3F)       + 0x80;
				out[pos]   = (UCHAR)((in[tpos] & 0x7C0) >> 6) + 0xC0;
				pos+=2; tpos++;

			}else{
				// UTF-16               UTF-8
				// xxxxyyyy-yyzzzzzz -> 1110xxxx 10yyyyyy 10zzzzzz 
				out[pos+2] = (UCHAR)( in[tpos] &   0x3F)        + 0x80;
				out[pos+1] = (UCHAR)((in[tpos] &  0xFC0) >> 6)  + 0x80;
				out[pos]   = (UCHAR)((in[tpos] & 0xF000) >> 12) + 0xE0;
				pos+=3; tpos++;
			}

		}
		return pos;
	}
};


} //namespace uelib
#endif

