
#ifndef _UELIB_TXT4_H_
#define _UELIB_TXT4_H_

#include "stdafx.h"
#include "txt.h"
#include "util.h"

// txt4.h
//  UTF16, UTF32 ɂĂ
//  ̓IȓǂݏB

namespace uelib{


class Utf16Txt : public Txt
{
public:
	Utf16Txt(const UCHAR* b, const ULONG s,
             bool bom=false, bool endian=0)
		:Txt(b, s), _bom(bom), _endian(endian)
	{ checkLB(); }

	String readLine()
	{
		if( _pos==0 && _bom ) _pos = 2;

        // EOF ܂ŗ _state  0 ɂ邱
		const USHORT *p = reinterpret_cast<const USHORT*>(&_base[_pos]);
        const USHORT *pp= NULL;
		size_t start = _pos, length=0;
		while(1)
		{
			if( *p==0x000A || *p==0x0A00 ||
				*p==0x000D || *p==0x0D00)
			{
				_state = 2;
				break;
			}
			else if( _pos>=_size ){
				_state = 0;
				break;
			}
			pp=CharNextW( p );
			_pos += (pp - p)*sizeof(wchar_t);
			length += pp - p;
			p = pp;
		}

		wchar_t *sp = new wchar_t [length+1];
		wcsncpy(sp, (const wchar_t*)&_base[start], length);
		sp[length] = L'\0';
		if( _endian==0 )
		{   //BE Ȃ endian ]
			for(size_t i=0; i<length; i++)
			{
				USHORT s = sp[i];
				s = (UCHAR)(s >> 8); s += ((sp[i] & 0xff) << 8);
				sp[i] = s;
			}
		}
		if( length>=1 )
			if( sp[length-1]==L'\r' ) sp[length-1] = L'\0';
/*
		// ݈ʒu炵
		if( _lb==CRLF )
			_pos += 4;
		else
			_pos += 2;
*/
		// ɈقȂsR[hĂĂ
		// ȂƂǂ߂悤
		_pos += 2;
		if( (*p==0x000D || *p==0x0D00) && 
			(*(p+1)==0x000A || *(p+1)==0x0A00) ) _pos+=2;

		String x = sp;
		delete [] sp;
		return x;
    }

	void writeLine(FileW& fp, const String& s)
	{
		if( _endian==0 )
		{   // Big Endian
			wstring ws = s.w_str();
			size_t size = ws.size();
			wchar_t *t = new wchar_t[ size+1 ];
			wcscpy( t, ws.c_str() );
			wchar_t *tp = t;
			for(UINT i=0; i<size; i++)
			{
				USHORT s = *tp;
				s = (UCHAR)(s >> 8); s += ((*tp & 0xff) << 8);
				fp.write( &s, sizeof(wchar_t) );
				tp++;
			}
			delete [] t;
		}
		else
		{   // Little Endian
			// LE Ȃ炻̂܂܂ł̂EE
			wstring ws = s.w_str();
			fp.write( ws.c_str(), (ULONG)ws.size()*sizeof(wchar_t) );
		}
    }

	void writeBOM(FileW& fp)
	{
		// BOM tOĂȂΏo͂Ȃ
		if( !_bom ) return;

		if( _endian==0 )
		{
			const UCHAR p[2] = {0xfe, 0xff};
			fp.write( (const void*)p, 2);
        }
        else
        {
			const UCHAR p[2] = {0xff, 0xfe};
			fp.write( (const void*)p, 2);
        }
	}

	virtual void writeLB(FileW& fp, int lb)
	{
		const int lblen[] = { 2, 2, 4 };
		// CR, LF, CRLF
		if( _endian == 0 )
		{ //BE
			const USHORT lbstr[]={0x0D00, 0x0A00, 0x0D00, 0x0A00};
			fp.write( &lbstr[lb-1], lblen[lb-1] );
		}
		else
		{ //LE
			const USHORT lbstr[]={0x000D, 0x000A, 0x000D, 0x000A};
			fp.write( &lbstr[lb-1], lblen[lb-1] );
		}
	}

protected:
	//@{ sR[h //@}
	virtual void checkLB()
	{
		UINT i=0;
		const USHORT *p=reinterpret_cast<const USHORT*>(_base);
		while( i < _size )
		{
			if( i >= _lbCheckLimit ) break;
			if( p[i]==0x000D || p[i]==0x0D00 ){
				if( p[i+1]==0x000A || p[i+1]==0x0A00 )
					_lb = CRLF;
				else 
					_lb = CR;

				break;
			}
			if( p[i]==0x000A || p[i]==0x0A00 ){
				_lb = LF; break;
			}
			i++;
		}
	}

private:
	bool _bom;
	int  _endian; //0:BE, 1:LE
};



class Utf32Txt : public Txt
{
public:
	Utf32Txt(const UCHAR* b, const ULONG s,
             bool bom=false, bool endian=0)
		:Txt(b, s), _bom(bom), _endian(endian)
	{ checkLB(); }

	String readLine()
	{
		if( _pos==0 && _bom ) _pos = 4;

        // EOF ܂ŗ _state  0 ɂ邱
		const UINT *p = reinterpret_cast<const UINT*>(&_base[_pos]);
		const UINT *pp= p;
		size_t start = _pos, length=0;
		while(1)
		{
			if( *pp==0x0000000A || *pp==0x0A000000 ||
				*pp==0x0000000D || *pp==0x0D000000)
			{
				_state = 2;
				break;
			}
			else if( _pos>=_size ){
				_state = 0;
				break;
			}
			_pos += 4;
			length++;
			pp++;
		}

		// s܂ł̒肵obt@mۂăRs[
		wchar_t *sp = new wchar_t [length+1];
		utf32ToUnicode( p, sp, length );

		// ɈقȂsR[hĂĂ
		// ȂƂǂ߂悤
		_pos += 4;
		if( (*pp==0x0000000D || *pp==0x0D000000) && 
			(*(pp+1)==0x0000000A || *(pp+1)==0x0A000000) ) _pos+=4;

		String x = sp;
		delete [] sp;
		return x;
	}

	void writeLine(FileW& fp, const String& s)
	{
		size_t size = s.size();
		for( size_t i=0; i<size; i++ )
		{
			UINT n = _endian==0 ? 
				changeEndian(s[i]) : (UINT)s[i];
			fp.write( &n, sizeof(UINT) );
		}
    }

	void writeBOM(FileW& fp)
	{
		// BOM tOĂȂΏo͂Ȃ
		if( !_bom ) return;

		if( _endian==0 )
		{
			const UCHAR p[4] = {0x00, 0x00, 0xfe, 0xff};
			fp.write( (const void*)p, 4);
        }
        else
        {
			const UCHAR p[4] = {0xff, 0xfe, 0x00, 0x00};
			fp.write( (const void*)p, 4);
        }
	}

	virtual void writeLB(FileW& fp, int lb)
	{
		const int lblen[] = { 4, 4, 8 };
		// CR, LF, CRLF
		if( _endian == 0 )
		{ //BE
			const UINT lbstr[]={0x0D000000, 0x0A000000, 
								0x0D000000, 0x0A000000};
			fp.write( &lbstr[lb-1], lblen[lb-1] );
		}
		else
		{ //LE
			const UINT lbstr[]={0x0000000D, 0x0000000A, 
								0x0000000D, 0x0000000A};
			fp.write( &lbstr[lb-1], lblen[lb-1] );
		}
	}

protected:
	//@{ sR[h //@}
	virtual void checkLB()
	{
		UINT i=0;
		const UINT *p=reinterpret_cast<const UINT*>(_base);
		while( i < _size )
		{
			if( i >= _lbCheckLimit ) break;
			if( p[i]==0x0000000D || p[i]==0x0D000000 ){
				if( p[i+1]==0x0000000A || p[i+1]==0x0A000000 )
					_lb = CRLF;
				else 
					_lb = CR;

				break;
			}
			if( p[i]==0x0000000A || p[i]==0x0A000000 ){
				_lb = LF; break;
			}
			i++;
		}
	}

private:
	void utf32ToUnicode( const UINT* p, wchar_t* sp, size_t length )
	{
		for( size_t i=0; i<length; i++ )
		{
			*sp++ = _endian==0 ? 
				(wchar_t)changeEndian(*p++) : (wchar_t)*p++;
		}
		*sp = L'\0';
	}

	const UINT changeEndian(const UINT n)
	{
		// GfBA̔]B
		UINT i;
		const UCHAR* p  = reinterpret_cast<const UCHAR*>(&n);
		UCHAR*       pp = reinterpret_cast<UCHAR*>(&i);
		pp[3] = p[0], pp[0] = p[3], pp[2] = p[1], pp[1] = p[2];
		return i;
	}

private:
	bool _bom;
	int  _endian; //0:BE, 1:LE
};


} //namespace uelib
#endif

